{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postTestHelpersTreasuryReceivedCredits
module StripeAPI.Operations.PostTestHelpersTreasuryReceivedCredits where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/test_helpers/treasury/received_credits
--
-- \<p>Use this endpoint to simulate a test mode ReceivedCredit initiated by a third party. In live mode, you can’t directly create ReceivedCredits initiated by third parties.\<\/p>
postTestHelpersTreasuryReceivedCredits ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | The request body to send
  PostTestHelpersTreasuryReceivedCreditsRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response PostTestHelpersTreasuryReceivedCreditsResponse)
postTestHelpersTreasuryReceivedCredits body =
  GHC.Base.fmap
    ( \response_0 ->
        GHC.Base.fmap
          ( Data.Either.either PostTestHelpersTreasuryReceivedCreditsResponseError GHC.Base.id
              GHC.Base.. ( \response body ->
                             if
                                 | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                   PostTestHelpersTreasuryReceivedCreditsResponse200
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Treasury'receivedCredit
                                                      )
                                 | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                   PostTestHelpersTreasuryReceivedCreditsResponseDefault
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Error
                                                      )
                                 | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                         )
                response_0
          )
          response_0
    )
    (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack "/v1/test_helpers/treasury/received_credits") GHC.Base.mempty (GHC.Maybe.Just body) StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/test_helpers\/treasury\/received_credits.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostTestHelpersTreasuryReceivedCreditsRequestBody = PostTestHelpersTreasuryReceivedCreditsRequestBody
  { -- | amount: Amount (in cents) to be transferred.
    postTestHelpersTreasuryReceivedCreditsRequestBodyAmount :: GHC.Types.Int,
    -- | currency: Three-letter [ISO currency code](https:\/\/www.iso.org\/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https:\/\/stripe.com\/docs\/currencies).
    postTestHelpersTreasuryReceivedCreditsRequestBodyCurrency :: Data.Text.Internal.Text,
    -- | description: An arbitrary string attached to the object. Often useful for displaying to users.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postTestHelpersTreasuryReceivedCreditsRequestBodyDescription :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | expand: Specifies which fields in the response should be expanded.
    postTestHelpersTreasuryReceivedCreditsRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | financial_account: The FinancialAccount to send funds to.
    postTestHelpersTreasuryReceivedCreditsRequestBodyFinancialAccount :: Data.Text.Internal.Text,
    -- | initiating_payment_method_details: Initiating payment method details for the object.
    postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails :: (GHC.Maybe.Maybe PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'),
    -- | network: The rails used for the object.
    postTestHelpersTreasuryReceivedCreditsRequestBodyNetwork :: PostTestHelpersTreasuryReceivedCreditsRequestBodyNetwork'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTestHelpersTreasuryReceivedCreditsRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= postTestHelpersTreasuryReceivedCreditsRequestBodyAmount obj] : ["currency" Data.Aeson.Types.ToJSON..= postTestHelpersTreasuryReceivedCreditsRequestBodyCurrency obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("description" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryReceivedCreditsRequestBodyDescription obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryReceivedCreditsRequestBodyExpand obj) : ["financial_account" Data.Aeson.Types.ToJSON..= postTestHelpersTreasuryReceivedCreditsRequestBodyFinancialAccount obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("initiating_payment_method_details" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails obj) : ["network" Data.Aeson.Types.ToJSON..= postTestHelpersTreasuryReceivedCreditsRequestBodyNetwork obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= postTestHelpersTreasuryReceivedCreditsRequestBodyAmount obj] : ["currency" Data.Aeson.Types.ToJSON..= postTestHelpersTreasuryReceivedCreditsRequestBodyCurrency obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("description" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryReceivedCreditsRequestBodyDescription obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryReceivedCreditsRequestBodyExpand obj) : ["financial_account" Data.Aeson.Types.ToJSON..= postTestHelpersTreasuryReceivedCreditsRequestBodyFinancialAccount obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("initiating_payment_method_details" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails obj) : ["network" Data.Aeson.Types.ToJSON..= postTestHelpersTreasuryReceivedCreditsRequestBodyNetwork obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTestHelpersTreasuryReceivedCreditsRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTestHelpersTreasuryReceivedCreditsRequestBody" (\obj -> ((((((GHC.Base.pure PostTestHelpersTreasuryReceivedCreditsRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "currency")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "description")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "financial_account")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "initiating_payment_method_details")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "network"))

-- | Create a new 'PostTestHelpersTreasuryReceivedCreditsRequestBody' with all required fields.
mkPostTestHelpersTreasuryReceivedCreditsRequestBody ::
  -- | 'postTestHelpersTreasuryReceivedCreditsRequestBodyAmount'
  GHC.Types.Int ->
  -- | 'postTestHelpersTreasuryReceivedCreditsRequestBodyCurrency'
  Data.Text.Internal.Text ->
  -- | 'postTestHelpersTreasuryReceivedCreditsRequestBodyFinancialAccount'
  Data.Text.Internal.Text ->
  -- | 'postTestHelpersTreasuryReceivedCreditsRequestBodyNetwork'
  PostTestHelpersTreasuryReceivedCreditsRequestBodyNetwork' ->
  PostTestHelpersTreasuryReceivedCreditsRequestBody
mkPostTestHelpersTreasuryReceivedCreditsRequestBody postTestHelpersTreasuryReceivedCreditsRequestBodyAmount postTestHelpersTreasuryReceivedCreditsRequestBodyCurrency postTestHelpersTreasuryReceivedCreditsRequestBodyFinancialAccount postTestHelpersTreasuryReceivedCreditsRequestBodyNetwork =
  PostTestHelpersTreasuryReceivedCreditsRequestBody
    { postTestHelpersTreasuryReceivedCreditsRequestBodyAmount = postTestHelpersTreasuryReceivedCreditsRequestBodyAmount,
      postTestHelpersTreasuryReceivedCreditsRequestBodyCurrency = postTestHelpersTreasuryReceivedCreditsRequestBodyCurrency,
      postTestHelpersTreasuryReceivedCreditsRequestBodyDescription = GHC.Maybe.Nothing,
      postTestHelpersTreasuryReceivedCreditsRequestBodyExpand = GHC.Maybe.Nothing,
      postTestHelpersTreasuryReceivedCreditsRequestBodyFinancialAccount = postTestHelpersTreasuryReceivedCreditsRequestBodyFinancialAccount,
      postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails = GHC.Maybe.Nothing,
      postTestHelpersTreasuryReceivedCreditsRequestBodyNetwork = postTestHelpersTreasuryReceivedCreditsRequestBodyNetwork
    }

-- | Defines the object schema located at @paths.\/v1\/test_helpers\/treasury\/received_credits.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.initiating_payment_method_details@ in the specification.
--
-- Initiating payment method details for the object.
data PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails' = PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'
  { -- | us_bank_account
    postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount :: (GHC.Maybe.Maybe PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("us_bank_account" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount obj) : ["type" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "us_bank_account"] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("us_bank_account" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount obj) : ["type" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "us_bank_account"] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'" (\obj -> GHC.Base.pure PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "us_bank_account"))

-- | Create a new 'PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'' with all required fields.
mkPostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails' :: PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'
mkPostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails' = PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails' {postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount = GHC.Maybe.Nothing}

-- | Defines the object schema located at @paths.\/v1\/test_helpers\/treasury\/received_credits.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.initiating_payment_method_details.properties.us_bank_account@ in the specification.
data PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount' = PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'
  { -- | account_holder_name
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'AccountHolderName :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | account_number
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'AccountNumber :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | routing_number
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'RoutingNumber :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("account_holder_name" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'AccountHolderName obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("account_number" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'AccountNumber obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("routing_number" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'RoutingNumber obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("account_holder_name" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'AccountHolderName obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("account_number" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'AccountNumber obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("routing_number" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'RoutingNumber obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'" (\obj -> ((GHC.Base.pure PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "account_holder_name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "account_number")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "routing_number"))

-- | Create a new 'PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'' with all required fields.
mkPostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount' :: PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'
mkPostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount' =
  PostTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'
    { postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'AccountHolderName = GHC.Maybe.Nothing,
      postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'AccountNumber = GHC.Maybe.Nothing,
      postTestHelpersTreasuryReceivedCreditsRequestBodyInitiatingPaymentMethodDetails'UsBankAccount'RoutingNumber = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/test_helpers\/treasury\/received_credits.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.network@ in the specification.
--
-- The rails used for the object.
data PostTestHelpersTreasuryReceivedCreditsRequestBodyNetwork'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostTestHelpersTreasuryReceivedCreditsRequestBodyNetwork'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostTestHelpersTreasuryReceivedCreditsRequestBodyNetwork'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ach"@
    PostTestHelpersTreasuryReceivedCreditsRequestBodyNetwork'EnumAch
  | -- | Represents the JSON value @"us_domestic_wire"@
    PostTestHelpersTreasuryReceivedCreditsRequestBodyNetwork'EnumUsDomesticWire
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostTestHelpersTreasuryReceivedCreditsRequestBodyNetwork' where
  toJSON (PostTestHelpersTreasuryReceivedCreditsRequestBodyNetwork'Other val) = val
  toJSON (PostTestHelpersTreasuryReceivedCreditsRequestBodyNetwork'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostTestHelpersTreasuryReceivedCreditsRequestBodyNetwork'EnumAch) = "ach"
  toJSON (PostTestHelpersTreasuryReceivedCreditsRequestBodyNetwork'EnumUsDomesticWire) = "us_domestic_wire"

instance Data.Aeson.Types.FromJSON.FromJSON PostTestHelpersTreasuryReceivedCreditsRequestBodyNetwork' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ach" -> PostTestHelpersTreasuryReceivedCreditsRequestBodyNetwork'EnumAch
            | val GHC.Classes.== "us_domestic_wire" -> PostTestHelpersTreasuryReceivedCreditsRequestBodyNetwork'EnumUsDomesticWire
            | GHC.Base.otherwise -> PostTestHelpersTreasuryReceivedCreditsRequestBodyNetwork'Other val
      )

-- | Represents a response of the operation 'postTestHelpersTreasuryReceivedCredits'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostTestHelpersTreasuryReceivedCreditsResponseError' is used.
data PostTestHelpersTreasuryReceivedCreditsResponse
  = -- | Means either no matching case available or a parse error
    PostTestHelpersTreasuryReceivedCreditsResponseError GHC.Base.String
  | -- | Successful response.
    PostTestHelpersTreasuryReceivedCreditsResponse200 Treasury'receivedCredit
  | -- | Error response.
    PostTestHelpersTreasuryReceivedCreditsResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
