{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema AccountServiceResourceFinancialAddress
module StripeAPI.Types.AccountServiceResourceFinancialAddress where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.AccountServiceResourceAbaRecord
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.account_service_resource_financial_address@ in the specification.
--
-- FinancialAddresses contain identifying information that resolves to a FinancialAccount.
data AccountServiceResourceFinancialAddress = AccountServiceResourceFinancialAddress
  { -- | aba: ABA Records contain U.S. bank account details per the ABA format.
    accountServiceResourceFinancialAddressAba :: (GHC.Maybe.Maybe AccountServiceResourceAbaRecord),
    -- | supported_networks: The list of networks that the address supports
    accountServiceResourceFinancialAddressSupportedNetworks :: (GHC.Maybe.Maybe ([AccountServiceResourceFinancialAddressSupportedNetworks']))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON AccountServiceResourceFinancialAddress where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("aba" Data.Aeson.Types.ToJSON..=)) (accountServiceResourceFinancialAddressAba obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("supported_networks" Data.Aeson.Types.ToJSON..=)) (accountServiceResourceFinancialAddressSupportedNetworks obj) : ["type" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "aba"] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("aba" Data.Aeson.Types.ToJSON..=)) (accountServiceResourceFinancialAddressAba obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("supported_networks" Data.Aeson.Types.ToJSON..=)) (accountServiceResourceFinancialAddressSupportedNetworks obj) : ["type" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "aba"] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON AccountServiceResourceFinancialAddress where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "AccountServiceResourceFinancialAddress" (\obj -> (GHC.Base.pure AccountServiceResourceFinancialAddress GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "aba")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "supported_networks"))

-- | Create a new 'AccountServiceResourceFinancialAddress' with all required fields.
mkAccountServiceResourceFinancialAddress :: AccountServiceResourceFinancialAddress
mkAccountServiceResourceFinancialAddress =
  AccountServiceResourceFinancialAddress
    { accountServiceResourceFinancialAddressAba = GHC.Maybe.Nothing,
      accountServiceResourceFinancialAddressSupportedNetworks = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.account_service_resource_financial_address.properties.supported_networks.items@ in the specification.
data AccountServiceResourceFinancialAddressSupportedNetworks'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    AccountServiceResourceFinancialAddressSupportedNetworks'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    AccountServiceResourceFinancialAddressSupportedNetworks'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ach"@
    AccountServiceResourceFinancialAddressSupportedNetworks'EnumAch
  | -- | Represents the JSON value @"us_domestic_wire"@
    AccountServiceResourceFinancialAddressSupportedNetworks'EnumUsDomesticWire
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON AccountServiceResourceFinancialAddressSupportedNetworks' where
  toJSON (AccountServiceResourceFinancialAddressSupportedNetworks'Other val) = val
  toJSON (AccountServiceResourceFinancialAddressSupportedNetworks'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (AccountServiceResourceFinancialAddressSupportedNetworks'EnumAch) = "ach"
  toJSON (AccountServiceResourceFinancialAddressSupportedNetworks'EnumUsDomesticWire) = "us_domestic_wire"

instance Data.Aeson.Types.FromJSON.FromJSON AccountServiceResourceFinancialAddressSupportedNetworks' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ach" -> AccountServiceResourceFinancialAddressSupportedNetworks'EnumAch
            | val GHC.Classes.== "us_domestic_wire" -> AccountServiceResourceFinancialAddressSupportedNetworks'EnumUsDomesticWire
            | GHC.Base.otherwise -> AccountServiceResourceFinancialAddressSupportedNetworks'Other val
      )
