{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema AccountServiceResourcePlatformRestrictions
module StripeAPI.Types.AccountServiceResourcePlatformRestrictions where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.account_service_resource_platform_restrictions@ in the specification.
--
-- Restrictions that a Connect Platform has placed on this FinancialAccount.
data AccountServiceResourcePlatformRestrictions = AccountServiceResourcePlatformRestrictions
  { -- | inbound_flows: Restricts all inbound money movement.
    accountServiceResourcePlatformRestrictionsInboundFlows :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable AccountServiceResourcePlatformRestrictionsInboundFlows'NonNullable)),
    -- | outbound_flows: Restricts all outbound money movement.
    accountServiceResourcePlatformRestrictionsOutboundFlows :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable AccountServiceResourcePlatformRestrictionsOutboundFlows'NonNullable))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON AccountServiceResourcePlatformRestrictions where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("inbound_flows" Data.Aeson.Types.ToJSON..=)) (accountServiceResourcePlatformRestrictionsInboundFlows obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("outbound_flows" Data.Aeson.Types.ToJSON..=)) (accountServiceResourcePlatformRestrictionsOutboundFlows obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("inbound_flows" Data.Aeson.Types.ToJSON..=)) (accountServiceResourcePlatformRestrictionsInboundFlows obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("outbound_flows" Data.Aeson.Types.ToJSON..=)) (accountServiceResourcePlatformRestrictionsOutboundFlows obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON AccountServiceResourcePlatformRestrictions where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "AccountServiceResourcePlatformRestrictions" (\obj -> (GHC.Base.pure AccountServiceResourcePlatformRestrictions GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "inbound_flows")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "outbound_flows"))

-- | Create a new 'AccountServiceResourcePlatformRestrictions' with all required fields.
mkAccountServiceResourcePlatformRestrictions :: AccountServiceResourcePlatformRestrictions
mkAccountServiceResourcePlatformRestrictions =
  AccountServiceResourcePlatformRestrictions
    { accountServiceResourcePlatformRestrictionsInboundFlows = GHC.Maybe.Nothing,
      accountServiceResourcePlatformRestrictionsOutboundFlows = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.account_service_resource_platform_restrictions.properties.inbound_flows@ in the specification.
--
-- Restricts all inbound money movement.
data AccountServiceResourcePlatformRestrictionsInboundFlows'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    AccountServiceResourcePlatformRestrictionsInboundFlows'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    AccountServiceResourcePlatformRestrictionsInboundFlows'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"restricted"@
    AccountServiceResourcePlatformRestrictionsInboundFlows'NonNullableEnumRestricted
  | -- | Represents the JSON value @"unrestricted"@
    AccountServiceResourcePlatformRestrictionsInboundFlows'NonNullableEnumUnrestricted
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON AccountServiceResourcePlatformRestrictionsInboundFlows'NonNullable where
  toJSON (AccountServiceResourcePlatformRestrictionsInboundFlows'NonNullableOther val) = val
  toJSON (AccountServiceResourcePlatformRestrictionsInboundFlows'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (AccountServiceResourcePlatformRestrictionsInboundFlows'NonNullableEnumRestricted) = "restricted"
  toJSON (AccountServiceResourcePlatformRestrictionsInboundFlows'NonNullableEnumUnrestricted) = "unrestricted"

instance Data.Aeson.Types.FromJSON.FromJSON AccountServiceResourcePlatformRestrictionsInboundFlows'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "restricted" -> AccountServiceResourcePlatformRestrictionsInboundFlows'NonNullableEnumRestricted
            | val GHC.Classes.== "unrestricted" -> AccountServiceResourcePlatformRestrictionsInboundFlows'NonNullableEnumUnrestricted
            | GHC.Base.otherwise -> AccountServiceResourcePlatformRestrictionsInboundFlows'NonNullableOther val
      )

-- | Defines the enum schema located at @components.schemas.account_service_resource_platform_restrictions.properties.outbound_flows@ in the specification.
--
-- Restricts all outbound money movement.
data AccountServiceResourcePlatformRestrictionsOutboundFlows'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    AccountServiceResourcePlatformRestrictionsOutboundFlows'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    AccountServiceResourcePlatformRestrictionsOutboundFlows'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"restricted"@
    AccountServiceResourcePlatformRestrictionsOutboundFlows'NonNullableEnumRestricted
  | -- | Represents the JSON value @"unrestricted"@
    AccountServiceResourcePlatformRestrictionsOutboundFlows'NonNullableEnumUnrestricted
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON AccountServiceResourcePlatformRestrictionsOutboundFlows'NonNullable where
  toJSON (AccountServiceResourcePlatformRestrictionsOutboundFlows'NonNullableOther val) = val
  toJSON (AccountServiceResourcePlatformRestrictionsOutboundFlows'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (AccountServiceResourcePlatformRestrictionsOutboundFlows'NonNullableEnumRestricted) = "restricted"
  toJSON (AccountServiceResourcePlatformRestrictionsOutboundFlows'NonNullableEnumUnrestricted) = "unrestricted"

instance Data.Aeson.Types.FromJSON.FromJSON AccountServiceResourcePlatformRestrictionsOutboundFlows'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "restricted" -> AccountServiceResourcePlatformRestrictionsOutboundFlows'NonNullableEnumRestricted
            | val GHC.Classes.== "unrestricted" -> AccountServiceResourcePlatformRestrictionsOutboundFlows'NonNullableEnumUnrestricted
            | GHC.Base.otherwise -> AccountServiceResourcePlatformRestrictionsOutboundFlows'NonNullableOther val
      )
