{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema AccountServiceResourceToggleSettings
module StripeAPI.Types.AccountServiceResourceToggleSettings where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.AccountServiceResourceStatusDetails
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.account_service_resource_toggle_settings@ in the specification.
--
-- Toggle settings for enabling\/disabling a feature
data AccountServiceResourceToggleSettings = AccountServiceResourceToggleSettings
  { -- | requested: Whether the FinancialAccount should have the Feature.
    accountServiceResourceToggleSettingsRequested :: GHC.Types.Bool,
    -- | status: Whether the Feature is operational.
    accountServiceResourceToggleSettingsStatus :: AccountServiceResourceToggleSettingsStatus',
    -- | status_details: Additional details; includes at least one entry when the status is not \`active\`.
    accountServiceResourceToggleSettingsStatusDetails :: ([AccountServiceResourceStatusDetails])
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON AccountServiceResourceToggleSettings where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["requested" Data.Aeson.Types.ToJSON..= accountServiceResourceToggleSettingsRequested obj] : ["status" Data.Aeson.Types.ToJSON..= accountServiceResourceToggleSettingsStatus obj] : ["status_details" Data.Aeson.Types.ToJSON..= accountServiceResourceToggleSettingsStatusDetails obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["requested" Data.Aeson.Types.ToJSON..= accountServiceResourceToggleSettingsRequested obj] : ["status" Data.Aeson.Types.ToJSON..= accountServiceResourceToggleSettingsStatus obj] : ["status_details" Data.Aeson.Types.ToJSON..= accountServiceResourceToggleSettingsStatusDetails obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON AccountServiceResourceToggleSettings where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "AccountServiceResourceToggleSettings" (\obj -> ((GHC.Base.pure AccountServiceResourceToggleSettings GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "requested")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "status")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "status_details"))

-- | Create a new 'AccountServiceResourceToggleSettings' with all required fields.
mkAccountServiceResourceToggleSettings ::
  -- | 'accountServiceResourceToggleSettingsRequested'
  GHC.Types.Bool ->
  -- | 'accountServiceResourceToggleSettingsStatus'
  AccountServiceResourceToggleSettingsStatus' ->
  -- | 'accountServiceResourceToggleSettingsStatusDetails'
  [AccountServiceResourceStatusDetails] ->
  AccountServiceResourceToggleSettings
mkAccountServiceResourceToggleSettings accountServiceResourceToggleSettingsRequested accountServiceResourceToggleSettingsStatus accountServiceResourceToggleSettingsStatusDetails =
  AccountServiceResourceToggleSettings
    { accountServiceResourceToggleSettingsRequested = accountServiceResourceToggleSettingsRequested,
      accountServiceResourceToggleSettingsStatus = accountServiceResourceToggleSettingsStatus,
      accountServiceResourceToggleSettingsStatusDetails = accountServiceResourceToggleSettingsStatusDetails
    }

-- | Defines the enum schema located at @components.schemas.account_service_resource_toggle_settings.properties.status@ in the specification.
--
-- Whether the Feature is operational.
data AccountServiceResourceToggleSettingsStatus'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    AccountServiceResourceToggleSettingsStatus'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    AccountServiceResourceToggleSettingsStatus'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"active"@
    AccountServiceResourceToggleSettingsStatus'EnumActive
  | -- | Represents the JSON value @"pending"@
    AccountServiceResourceToggleSettingsStatus'EnumPending
  | -- | Represents the JSON value @"restricted"@
    AccountServiceResourceToggleSettingsStatus'EnumRestricted
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON AccountServiceResourceToggleSettingsStatus' where
  toJSON (AccountServiceResourceToggleSettingsStatus'Other val) = val
  toJSON (AccountServiceResourceToggleSettingsStatus'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (AccountServiceResourceToggleSettingsStatus'EnumActive) = "active"
  toJSON (AccountServiceResourceToggleSettingsStatus'EnumPending) = "pending"
  toJSON (AccountServiceResourceToggleSettingsStatus'EnumRestricted) = "restricted"

instance Data.Aeson.Types.FromJSON.FromJSON AccountServiceResourceToggleSettingsStatus' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "active" -> AccountServiceResourceToggleSettingsStatus'EnumActive
            | val GHC.Classes.== "pending" -> AccountServiceResourceToggleSettingsStatus'EnumPending
            | val GHC.Classes.== "restricted" -> AccountServiceResourceToggleSettingsStatus'EnumRestricted
            | GHC.Base.otherwise -> AccountServiceResourceToggleSettingsStatus'Other val
      )
