{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema CheckoutUsBankAccountPaymentMethodOptions
module StripeAPI.Types.CheckoutUsBankAccountPaymentMethodOptions where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.LinkedAccountOptionsUsBankAccount
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.checkout_us_bank_account_payment_method_options@ in the specification.
data CheckoutUsBankAccountPaymentMethodOptions = CheckoutUsBankAccountPaymentMethodOptions
  { -- | financial_connections:
    checkoutUsBankAccountPaymentMethodOptionsFinancialConnections :: (GHC.Maybe.Maybe LinkedAccountOptionsUsBankAccount),
    -- | setup_future_usage: Indicates that you intend to make future payments with this PaymentIntent\'s payment method.
    --
    -- Providing this parameter will [attach the payment method](https:\/\/stripe.com\/docs\/payments\/save-during-payment) to the PaymentIntent\'s Customer, if present, after the PaymentIntent is confirmed and any required actions from the user are complete. If no Customer was provided, the payment method can still be [attached](https:\/\/stripe.com\/docs\/api\/payment_methods\/attach) to a Customer after the transaction completes.
    --
    -- When processing card payments, Stripe also uses \`setup_future_usage\` to dynamically optimize your payment flow and comply with regional legislation and network rules, such as [SCA](https:\/\/stripe.com\/docs\/strong-customer-authentication).
    checkoutUsBankAccountPaymentMethodOptionsSetupFutureUsage :: (GHC.Maybe.Maybe CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage'),
    -- | verification_method: Bank account verification method.
    checkoutUsBankAccountPaymentMethodOptionsVerificationMethod :: (GHC.Maybe.Maybe CheckoutUsBankAccountPaymentMethodOptionsVerificationMethod')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON CheckoutUsBankAccountPaymentMethodOptions where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("financial_connections" Data.Aeson.Types.ToJSON..=)) (checkoutUsBankAccountPaymentMethodOptionsFinancialConnections obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (checkoutUsBankAccountPaymentMethodOptionsSetupFutureUsage obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verification_method" Data.Aeson.Types.ToJSON..=)) (checkoutUsBankAccountPaymentMethodOptionsVerificationMethod obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("financial_connections" Data.Aeson.Types.ToJSON..=)) (checkoutUsBankAccountPaymentMethodOptionsFinancialConnections obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (checkoutUsBankAccountPaymentMethodOptionsSetupFutureUsage obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verification_method" Data.Aeson.Types.ToJSON..=)) (checkoutUsBankAccountPaymentMethodOptionsVerificationMethod obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON CheckoutUsBankAccountPaymentMethodOptions where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "CheckoutUsBankAccountPaymentMethodOptions" (\obj -> ((GHC.Base.pure CheckoutUsBankAccountPaymentMethodOptions GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "financial_connections")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "verification_method"))

-- | Create a new 'CheckoutUsBankAccountPaymentMethodOptions' with all required fields.
mkCheckoutUsBankAccountPaymentMethodOptions :: CheckoutUsBankAccountPaymentMethodOptions
mkCheckoutUsBankAccountPaymentMethodOptions =
  CheckoutUsBankAccountPaymentMethodOptions
    { checkoutUsBankAccountPaymentMethodOptionsFinancialConnections = GHC.Maybe.Nothing,
      checkoutUsBankAccountPaymentMethodOptionsSetupFutureUsage = GHC.Maybe.Nothing,
      checkoutUsBankAccountPaymentMethodOptionsVerificationMethod = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.checkout_us_bank_account_payment_method_options.properties.setup_future_usage@ in the specification.
--
-- Indicates that you intend to make future payments with this PaymentIntent\'s payment method.
--
-- Providing this parameter will [attach the payment method](https:\/\/stripe.com\/docs\/payments\/save-during-payment) to the PaymentIntent\'s Customer, if present, after the PaymentIntent is confirmed and any required actions from the user are complete. If no Customer was provided, the payment method can still be [attached](https:\/\/stripe.com\/docs\/api\/payment_methods\/attach) to a Customer after the transaction completes.
--
-- When processing card payments, Stripe also uses \`setup_future_usage\` to dynamically optimize your payment flow and comply with regional legislation and network rules, such as [SCA](https:\/\/stripe.com\/docs\/strong-customer-authentication).
data CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"none"@
    CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage'EnumNone
  | -- | Represents the JSON value @"off_session"@
    CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage'EnumOffSession
  | -- | Represents the JSON value @"on_session"@
    CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage'EnumOnSession
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage' where
  toJSON (CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage'Other val) = val
  toJSON (CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage'EnumNone) = "none"
  toJSON (CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage'EnumOffSession) = "off_session"
  toJSON (CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage'EnumOnSession) = "on_session"

instance Data.Aeson.Types.FromJSON.FromJSON CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "none" -> CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage'EnumNone
            | val GHC.Classes.== "off_session" -> CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage'EnumOffSession
            | val GHC.Classes.== "on_session" -> CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage'EnumOnSession
            | GHC.Base.otherwise -> CheckoutUsBankAccountPaymentMethodOptionsSetupFutureUsage'Other val
      )

-- | Defines the enum schema located at @components.schemas.checkout_us_bank_account_payment_method_options.properties.verification_method@ in the specification.
--
-- Bank account verification method.
data CheckoutUsBankAccountPaymentMethodOptionsVerificationMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    CheckoutUsBankAccountPaymentMethodOptionsVerificationMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    CheckoutUsBankAccountPaymentMethodOptionsVerificationMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"automatic"@
    CheckoutUsBankAccountPaymentMethodOptionsVerificationMethod'EnumAutomatic
  | -- | Represents the JSON value @"instant"@
    CheckoutUsBankAccountPaymentMethodOptionsVerificationMethod'EnumInstant
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON CheckoutUsBankAccountPaymentMethodOptionsVerificationMethod' where
  toJSON (CheckoutUsBankAccountPaymentMethodOptionsVerificationMethod'Other val) = val
  toJSON (CheckoutUsBankAccountPaymentMethodOptionsVerificationMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (CheckoutUsBankAccountPaymentMethodOptionsVerificationMethod'EnumAutomatic) = "automatic"
  toJSON (CheckoutUsBankAccountPaymentMethodOptionsVerificationMethod'EnumInstant) = "instant"

instance Data.Aeson.Types.FromJSON.FromJSON CheckoutUsBankAccountPaymentMethodOptionsVerificationMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "automatic" -> CheckoutUsBankAccountPaymentMethodOptionsVerificationMethod'EnumAutomatic
            | val GHC.Classes.== "instant" -> CheckoutUsBankAccountPaymentMethodOptionsVerificationMethod'EnumInstant
            | GHC.Base.otherwise -> CheckoutUsBankAccountPaymentMethodOptionsVerificationMethod'Other val
      )
