{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema GelatoSessionLastError
module StripeAPI.Types.GelatoSessionLastError where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.gelato_session_last_error@ in the specification.
--
-- Shows last VerificationSession error
data GelatoSessionLastError = GelatoSessionLastError
  { -- | code: A short machine-readable string giving the reason for the verification or user-session failure.
    gelatoSessionLastErrorCode :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable GelatoSessionLastErrorCode'NonNullable)),
    -- | reason: A message that explains the reason for verification or user-session failure.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    gelatoSessionLastErrorReason :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON GelatoSessionLastError where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("code" Data.Aeson.Types.ToJSON..=)) (gelatoSessionLastErrorCode obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("reason" Data.Aeson.Types.ToJSON..=)) (gelatoSessionLastErrorReason obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("code" Data.Aeson.Types.ToJSON..=)) (gelatoSessionLastErrorCode obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("reason" Data.Aeson.Types.ToJSON..=)) (gelatoSessionLastErrorReason obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON GelatoSessionLastError where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GelatoSessionLastError" (\obj -> (GHC.Base.pure GelatoSessionLastError GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "code")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "reason"))

-- | Create a new 'GelatoSessionLastError' with all required fields.
mkGelatoSessionLastError :: GelatoSessionLastError
mkGelatoSessionLastError =
  GelatoSessionLastError
    { gelatoSessionLastErrorCode = GHC.Maybe.Nothing,
      gelatoSessionLastErrorReason = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.gelato_session_last_error.properties.code@ in the specification.
--
-- A short machine-readable string giving the reason for the verification or user-session failure.
data GelatoSessionLastErrorCode'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    GelatoSessionLastErrorCode'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    GelatoSessionLastErrorCode'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"abandoned"@
    GelatoSessionLastErrorCode'NonNullableEnumAbandoned
  | -- | Represents the JSON value @"consent_declined"@
    GelatoSessionLastErrorCode'NonNullableEnumConsentDeclined
  | -- | Represents the JSON value @"country_not_supported"@
    GelatoSessionLastErrorCode'NonNullableEnumCountryNotSupported
  | -- | Represents the JSON value @"device_not_supported"@
    GelatoSessionLastErrorCode'NonNullableEnumDeviceNotSupported
  | -- | Represents the JSON value @"document_expired"@
    GelatoSessionLastErrorCode'NonNullableEnumDocumentExpired
  | -- | Represents the JSON value @"document_type_not_supported"@
    GelatoSessionLastErrorCode'NonNullableEnumDocumentTypeNotSupported
  | -- | Represents the JSON value @"document_unverified_other"@
    GelatoSessionLastErrorCode'NonNullableEnumDocumentUnverifiedOther
  | -- | Represents the JSON value @"id_number_insufficient_document_data"@
    GelatoSessionLastErrorCode'NonNullableEnumIdNumberInsufficientDocumentData
  | -- | Represents the JSON value @"id_number_mismatch"@
    GelatoSessionLastErrorCode'NonNullableEnumIdNumberMismatch
  | -- | Represents the JSON value @"id_number_unverified_other"@
    GelatoSessionLastErrorCode'NonNullableEnumIdNumberUnverifiedOther
  | -- | Represents the JSON value @"selfie_document_missing_photo"@
    GelatoSessionLastErrorCode'NonNullableEnumSelfieDocumentMissingPhoto
  | -- | Represents the JSON value @"selfie_face_mismatch"@
    GelatoSessionLastErrorCode'NonNullableEnumSelfieFaceMismatch
  | -- | Represents the JSON value @"selfie_manipulated"@
    GelatoSessionLastErrorCode'NonNullableEnumSelfieManipulated
  | -- | Represents the JSON value @"selfie_unverified_other"@
    GelatoSessionLastErrorCode'NonNullableEnumSelfieUnverifiedOther
  | -- | Represents the JSON value @"under_supported_age"@
    GelatoSessionLastErrorCode'NonNullableEnumUnderSupportedAge
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON GelatoSessionLastErrorCode'NonNullable where
  toJSON (GelatoSessionLastErrorCode'NonNullableOther val) = val
  toJSON (GelatoSessionLastErrorCode'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (GelatoSessionLastErrorCode'NonNullableEnumAbandoned) = "abandoned"
  toJSON (GelatoSessionLastErrorCode'NonNullableEnumConsentDeclined) = "consent_declined"
  toJSON (GelatoSessionLastErrorCode'NonNullableEnumCountryNotSupported) = "country_not_supported"
  toJSON (GelatoSessionLastErrorCode'NonNullableEnumDeviceNotSupported) = "device_not_supported"
  toJSON (GelatoSessionLastErrorCode'NonNullableEnumDocumentExpired) = "document_expired"
  toJSON (GelatoSessionLastErrorCode'NonNullableEnumDocumentTypeNotSupported) = "document_type_not_supported"
  toJSON (GelatoSessionLastErrorCode'NonNullableEnumDocumentUnverifiedOther) = "document_unverified_other"
  toJSON (GelatoSessionLastErrorCode'NonNullableEnumIdNumberInsufficientDocumentData) = "id_number_insufficient_document_data"
  toJSON (GelatoSessionLastErrorCode'NonNullableEnumIdNumberMismatch) = "id_number_mismatch"
  toJSON (GelatoSessionLastErrorCode'NonNullableEnumIdNumberUnverifiedOther) = "id_number_unverified_other"
  toJSON (GelatoSessionLastErrorCode'NonNullableEnumSelfieDocumentMissingPhoto) = "selfie_document_missing_photo"
  toJSON (GelatoSessionLastErrorCode'NonNullableEnumSelfieFaceMismatch) = "selfie_face_mismatch"
  toJSON (GelatoSessionLastErrorCode'NonNullableEnumSelfieManipulated) = "selfie_manipulated"
  toJSON (GelatoSessionLastErrorCode'NonNullableEnumSelfieUnverifiedOther) = "selfie_unverified_other"
  toJSON (GelatoSessionLastErrorCode'NonNullableEnumUnderSupportedAge) = "under_supported_age"

instance Data.Aeson.Types.FromJSON.FromJSON GelatoSessionLastErrorCode'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "abandoned" -> GelatoSessionLastErrorCode'NonNullableEnumAbandoned
            | val GHC.Classes.== "consent_declined" -> GelatoSessionLastErrorCode'NonNullableEnumConsentDeclined
            | val GHC.Classes.== "country_not_supported" -> GelatoSessionLastErrorCode'NonNullableEnumCountryNotSupported
            | val GHC.Classes.== "device_not_supported" -> GelatoSessionLastErrorCode'NonNullableEnumDeviceNotSupported
            | val GHC.Classes.== "document_expired" -> GelatoSessionLastErrorCode'NonNullableEnumDocumentExpired
            | val GHC.Classes.== "document_type_not_supported" -> GelatoSessionLastErrorCode'NonNullableEnumDocumentTypeNotSupported
            | val GHC.Classes.== "document_unverified_other" -> GelatoSessionLastErrorCode'NonNullableEnumDocumentUnverifiedOther
            | val GHC.Classes.== "id_number_insufficient_document_data" -> GelatoSessionLastErrorCode'NonNullableEnumIdNumberInsufficientDocumentData
            | val GHC.Classes.== "id_number_mismatch" -> GelatoSessionLastErrorCode'NonNullableEnumIdNumberMismatch
            | val GHC.Classes.== "id_number_unverified_other" -> GelatoSessionLastErrorCode'NonNullableEnumIdNumberUnverifiedOther
            | val GHC.Classes.== "selfie_document_missing_photo" -> GelatoSessionLastErrorCode'NonNullableEnumSelfieDocumentMissingPhoto
            | val GHC.Classes.== "selfie_face_mismatch" -> GelatoSessionLastErrorCode'NonNullableEnumSelfieFaceMismatch
            | val GHC.Classes.== "selfie_manipulated" -> GelatoSessionLastErrorCode'NonNullableEnumSelfieManipulated
            | val GHC.Classes.== "selfie_unverified_other" -> GelatoSessionLastErrorCode'NonNullableEnumSelfieUnverifiedOther
            | val GHC.Classes.== "under_supported_age" -> GelatoSessionLastErrorCode'NonNullableEnumUnderSupportedAge
            | GHC.Base.otherwise -> GelatoSessionLastErrorCode'NonNullableOther val
      )
