{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema OrdersV2ResourceAutomaticTax
module StripeAPI.Types.OrdersV2ResourceAutomaticTax where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.orders_v2_resource_automatic_tax@ in the specification.
data OrdersV2ResourceAutomaticTax = OrdersV2ResourceAutomaticTax
  { -- | enabled: Whether Stripe automatically computes tax on this Order.
    ordersV2ResourceAutomaticTaxEnabled :: GHC.Types.Bool,
    -- | status: The status of the most recent automated tax calculation for this Order.
    ordersV2ResourceAutomaticTaxStatus :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable OrdersV2ResourceAutomaticTaxStatus'NonNullable))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON OrdersV2ResourceAutomaticTax where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= ordersV2ResourceAutomaticTaxEnabled obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("status" Data.Aeson.Types.ToJSON..=)) (ordersV2ResourceAutomaticTaxStatus obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= ordersV2ResourceAutomaticTaxEnabled obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("status" Data.Aeson.Types.ToJSON..=)) (ordersV2ResourceAutomaticTaxStatus obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON OrdersV2ResourceAutomaticTax where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "OrdersV2ResourceAutomaticTax" (\obj -> (GHC.Base.pure OrdersV2ResourceAutomaticTax GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "status"))

-- | Create a new 'OrdersV2ResourceAutomaticTax' with all required fields.
mkOrdersV2ResourceAutomaticTax ::
  -- | 'ordersV2ResourceAutomaticTaxEnabled'
  GHC.Types.Bool ->
  OrdersV2ResourceAutomaticTax
mkOrdersV2ResourceAutomaticTax ordersV2ResourceAutomaticTaxEnabled =
  OrdersV2ResourceAutomaticTax
    { ordersV2ResourceAutomaticTaxEnabled = ordersV2ResourceAutomaticTaxEnabled,
      ordersV2ResourceAutomaticTaxStatus = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.orders_v2_resource_automatic_tax.properties.status@ in the specification.
--
-- The status of the most recent automated tax calculation for this Order.
data OrdersV2ResourceAutomaticTaxStatus'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    OrdersV2ResourceAutomaticTaxStatus'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    OrdersV2ResourceAutomaticTaxStatus'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"complete"@
    OrdersV2ResourceAutomaticTaxStatus'NonNullableEnumComplete
  | -- | Represents the JSON value @"failed"@
    OrdersV2ResourceAutomaticTaxStatus'NonNullableEnumFailed
  | -- | Represents the JSON value @"requires_location_inputs"@
    OrdersV2ResourceAutomaticTaxStatus'NonNullableEnumRequiresLocationInputs
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON OrdersV2ResourceAutomaticTaxStatus'NonNullable where
  toJSON (OrdersV2ResourceAutomaticTaxStatus'NonNullableOther val) = val
  toJSON (OrdersV2ResourceAutomaticTaxStatus'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (OrdersV2ResourceAutomaticTaxStatus'NonNullableEnumComplete) = "complete"
  toJSON (OrdersV2ResourceAutomaticTaxStatus'NonNullableEnumFailed) = "failed"
  toJSON (OrdersV2ResourceAutomaticTaxStatus'NonNullableEnumRequiresLocationInputs) = "requires_location_inputs"

instance Data.Aeson.Types.FromJSON.FromJSON OrdersV2ResourceAutomaticTaxStatus'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "complete" -> OrdersV2ResourceAutomaticTaxStatus'NonNullableEnumComplete
            | val GHC.Classes.== "failed" -> OrdersV2ResourceAutomaticTaxStatus'NonNullableEnumFailed
            | val GHC.Classes.== "requires_location_inputs" -> OrdersV2ResourceAutomaticTaxStatus'NonNullableEnumRequiresLocationInputs
            | GHC.Base.otherwise -> OrdersV2ResourceAutomaticTaxStatus'NonNullableOther val
      )
