{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema PaymentIntentTypeSpecificPaymentMethodOptionsClient
module StripeAPI.Types.PaymentIntentTypeSpecificPaymentMethodOptionsClient where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.payment_intent_type_specific_payment_method_options_client@ in the specification.
data PaymentIntentTypeSpecificPaymentMethodOptionsClient = PaymentIntentTypeSpecificPaymentMethodOptionsClient
  { -- | capture_method: Controls when the funds will be captured from the customer\'s account.
    paymentIntentTypeSpecificPaymentMethodOptionsClientCaptureMethod :: (GHC.Maybe.Maybe PaymentIntentTypeSpecificPaymentMethodOptionsClientCaptureMethod'),
    -- | setup_future_usage: Indicates that you intend to make future payments with this PaymentIntent\'s payment method.
    --
    -- Providing this parameter will [attach the payment method](https:\/\/stripe.com\/docs\/payments\/save-during-payment) to the PaymentIntent\'s Customer, if present, after the PaymentIntent is confirmed and any required actions from the user are complete. If no Customer was provided, the payment method can still be [attached](https:\/\/stripe.com\/docs\/api\/payment_methods\/attach) to a Customer after the transaction completes.
    --
    -- When processing card payments, Stripe also uses \`setup_future_usage\` to dynamically optimize your payment flow and comply with regional legislation and network rules, such as [SCA](https:\/\/stripe.com\/docs\/strong-customer-authentication).
    paymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage :: (GHC.Maybe.Maybe PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage'),
    -- | verification_method: Bank account verification method.
    paymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod :: (GHC.Maybe.Maybe PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentIntentTypeSpecificPaymentMethodOptionsClient where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (paymentIntentTypeSpecificPaymentMethodOptionsClientCaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (paymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verification_method" Data.Aeson.Types.ToJSON..=)) (paymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (paymentIntentTypeSpecificPaymentMethodOptionsClientCaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (paymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verification_method" Data.Aeson.Types.ToJSON..=)) (paymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentIntentTypeSpecificPaymentMethodOptionsClient where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentIntentTypeSpecificPaymentMethodOptionsClient" (\obj -> ((GHC.Base.pure PaymentIntentTypeSpecificPaymentMethodOptionsClient GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "capture_method")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "verification_method"))

-- | Create a new 'PaymentIntentTypeSpecificPaymentMethodOptionsClient' with all required fields.
mkPaymentIntentTypeSpecificPaymentMethodOptionsClient :: PaymentIntentTypeSpecificPaymentMethodOptionsClient
mkPaymentIntentTypeSpecificPaymentMethodOptionsClient =
  PaymentIntentTypeSpecificPaymentMethodOptionsClient
    { paymentIntentTypeSpecificPaymentMethodOptionsClientCaptureMethod = GHC.Maybe.Nothing,
      paymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage = GHC.Maybe.Nothing,
      paymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.payment_intent_type_specific_payment_method_options_client.properties.capture_method@ in the specification.
--
-- Controls when the funds will be captured from the customer\'s account.
data PaymentIntentTypeSpecificPaymentMethodOptionsClientCaptureMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentIntentTypeSpecificPaymentMethodOptionsClientCaptureMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentIntentTypeSpecificPaymentMethodOptionsClientCaptureMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"manual"@
    PaymentIntentTypeSpecificPaymentMethodOptionsClientCaptureMethod'EnumManual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentIntentTypeSpecificPaymentMethodOptionsClientCaptureMethod' where
  toJSON (PaymentIntentTypeSpecificPaymentMethodOptionsClientCaptureMethod'Other val) = val
  toJSON (PaymentIntentTypeSpecificPaymentMethodOptionsClientCaptureMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentIntentTypeSpecificPaymentMethodOptionsClientCaptureMethod'EnumManual) = "manual"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentIntentTypeSpecificPaymentMethodOptionsClientCaptureMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "manual" -> PaymentIntentTypeSpecificPaymentMethodOptionsClientCaptureMethod'EnumManual
            | GHC.Base.otherwise -> PaymentIntentTypeSpecificPaymentMethodOptionsClientCaptureMethod'Other val
      )

-- | Defines the enum schema located at @components.schemas.payment_intent_type_specific_payment_method_options_client.properties.setup_future_usage@ in the specification.
--
-- Indicates that you intend to make future payments with this PaymentIntent\'s payment method.
--
-- Providing this parameter will [attach the payment method](https:\/\/stripe.com\/docs\/payments\/save-during-payment) to the PaymentIntent\'s Customer, if present, after the PaymentIntent is confirmed and any required actions from the user are complete. If no Customer was provided, the payment method can still be [attached](https:\/\/stripe.com\/docs\/api\/payment_methods\/attach) to a Customer after the transaction completes.
--
-- When processing card payments, Stripe also uses \`setup_future_usage\` to dynamically optimize your payment flow and comply with regional legislation and network rules, such as [SCA](https:\/\/stripe.com\/docs\/strong-customer-authentication).
data PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"none"@
    PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage'EnumNone
  | -- | Represents the JSON value @"off_session"@
    PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage'EnumOffSession
  | -- | Represents the JSON value @"on_session"@
    PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage'EnumOnSession
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage' where
  toJSON (PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage'Other val) = val
  toJSON (PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage'EnumNone) = "none"
  toJSON (PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage'EnumOffSession) = "off_session"
  toJSON (PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage'EnumOnSession) = "on_session"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "none" -> PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage'EnumNone
            | val GHC.Classes.== "off_session" -> PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage'EnumOffSession
            | val GHC.Classes.== "on_session" -> PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage'EnumOnSession
            | GHC.Base.otherwise -> PaymentIntentTypeSpecificPaymentMethodOptionsClientSetupFutureUsage'Other val
      )

-- | Defines the enum schema located at @components.schemas.payment_intent_type_specific_payment_method_options_client.properties.verification_method@ in the specification.
--
-- Bank account verification method.
data PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"automatic"@
    PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod'EnumAutomatic
  | -- | Represents the JSON value @"instant"@
    PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod'EnumInstant
  | -- | Represents the JSON value @"microdeposits"@
    PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod'EnumMicrodeposits
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod' where
  toJSON (PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod'Other val) = val
  toJSON (PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod'EnumAutomatic) = "automatic"
  toJSON (PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod'EnumInstant) = "instant"
  toJSON (PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod'EnumMicrodeposits) = "microdeposits"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "automatic" -> PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod'EnumAutomatic
            | val GHC.Classes.== "instant" -> PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod'EnumInstant
            | val GHC.Classes.== "microdeposits" -> PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod'EnumMicrodeposits
            | GHC.Base.otherwise -> PaymentIntentTypeSpecificPaymentMethodOptionsClientVerificationMethod'Other val
      )
