{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema PaymentPagesCheckoutSessionShippingAddressCollection
module StripeAPI.Types.PaymentPagesCheckoutSessionShippingAddressCollection where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.payment_pages_checkout_session_shipping_address_collection@ in the specification.
data PaymentPagesCheckoutSessionShippingAddressCollection = PaymentPagesCheckoutSessionShippingAddressCollection
  { -- | allowed_countries: An array of two-letter ISO country codes representing which countries Checkout should provide as options for
    -- shipping locations. Unsupported country codes: \`AS, CX, CC, CU, HM, IR, KP, MH, FM, NF, MP, PW, SD, SY, UM, VI\`.
    paymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries :: ([PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'])
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentPagesCheckoutSessionShippingAddressCollection where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["allowed_countries" Data.Aeson.Types.ToJSON..= paymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["allowed_countries" Data.Aeson.Types.ToJSON..= paymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentPagesCheckoutSessionShippingAddressCollection where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentPagesCheckoutSessionShippingAddressCollection" (\obj -> GHC.Base.pure PaymentPagesCheckoutSessionShippingAddressCollection GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "allowed_countries"))

-- | Create a new 'PaymentPagesCheckoutSessionShippingAddressCollection' with all required fields.
mkPaymentPagesCheckoutSessionShippingAddressCollection ::
  -- | 'paymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'
  [PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'] ->
  PaymentPagesCheckoutSessionShippingAddressCollection
mkPaymentPagesCheckoutSessionShippingAddressCollection paymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries = PaymentPagesCheckoutSessionShippingAddressCollection {paymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries = paymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries}

-- | Defines the enum schema located at @components.schemas.payment_pages_checkout_session_shipping_address_collection.properties.allowed_countries.items@ in the specification.
data PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"AC"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAC
  | -- | Represents the JSON value @"AD"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAD
  | -- | Represents the JSON value @"AE"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAE
  | -- | Represents the JSON value @"AF"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAF
  | -- | Represents the JSON value @"AG"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAG
  | -- | Represents the JSON value @"AI"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAI
  | -- | Represents the JSON value @"AL"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAL
  | -- | Represents the JSON value @"AM"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAM
  | -- | Represents the JSON value @"AO"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAO
  | -- | Represents the JSON value @"AQ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAQ
  | -- | Represents the JSON value @"AR"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAR
  | -- | Represents the JSON value @"AT"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAT
  | -- | Represents the JSON value @"AU"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAU
  | -- | Represents the JSON value @"AW"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAW
  | -- | Represents the JSON value @"AX"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAX
  | -- | Represents the JSON value @"AZ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAZ
  | -- | Represents the JSON value @"BA"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBA
  | -- | Represents the JSON value @"BB"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBB
  | -- | Represents the JSON value @"BD"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBD
  | -- | Represents the JSON value @"BE"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBE
  | -- | Represents the JSON value @"BF"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBF
  | -- | Represents the JSON value @"BG"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBG
  | -- | Represents the JSON value @"BH"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBH
  | -- | Represents the JSON value @"BI"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBI
  | -- | Represents the JSON value @"BJ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBJ
  | -- | Represents the JSON value @"BL"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBL
  | -- | Represents the JSON value @"BM"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBM
  | -- | Represents the JSON value @"BN"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBN
  | -- | Represents the JSON value @"BO"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBO
  | -- | Represents the JSON value @"BQ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBQ
  | -- | Represents the JSON value @"BR"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBR
  | -- | Represents the JSON value @"BS"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBS
  | -- | Represents the JSON value @"BT"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBT
  | -- | Represents the JSON value @"BV"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBV
  | -- | Represents the JSON value @"BW"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBW
  | -- | Represents the JSON value @"BY"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBY
  | -- | Represents the JSON value @"BZ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBZ
  | -- | Represents the JSON value @"CA"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCA
  | -- | Represents the JSON value @"CD"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCD
  | -- | Represents the JSON value @"CF"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCF
  | -- | Represents the JSON value @"CG"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCG
  | -- | Represents the JSON value @"CH"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCH
  | -- | Represents the JSON value @"CI"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCI
  | -- | Represents the JSON value @"CK"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCK
  | -- | Represents the JSON value @"CL"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCL
  | -- | Represents the JSON value @"CM"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCM
  | -- | Represents the JSON value @"CN"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCN
  | -- | Represents the JSON value @"CO"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCO
  | -- | Represents the JSON value @"CR"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCR
  | -- | Represents the JSON value @"CV"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCV
  | -- | Represents the JSON value @"CW"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCW
  | -- | Represents the JSON value @"CY"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCY
  | -- | Represents the JSON value @"CZ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCZ
  | -- | Represents the JSON value @"DE"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDE
  | -- | Represents the JSON value @"DJ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDJ
  | -- | Represents the JSON value @"DK"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDK
  | -- | Represents the JSON value @"DM"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDM
  | -- | Represents the JSON value @"DO"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDO
  | -- | Represents the JSON value @"DZ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDZ
  | -- | Represents the JSON value @"EC"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumEC
  | -- | Represents the JSON value @"EE"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumEE
  | -- | Represents the JSON value @"EG"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumEG
  | -- | Represents the JSON value @"EH"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumEH
  | -- | Represents the JSON value @"ER"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumER
  | -- | Represents the JSON value @"ES"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumES
  | -- | Represents the JSON value @"ET"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumET
  | -- | Represents the JSON value @"FI"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumFI
  | -- | Represents the JSON value @"FJ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumFJ
  | -- | Represents the JSON value @"FK"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumFK
  | -- | Represents the JSON value @"FO"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumFO
  | -- | Represents the JSON value @"FR"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumFR
  | -- | Represents the JSON value @"GA"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGA
  | -- | Represents the JSON value @"GB"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGB
  | -- | Represents the JSON value @"GD"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGD
  | -- | Represents the JSON value @"GE"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGE
  | -- | Represents the JSON value @"GF"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGF
  | -- | Represents the JSON value @"GG"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGG
  | -- | Represents the JSON value @"GH"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGH
  | -- | Represents the JSON value @"GI"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGI
  | -- | Represents the JSON value @"GL"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGL
  | -- | Represents the JSON value @"GM"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGM
  | -- | Represents the JSON value @"GN"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGN
  | -- | Represents the JSON value @"GP"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGP
  | -- | Represents the JSON value @"GQ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGQ
  | -- | Represents the JSON value @"GR"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGR
  | -- | Represents the JSON value @"GS"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGS
  | -- | Represents the JSON value @"GT"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGT
  | -- | Represents the JSON value @"GU"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGU
  | -- | Represents the JSON value @"GW"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGW
  | -- | Represents the JSON value @"GY"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGY
  | -- | Represents the JSON value @"HK"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumHK
  | -- | Represents the JSON value @"HN"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumHN
  | -- | Represents the JSON value @"HR"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumHR
  | -- | Represents the JSON value @"HT"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumHT
  | -- | Represents the JSON value @"HU"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumHU
  | -- | Represents the JSON value @"ID"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumID
  | -- | Represents the JSON value @"IE"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIE
  | -- | Represents the JSON value @"IL"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIL
  | -- | Represents the JSON value @"IM"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIM
  | -- | Represents the JSON value @"IN"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIN
  | -- | Represents the JSON value @"IO"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIO
  | -- | Represents the JSON value @"IQ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIQ
  | -- | Represents the JSON value @"IS"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIS
  | -- | Represents the JSON value @"IT"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIT
  | -- | Represents the JSON value @"JE"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumJE
  | -- | Represents the JSON value @"JM"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumJM
  | -- | Represents the JSON value @"JO"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumJO
  | -- | Represents the JSON value @"JP"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumJP
  | -- | Represents the JSON value @"KE"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKE
  | -- | Represents the JSON value @"KG"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKG
  | -- | Represents the JSON value @"KH"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKH
  | -- | Represents the JSON value @"KI"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKI
  | -- | Represents the JSON value @"KM"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKM
  | -- | Represents the JSON value @"KN"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKN
  | -- | Represents the JSON value @"KR"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKR
  | -- | Represents the JSON value @"KW"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKW
  | -- | Represents the JSON value @"KY"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKY
  | -- | Represents the JSON value @"KZ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKZ
  | -- | Represents the JSON value @"LA"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLA
  | -- | Represents the JSON value @"LB"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLB
  | -- | Represents the JSON value @"LC"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLC
  | -- | Represents the JSON value @"LI"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLI
  | -- | Represents the JSON value @"LK"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLK
  | -- | Represents the JSON value @"LR"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLR
  | -- | Represents the JSON value @"LS"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLS
  | -- | Represents the JSON value @"LT"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLT
  | -- | Represents the JSON value @"LU"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLU
  | -- | Represents the JSON value @"LV"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLV
  | -- | Represents the JSON value @"LY"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLY
  | -- | Represents the JSON value @"MA"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMA
  | -- | Represents the JSON value @"MC"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMC
  | -- | Represents the JSON value @"MD"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMD
  | -- | Represents the JSON value @"ME"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumME
  | -- | Represents the JSON value @"MF"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMF
  | -- | Represents the JSON value @"MG"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMG
  | -- | Represents the JSON value @"MK"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMK
  | -- | Represents the JSON value @"ML"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumML
  | -- | Represents the JSON value @"MM"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMM
  | -- | Represents the JSON value @"MN"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMN
  | -- | Represents the JSON value @"MO"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMO
  | -- | Represents the JSON value @"MQ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMQ
  | -- | Represents the JSON value @"MR"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMR
  | -- | Represents the JSON value @"MS"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMS
  | -- | Represents the JSON value @"MT"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMT
  | -- | Represents the JSON value @"MU"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMU
  | -- | Represents the JSON value @"MV"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMV
  | -- | Represents the JSON value @"MW"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMW
  | -- | Represents the JSON value @"MX"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMX
  | -- | Represents the JSON value @"MY"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMY
  | -- | Represents the JSON value @"MZ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMZ
  | -- | Represents the JSON value @"NA"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNA
  | -- | Represents the JSON value @"NC"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNC
  | -- | Represents the JSON value @"NE"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNE
  | -- | Represents the JSON value @"NG"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNG
  | -- | Represents the JSON value @"NI"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNI
  | -- | Represents the JSON value @"NL"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNL
  | -- | Represents the JSON value @"NO"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNO
  | -- | Represents the JSON value @"NP"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNP
  | -- | Represents the JSON value @"NR"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNR
  | -- | Represents the JSON value @"NU"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNU
  | -- | Represents the JSON value @"NZ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNZ
  | -- | Represents the JSON value @"OM"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumOM
  | -- | Represents the JSON value @"PA"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPA
  | -- | Represents the JSON value @"PE"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPE
  | -- | Represents the JSON value @"PF"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPF
  | -- | Represents the JSON value @"PG"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPG
  | -- | Represents the JSON value @"PH"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPH
  | -- | Represents the JSON value @"PK"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPK
  | -- | Represents the JSON value @"PL"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPL
  | -- | Represents the JSON value @"PM"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPM
  | -- | Represents the JSON value @"PN"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPN
  | -- | Represents the JSON value @"PR"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPR
  | -- | Represents the JSON value @"PS"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPS
  | -- | Represents the JSON value @"PT"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPT
  | -- | Represents the JSON value @"PY"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPY
  | -- | Represents the JSON value @"QA"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumQA
  | -- | Represents the JSON value @"RE"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumRE
  | -- | Represents the JSON value @"RO"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumRO
  | -- | Represents the JSON value @"RS"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumRS
  | -- | Represents the JSON value @"RU"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumRU
  | -- | Represents the JSON value @"RW"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumRW
  | -- | Represents the JSON value @"SA"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSA
  | -- | Represents the JSON value @"SB"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSB
  | -- | Represents the JSON value @"SC"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSC
  | -- | Represents the JSON value @"SE"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSE
  | -- | Represents the JSON value @"SG"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSG
  | -- | Represents the JSON value @"SH"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSH
  | -- | Represents the JSON value @"SI"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSI
  | -- | Represents the JSON value @"SJ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSJ
  | -- | Represents the JSON value @"SK"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSK
  | -- | Represents the JSON value @"SL"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSL
  | -- | Represents the JSON value @"SM"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSM
  | -- | Represents the JSON value @"SN"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSN
  | -- | Represents the JSON value @"SO"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSO
  | -- | Represents the JSON value @"SR"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSR
  | -- | Represents the JSON value @"SS"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSS
  | -- | Represents the JSON value @"ST"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumST
  | -- | Represents the JSON value @"SV"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSV
  | -- | Represents the JSON value @"SX"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSX
  | -- | Represents the JSON value @"SZ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSZ
  | -- | Represents the JSON value @"TA"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTA
  | -- | Represents the JSON value @"TC"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTC
  | -- | Represents the JSON value @"TD"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTD
  | -- | Represents the JSON value @"TF"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTF
  | -- | Represents the JSON value @"TG"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTG
  | -- | Represents the JSON value @"TH"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTH
  | -- | Represents the JSON value @"TJ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTJ
  | -- | Represents the JSON value @"TK"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTK
  | -- | Represents the JSON value @"TL"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTL
  | -- | Represents the JSON value @"TM"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTM
  | -- | Represents the JSON value @"TN"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTN
  | -- | Represents the JSON value @"TO"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTO
  | -- | Represents the JSON value @"TR"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTR
  | -- | Represents the JSON value @"TT"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTT
  | -- | Represents the JSON value @"TV"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTV
  | -- | Represents the JSON value @"TW"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTW
  | -- | Represents the JSON value @"TZ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTZ
  | -- | Represents the JSON value @"UA"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumUA
  | -- | Represents the JSON value @"UG"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumUG
  | -- | Represents the JSON value @"US"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumUS
  | -- | Represents the JSON value @"UY"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumUY
  | -- | Represents the JSON value @"UZ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumUZ
  | -- | Represents the JSON value @"VA"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVA
  | -- | Represents the JSON value @"VC"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVC
  | -- | Represents the JSON value @"VE"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVE
  | -- | Represents the JSON value @"VG"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVG
  | -- | Represents the JSON value @"VN"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVN
  | -- | Represents the JSON value @"VU"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVU
  | -- | Represents the JSON value @"WF"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumWF
  | -- | Represents the JSON value @"WS"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumWS
  | -- | Represents the JSON value @"XK"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumXK
  | -- | Represents the JSON value @"YE"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumYE
  | -- | Represents the JSON value @"YT"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumYT
  | -- | Represents the JSON value @"ZA"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumZA
  | -- | Represents the JSON value @"ZM"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumZM
  | -- | Represents the JSON value @"ZW"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumZW
  | -- | Represents the JSON value @"ZZ"@
    PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumZZ
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries' where
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'Other val) = val
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAC) = "AC"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAD) = "AD"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAE) = "AE"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAF) = "AF"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAG) = "AG"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAI) = "AI"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAL) = "AL"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAM) = "AM"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAO) = "AO"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAQ) = "AQ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAR) = "AR"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAT) = "AT"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAU) = "AU"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAW) = "AW"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAX) = "AX"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAZ) = "AZ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBA) = "BA"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBB) = "BB"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBD) = "BD"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBE) = "BE"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBF) = "BF"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBG) = "BG"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBH) = "BH"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBI) = "BI"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBJ) = "BJ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBL) = "BL"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBM) = "BM"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBN) = "BN"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBO) = "BO"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBQ) = "BQ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBR) = "BR"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBS) = "BS"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBT) = "BT"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBV) = "BV"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBW) = "BW"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBY) = "BY"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBZ) = "BZ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCA) = "CA"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCD) = "CD"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCF) = "CF"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCG) = "CG"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCH) = "CH"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCI) = "CI"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCK) = "CK"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCL) = "CL"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCM) = "CM"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCN) = "CN"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCO) = "CO"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCR) = "CR"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCV) = "CV"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCW) = "CW"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCY) = "CY"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCZ) = "CZ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDE) = "DE"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDJ) = "DJ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDK) = "DK"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDM) = "DM"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDO) = "DO"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDZ) = "DZ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumEC) = "EC"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumEE) = "EE"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumEG) = "EG"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumEH) = "EH"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumER) = "ER"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumES) = "ES"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumET) = "ET"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumFI) = "FI"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumFJ) = "FJ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumFK) = "FK"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumFO) = "FO"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumFR) = "FR"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGA) = "GA"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGB) = "GB"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGD) = "GD"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGE) = "GE"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGF) = "GF"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGG) = "GG"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGH) = "GH"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGI) = "GI"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGL) = "GL"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGM) = "GM"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGN) = "GN"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGP) = "GP"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGQ) = "GQ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGR) = "GR"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGS) = "GS"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGT) = "GT"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGU) = "GU"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGW) = "GW"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGY) = "GY"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumHK) = "HK"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumHN) = "HN"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumHR) = "HR"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumHT) = "HT"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumHU) = "HU"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumID) = "ID"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIE) = "IE"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIL) = "IL"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIM) = "IM"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIN) = "IN"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIO) = "IO"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIQ) = "IQ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIS) = "IS"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIT) = "IT"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumJE) = "JE"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumJM) = "JM"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumJO) = "JO"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumJP) = "JP"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKE) = "KE"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKG) = "KG"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKH) = "KH"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKI) = "KI"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKM) = "KM"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKN) = "KN"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKR) = "KR"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKW) = "KW"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKY) = "KY"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKZ) = "KZ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLA) = "LA"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLB) = "LB"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLC) = "LC"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLI) = "LI"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLK) = "LK"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLR) = "LR"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLS) = "LS"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLT) = "LT"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLU) = "LU"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLV) = "LV"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLY) = "LY"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMA) = "MA"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMC) = "MC"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMD) = "MD"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumME) = "ME"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMF) = "MF"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMG) = "MG"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMK) = "MK"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumML) = "ML"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMM) = "MM"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMN) = "MN"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMO) = "MO"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMQ) = "MQ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMR) = "MR"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMS) = "MS"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMT) = "MT"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMU) = "MU"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMV) = "MV"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMW) = "MW"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMX) = "MX"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMY) = "MY"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMZ) = "MZ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNA) = "NA"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNC) = "NC"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNE) = "NE"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNG) = "NG"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNI) = "NI"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNL) = "NL"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNO) = "NO"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNP) = "NP"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNR) = "NR"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNU) = "NU"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNZ) = "NZ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumOM) = "OM"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPA) = "PA"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPE) = "PE"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPF) = "PF"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPG) = "PG"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPH) = "PH"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPK) = "PK"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPL) = "PL"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPM) = "PM"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPN) = "PN"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPR) = "PR"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPS) = "PS"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPT) = "PT"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPY) = "PY"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumQA) = "QA"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumRE) = "RE"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumRO) = "RO"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumRS) = "RS"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumRU) = "RU"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumRW) = "RW"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSA) = "SA"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSB) = "SB"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSC) = "SC"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSE) = "SE"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSG) = "SG"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSH) = "SH"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSI) = "SI"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSJ) = "SJ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSK) = "SK"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSL) = "SL"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSM) = "SM"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSN) = "SN"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSO) = "SO"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSR) = "SR"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSS) = "SS"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumST) = "ST"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSV) = "SV"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSX) = "SX"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSZ) = "SZ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTA) = "TA"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTC) = "TC"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTD) = "TD"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTF) = "TF"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTG) = "TG"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTH) = "TH"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTJ) = "TJ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTK) = "TK"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTL) = "TL"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTM) = "TM"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTN) = "TN"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTO) = "TO"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTR) = "TR"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTT) = "TT"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTV) = "TV"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTW) = "TW"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTZ) = "TZ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumUA) = "UA"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumUG) = "UG"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumUS) = "US"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumUY) = "UY"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumUZ) = "UZ"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVA) = "VA"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVC) = "VC"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVE) = "VE"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVG) = "VG"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVN) = "VN"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVU) = "VU"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumWF) = "WF"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumWS) = "WS"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumXK) = "XK"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumYE) = "YE"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumYT) = "YT"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumZA) = "ZA"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumZM) = "ZM"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumZW) = "ZW"
  toJSON (PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumZZ) = "ZZ"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "AC" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAC
            | val GHC.Classes.== "AD" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAD
            | val GHC.Classes.== "AE" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAE
            | val GHC.Classes.== "AF" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAF
            | val GHC.Classes.== "AG" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAG
            | val GHC.Classes.== "AI" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAI
            | val GHC.Classes.== "AL" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAL
            | val GHC.Classes.== "AM" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAM
            | val GHC.Classes.== "AO" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAO
            | val GHC.Classes.== "AQ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAQ
            | val GHC.Classes.== "AR" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAR
            | val GHC.Classes.== "AT" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAT
            | val GHC.Classes.== "AU" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAU
            | val GHC.Classes.== "AW" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAW
            | val GHC.Classes.== "AX" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAX
            | val GHC.Classes.== "AZ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumAZ
            | val GHC.Classes.== "BA" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBA
            | val GHC.Classes.== "BB" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBB
            | val GHC.Classes.== "BD" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBD
            | val GHC.Classes.== "BE" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBE
            | val GHC.Classes.== "BF" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBF
            | val GHC.Classes.== "BG" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBG
            | val GHC.Classes.== "BH" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBH
            | val GHC.Classes.== "BI" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBI
            | val GHC.Classes.== "BJ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBJ
            | val GHC.Classes.== "BL" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBL
            | val GHC.Classes.== "BM" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBM
            | val GHC.Classes.== "BN" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBN
            | val GHC.Classes.== "BO" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBO
            | val GHC.Classes.== "BQ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBQ
            | val GHC.Classes.== "BR" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBR
            | val GHC.Classes.== "BS" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBS
            | val GHC.Classes.== "BT" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBT
            | val GHC.Classes.== "BV" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBV
            | val GHC.Classes.== "BW" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBW
            | val GHC.Classes.== "BY" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBY
            | val GHC.Classes.== "BZ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumBZ
            | val GHC.Classes.== "CA" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCA
            | val GHC.Classes.== "CD" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCD
            | val GHC.Classes.== "CF" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCF
            | val GHC.Classes.== "CG" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCG
            | val GHC.Classes.== "CH" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCH
            | val GHC.Classes.== "CI" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCI
            | val GHC.Classes.== "CK" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCK
            | val GHC.Classes.== "CL" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCL
            | val GHC.Classes.== "CM" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCM
            | val GHC.Classes.== "CN" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCN
            | val GHC.Classes.== "CO" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCO
            | val GHC.Classes.== "CR" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCR
            | val GHC.Classes.== "CV" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCV
            | val GHC.Classes.== "CW" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCW
            | val GHC.Classes.== "CY" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCY
            | val GHC.Classes.== "CZ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumCZ
            | val GHC.Classes.== "DE" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDE
            | val GHC.Classes.== "DJ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDJ
            | val GHC.Classes.== "DK" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDK
            | val GHC.Classes.== "DM" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDM
            | val GHC.Classes.== "DO" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDO
            | val GHC.Classes.== "DZ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumDZ
            | val GHC.Classes.== "EC" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumEC
            | val GHC.Classes.== "EE" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumEE
            | val GHC.Classes.== "EG" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumEG
            | val GHC.Classes.== "EH" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumEH
            | val GHC.Classes.== "ER" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumER
            | val GHC.Classes.== "ES" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumES
            | val GHC.Classes.== "ET" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumET
            | val GHC.Classes.== "FI" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumFI
            | val GHC.Classes.== "FJ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumFJ
            | val GHC.Classes.== "FK" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumFK
            | val GHC.Classes.== "FO" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumFO
            | val GHC.Classes.== "FR" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumFR
            | val GHC.Classes.== "GA" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGA
            | val GHC.Classes.== "GB" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGB
            | val GHC.Classes.== "GD" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGD
            | val GHC.Classes.== "GE" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGE
            | val GHC.Classes.== "GF" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGF
            | val GHC.Classes.== "GG" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGG
            | val GHC.Classes.== "GH" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGH
            | val GHC.Classes.== "GI" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGI
            | val GHC.Classes.== "GL" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGL
            | val GHC.Classes.== "GM" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGM
            | val GHC.Classes.== "GN" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGN
            | val GHC.Classes.== "GP" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGP
            | val GHC.Classes.== "GQ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGQ
            | val GHC.Classes.== "GR" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGR
            | val GHC.Classes.== "GS" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGS
            | val GHC.Classes.== "GT" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGT
            | val GHC.Classes.== "GU" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGU
            | val GHC.Classes.== "GW" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGW
            | val GHC.Classes.== "GY" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumGY
            | val GHC.Classes.== "HK" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumHK
            | val GHC.Classes.== "HN" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumHN
            | val GHC.Classes.== "HR" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumHR
            | val GHC.Classes.== "HT" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumHT
            | val GHC.Classes.== "HU" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumHU
            | val GHC.Classes.== "ID" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumID
            | val GHC.Classes.== "IE" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIE
            | val GHC.Classes.== "IL" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIL
            | val GHC.Classes.== "IM" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIM
            | val GHC.Classes.== "IN" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIN
            | val GHC.Classes.== "IO" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIO
            | val GHC.Classes.== "IQ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIQ
            | val GHC.Classes.== "IS" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIS
            | val GHC.Classes.== "IT" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumIT
            | val GHC.Classes.== "JE" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumJE
            | val GHC.Classes.== "JM" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumJM
            | val GHC.Classes.== "JO" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumJO
            | val GHC.Classes.== "JP" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumJP
            | val GHC.Classes.== "KE" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKE
            | val GHC.Classes.== "KG" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKG
            | val GHC.Classes.== "KH" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKH
            | val GHC.Classes.== "KI" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKI
            | val GHC.Classes.== "KM" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKM
            | val GHC.Classes.== "KN" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKN
            | val GHC.Classes.== "KR" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKR
            | val GHC.Classes.== "KW" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKW
            | val GHC.Classes.== "KY" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKY
            | val GHC.Classes.== "KZ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumKZ
            | val GHC.Classes.== "LA" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLA
            | val GHC.Classes.== "LB" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLB
            | val GHC.Classes.== "LC" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLC
            | val GHC.Classes.== "LI" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLI
            | val GHC.Classes.== "LK" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLK
            | val GHC.Classes.== "LR" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLR
            | val GHC.Classes.== "LS" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLS
            | val GHC.Classes.== "LT" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLT
            | val GHC.Classes.== "LU" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLU
            | val GHC.Classes.== "LV" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLV
            | val GHC.Classes.== "LY" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumLY
            | val GHC.Classes.== "MA" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMA
            | val GHC.Classes.== "MC" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMC
            | val GHC.Classes.== "MD" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMD
            | val GHC.Classes.== "ME" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumME
            | val GHC.Classes.== "MF" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMF
            | val GHC.Classes.== "MG" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMG
            | val GHC.Classes.== "MK" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMK
            | val GHC.Classes.== "ML" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumML
            | val GHC.Classes.== "MM" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMM
            | val GHC.Classes.== "MN" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMN
            | val GHC.Classes.== "MO" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMO
            | val GHC.Classes.== "MQ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMQ
            | val GHC.Classes.== "MR" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMR
            | val GHC.Classes.== "MS" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMS
            | val GHC.Classes.== "MT" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMT
            | val GHC.Classes.== "MU" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMU
            | val GHC.Classes.== "MV" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMV
            | val GHC.Classes.== "MW" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMW
            | val GHC.Classes.== "MX" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMX
            | val GHC.Classes.== "MY" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMY
            | val GHC.Classes.== "MZ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumMZ
            | val GHC.Classes.== "NA" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNA
            | val GHC.Classes.== "NC" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNC
            | val GHC.Classes.== "NE" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNE
            | val GHC.Classes.== "NG" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNG
            | val GHC.Classes.== "NI" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNI
            | val GHC.Classes.== "NL" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNL
            | val GHC.Classes.== "NO" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNO
            | val GHC.Classes.== "NP" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNP
            | val GHC.Classes.== "NR" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNR
            | val GHC.Classes.== "NU" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNU
            | val GHC.Classes.== "NZ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumNZ
            | val GHC.Classes.== "OM" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumOM
            | val GHC.Classes.== "PA" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPA
            | val GHC.Classes.== "PE" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPE
            | val GHC.Classes.== "PF" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPF
            | val GHC.Classes.== "PG" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPG
            | val GHC.Classes.== "PH" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPH
            | val GHC.Classes.== "PK" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPK
            | val GHC.Classes.== "PL" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPL
            | val GHC.Classes.== "PM" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPM
            | val GHC.Classes.== "PN" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPN
            | val GHC.Classes.== "PR" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPR
            | val GHC.Classes.== "PS" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPS
            | val GHC.Classes.== "PT" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPT
            | val GHC.Classes.== "PY" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumPY
            | val GHC.Classes.== "QA" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumQA
            | val GHC.Classes.== "RE" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumRE
            | val GHC.Classes.== "RO" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumRO
            | val GHC.Classes.== "RS" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumRS
            | val GHC.Classes.== "RU" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumRU
            | val GHC.Classes.== "RW" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumRW
            | val GHC.Classes.== "SA" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSA
            | val GHC.Classes.== "SB" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSB
            | val GHC.Classes.== "SC" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSC
            | val GHC.Classes.== "SE" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSE
            | val GHC.Classes.== "SG" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSG
            | val GHC.Classes.== "SH" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSH
            | val GHC.Classes.== "SI" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSI
            | val GHC.Classes.== "SJ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSJ
            | val GHC.Classes.== "SK" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSK
            | val GHC.Classes.== "SL" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSL
            | val GHC.Classes.== "SM" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSM
            | val GHC.Classes.== "SN" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSN
            | val GHC.Classes.== "SO" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSO
            | val GHC.Classes.== "SR" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSR
            | val GHC.Classes.== "SS" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSS
            | val GHC.Classes.== "ST" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumST
            | val GHC.Classes.== "SV" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSV
            | val GHC.Classes.== "SX" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSX
            | val GHC.Classes.== "SZ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumSZ
            | val GHC.Classes.== "TA" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTA
            | val GHC.Classes.== "TC" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTC
            | val GHC.Classes.== "TD" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTD
            | val GHC.Classes.== "TF" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTF
            | val GHC.Classes.== "TG" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTG
            | val GHC.Classes.== "TH" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTH
            | val GHC.Classes.== "TJ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTJ
            | val GHC.Classes.== "TK" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTK
            | val GHC.Classes.== "TL" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTL
            | val GHC.Classes.== "TM" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTM
            | val GHC.Classes.== "TN" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTN
            | val GHC.Classes.== "TO" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTO
            | val GHC.Classes.== "TR" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTR
            | val GHC.Classes.== "TT" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTT
            | val GHC.Classes.== "TV" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTV
            | val GHC.Classes.== "TW" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTW
            | val GHC.Classes.== "TZ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumTZ
            | val GHC.Classes.== "UA" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumUA
            | val GHC.Classes.== "UG" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumUG
            | val GHC.Classes.== "US" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumUS
            | val GHC.Classes.== "UY" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumUY
            | val GHC.Classes.== "UZ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumUZ
            | val GHC.Classes.== "VA" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVA
            | val GHC.Classes.== "VC" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVC
            | val GHC.Classes.== "VE" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVE
            | val GHC.Classes.== "VG" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVG
            | val GHC.Classes.== "VN" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVN
            | val GHC.Classes.== "VU" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumVU
            | val GHC.Classes.== "WF" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumWF
            | val GHC.Classes.== "WS" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumWS
            | val GHC.Classes.== "XK" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumXK
            | val GHC.Classes.== "YE" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumYE
            | val GHC.Classes.== "YT" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumYT
            | val GHC.Classes.== "ZA" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumZA
            | val GHC.Classes.== "ZM" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumZM
            | val GHC.Classes.== "ZW" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumZW
            | val GHC.Classes.== "ZZ" -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'EnumZZ
            | GHC.Base.otherwise -> PaymentPagesCheckoutSessionShippingAddressCollectionAllowedCountries'Other val
      )
