{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema PortalSubscriptionCancellationReason
module StripeAPI.Types.PortalSubscriptionCancellationReason where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.portal_subscription_cancellation_reason@ in the specification.
data PortalSubscriptionCancellationReason = PortalSubscriptionCancellationReason
  { -- | enabled: Whether the feature is enabled.
    portalSubscriptionCancellationReasonEnabled :: GHC.Types.Bool,
    -- | options: Which cancellation reasons will be given as options to the customer.
    portalSubscriptionCancellationReasonOptions :: ([PortalSubscriptionCancellationReasonOptions'])
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PortalSubscriptionCancellationReason where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= portalSubscriptionCancellationReasonEnabled obj] : ["options" Data.Aeson.Types.ToJSON..= portalSubscriptionCancellationReasonOptions obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= portalSubscriptionCancellationReasonEnabled obj] : ["options" Data.Aeson.Types.ToJSON..= portalSubscriptionCancellationReasonOptions obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PortalSubscriptionCancellationReason where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PortalSubscriptionCancellationReason" (\obj -> (GHC.Base.pure PortalSubscriptionCancellationReason GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "options"))

-- | Create a new 'PortalSubscriptionCancellationReason' with all required fields.
mkPortalSubscriptionCancellationReason ::
  -- | 'portalSubscriptionCancellationReasonEnabled'
  GHC.Types.Bool ->
  -- | 'portalSubscriptionCancellationReasonOptions'
  [PortalSubscriptionCancellationReasonOptions'] ->
  PortalSubscriptionCancellationReason
mkPortalSubscriptionCancellationReason portalSubscriptionCancellationReasonEnabled portalSubscriptionCancellationReasonOptions =
  PortalSubscriptionCancellationReason
    { portalSubscriptionCancellationReasonEnabled = portalSubscriptionCancellationReasonEnabled,
      portalSubscriptionCancellationReasonOptions = portalSubscriptionCancellationReasonOptions
    }

-- | Defines the enum schema located at @components.schemas.portal_subscription_cancellation_reason.properties.options.items@ in the specification.
data PortalSubscriptionCancellationReasonOptions'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PortalSubscriptionCancellationReasonOptions'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PortalSubscriptionCancellationReasonOptions'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"customer_service"@
    PortalSubscriptionCancellationReasonOptions'EnumCustomerService
  | -- | Represents the JSON value @"low_quality"@
    PortalSubscriptionCancellationReasonOptions'EnumLowQuality
  | -- | Represents the JSON value @"missing_features"@
    PortalSubscriptionCancellationReasonOptions'EnumMissingFeatures
  | -- | Represents the JSON value @"other"@
    PortalSubscriptionCancellationReasonOptions'EnumOther
  | -- | Represents the JSON value @"switched_service"@
    PortalSubscriptionCancellationReasonOptions'EnumSwitchedService
  | -- | Represents the JSON value @"too_complex"@
    PortalSubscriptionCancellationReasonOptions'EnumTooComplex
  | -- | Represents the JSON value @"too_expensive"@
    PortalSubscriptionCancellationReasonOptions'EnumTooExpensive
  | -- | Represents the JSON value @"unused"@
    PortalSubscriptionCancellationReasonOptions'EnumUnused
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PortalSubscriptionCancellationReasonOptions' where
  toJSON (PortalSubscriptionCancellationReasonOptions'Other val) = val
  toJSON (PortalSubscriptionCancellationReasonOptions'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PortalSubscriptionCancellationReasonOptions'EnumCustomerService) = "customer_service"
  toJSON (PortalSubscriptionCancellationReasonOptions'EnumLowQuality) = "low_quality"
  toJSON (PortalSubscriptionCancellationReasonOptions'EnumMissingFeatures) = "missing_features"
  toJSON (PortalSubscriptionCancellationReasonOptions'EnumOther) = "other"
  toJSON (PortalSubscriptionCancellationReasonOptions'EnumSwitchedService) = "switched_service"
  toJSON (PortalSubscriptionCancellationReasonOptions'EnumTooComplex) = "too_complex"
  toJSON (PortalSubscriptionCancellationReasonOptions'EnumTooExpensive) = "too_expensive"
  toJSON (PortalSubscriptionCancellationReasonOptions'EnumUnused) = "unused"

instance Data.Aeson.Types.FromJSON.FromJSON PortalSubscriptionCancellationReasonOptions' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "customer_service" -> PortalSubscriptionCancellationReasonOptions'EnumCustomerService
            | val GHC.Classes.== "low_quality" -> PortalSubscriptionCancellationReasonOptions'EnumLowQuality
            | val GHC.Classes.== "missing_features" -> PortalSubscriptionCancellationReasonOptions'EnumMissingFeatures
            | val GHC.Classes.== "other" -> PortalSubscriptionCancellationReasonOptions'EnumOther
            | val GHC.Classes.== "switched_service" -> PortalSubscriptionCancellationReasonOptions'EnumSwitchedService
            | val GHC.Classes.== "too_complex" -> PortalSubscriptionCancellationReasonOptions'EnumTooComplex
            | val GHC.Classes.== "too_expensive" -> PortalSubscriptionCancellationReasonOptions'EnumTooExpensive
            | val GHC.Classes.== "unused" -> PortalSubscriptionCancellationReasonOptions'EnumUnused
            | GHC.Base.otherwise -> PortalSubscriptionCancellationReasonOptions'Other val
      )
