{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema SecretServiceResourceScope
module StripeAPI.Types.SecretServiceResourceScope where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.secret_service_resource_scope@ in the specification.
data SecretServiceResourceScope = SecretServiceResourceScope
  { -- | type: The secret scope type.
    secretServiceResourceScopeType :: SecretServiceResourceScopeType',
    -- | user: The user ID, if type is set to \"user\"
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    secretServiceResourceScopeUser :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON SecretServiceResourceScope where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["type" Data.Aeson.Types.ToJSON..= secretServiceResourceScopeType obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("user" Data.Aeson.Types.ToJSON..=)) (secretServiceResourceScopeUser obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["type" Data.Aeson.Types.ToJSON..= secretServiceResourceScopeType obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("user" Data.Aeson.Types.ToJSON..=)) (secretServiceResourceScopeUser obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON SecretServiceResourceScope where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "SecretServiceResourceScope" (\obj -> (GHC.Base.pure SecretServiceResourceScope GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "type")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "user"))

-- | Create a new 'SecretServiceResourceScope' with all required fields.
mkSecretServiceResourceScope ::
  -- | 'secretServiceResourceScopeType'
  SecretServiceResourceScopeType' ->
  SecretServiceResourceScope
mkSecretServiceResourceScope secretServiceResourceScopeType =
  SecretServiceResourceScope
    { secretServiceResourceScopeType = secretServiceResourceScopeType,
      secretServiceResourceScopeUser = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.secret_service_resource_scope.properties.type@ in the specification.
--
-- The secret scope type.
data SecretServiceResourceScopeType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    SecretServiceResourceScopeType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    SecretServiceResourceScopeType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"account"@
    SecretServiceResourceScopeType'EnumAccount
  | -- | Represents the JSON value @"user"@
    SecretServiceResourceScopeType'EnumUser
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON SecretServiceResourceScopeType' where
  toJSON (SecretServiceResourceScopeType'Other val) = val
  toJSON (SecretServiceResourceScopeType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (SecretServiceResourceScopeType'EnumAccount) = "account"
  toJSON (SecretServiceResourceScopeType'EnumUser) = "user"

instance Data.Aeson.Types.FromJSON.FromJSON SecretServiceResourceScopeType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "account" -> SecretServiceResourceScopeType'EnumAccount
            | val GHC.Classes.== "user" -> SecretServiceResourceScopeType'EnumUser
            | GHC.Base.otherwise -> SecretServiceResourceScopeType'Other val
      )
