{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema ShippingRateDeliveryEstimate
module StripeAPI.Types.ShippingRateDeliveryEstimate where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.ShippingRateDeliveryEstimateBound
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.shipping_rate_delivery_estimate@ in the specification.
data ShippingRateDeliveryEstimate = ShippingRateDeliveryEstimate
  { -- | maximum: The upper bound of the estimated range. If empty, represents no upper bound i.e., infinite.
    shippingRateDeliveryEstimateMaximum :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable ShippingRateDeliveryEstimateMaximum'NonNullable)),
    -- | minimum: The lower bound of the estimated range. If empty, represents no lower bound.
    shippingRateDeliveryEstimateMinimum :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable ShippingRateDeliveryEstimateMinimum'NonNullable))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON ShippingRateDeliveryEstimate where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("maximum" Data.Aeson.Types.ToJSON..=)) (shippingRateDeliveryEstimateMaximum obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("minimum" Data.Aeson.Types.ToJSON..=)) (shippingRateDeliveryEstimateMinimum obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("maximum" Data.Aeson.Types.ToJSON..=)) (shippingRateDeliveryEstimateMaximum obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("minimum" Data.Aeson.Types.ToJSON..=)) (shippingRateDeliveryEstimateMinimum obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON ShippingRateDeliveryEstimate where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "ShippingRateDeliveryEstimate" (\obj -> (GHC.Base.pure ShippingRateDeliveryEstimate GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "maximum")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "minimum"))

-- | Create a new 'ShippingRateDeliveryEstimate' with all required fields.
mkShippingRateDeliveryEstimate :: ShippingRateDeliveryEstimate
mkShippingRateDeliveryEstimate =
  ShippingRateDeliveryEstimate
    { shippingRateDeliveryEstimateMaximum = GHC.Maybe.Nothing,
      shippingRateDeliveryEstimateMinimum = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @components.schemas.shipping_rate_delivery_estimate.properties.maximum.anyOf@ in the specification.
--
-- The upper bound of the estimated range. If empty, represents no upper bound i.e., infinite.
data ShippingRateDeliveryEstimateMaximum'NonNullable = ShippingRateDeliveryEstimateMaximum'NonNullable
  { -- | unit: A unit of time.
    shippingRateDeliveryEstimateMaximum'NonNullableUnit :: (GHC.Maybe.Maybe ShippingRateDeliveryEstimateMaximum'NonNullableUnit'),
    -- | value: Must be greater than 0.
    shippingRateDeliveryEstimateMaximum'NonNullableValue :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON ShippingRateDeliveryEstimateMaximum'NonNullable where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("unit" Data.Aeson.Types.ToJSON..=)) (shippingRateDeliveryEstimateMaximum'NonNullableUnit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("value" Data.Aeson.Types.ToJSON..=)) (shippingRateDeliveryEstimateMaximum'NonNullableValue obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("unit" Data.Aeson.Types.ToJSON..=)) (shippingRateDeliveryEstimateMaximum'NonNullableUnit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("value" Data.Aeson.Types.ToJSON..=)) (shippingRateDeliveryEstimateMaximum'NonNullableValue obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON ShippingRateDeliveryEstimateMaximum'NonNullable where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "ShippingRateDeliveryEstimateMaximum'NonNullable" (\obj -> (GHC.Base.pure ShippingRateDeliveryEstimateMaximum'NonNullable GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "unit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "value"))

-- | Create a new 'ShippingRateDeliveryEstimateMaximum'NonNullable' with all required fields.
mkShippingRateDeliveryEstimateMaximum'NonNullable :: ShippingRateDeliveryEstimateMaximum'NonNullable
mkShippingRateDeliveryEstimateMaximum'NonNullable =
  ShippingRateDeliveryEstimateMaximum'NonNullable
    { shippingRateDeliveryEstimateMaximum'NonNullableUnit = GHC.Maybe.Nothing,
      shippingRateDeliveryEstimateMaximum'NonNullableValue = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.shipping_rate_delivery_estimate.properties.maximum.anyOf.properties.unit@ in the specification.
--
-- A unit of time.
data ShippingRateDeliveryEstimateMaximum'NonNullableUnit'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    ShippingRateDeliveryEstimateMaximum'NonNullableUnit'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    ShippingRateDeliveryEstimateMaximum'NonNullableUnit'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"business_day"@
    ShippingRateDeliveryEstimateMaximum'NonNullableUnit'EnumBusinessDay
  | -- | Represents the JSON value @"day"@
    ShippingRateDeliveryEstimateMaximum'NonNullableUnit'EnumDay
  | -- | Represents the JSON value @"hour"@
    ShippingRateDeliveryEstimateMaximum'NonNullableUnit'EnumHour
  | -- | Represents the JSON value @"month"@
    ShippingRateDeliveryEstimateMaximum'NonNullableUnit'EnumMonth
  | -- | Represents the JSON value @"week"@
    ShippingRateDeliveryEstimateMaximum'NonNullableUnit'EnumWeek
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON ShippingRateDeliveryEstimateMaximum'NonNullableUnit' where
  toJSON (ShippingRateDeliveryEstimateMaximum'NonNullableUnit'Other val) = val
  toJSON (ShippingRateDeliveryEstimateMaximum'NonNullableUnit'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (ShippingRateDeliveryEstimateMaximum'NonNullableUnit'EnumBusinessDay) = "business_day"
  toJSON (ShippingRateDeliveryEstimateMaximum'NonNullableUnit'EnumDay) = "day"
  toJSON (ShippingRateDeliveryEstimateMaximum'NonNullableUnit'EnumHour) = "hour"
  toJSON (ShippingRateDeliveryEstimateMaximum'NonNullableUnit'EnumMonth) = "month"
  toJSON (ShippingRateDeliveryEstimateMaximum'NonNullableUnit'EnumWeek) = "week"

instance Data.Aeson.Types.FromJSON.FromJSON ShippingRateDeliveryEstimateMaximum'NonNullableUnit' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "business_day" -> ShippingRateDeliveryEstimateMaximum'NonNullableUnit'EnumBusinessDay
            | val GHC.Classes.== "day" -> ShippingRateDeliveryEstimateMaximum'NonNullableUnit'EnumDay
            | val GHC.Classes.== "hour" -> ShippingRateDeliveryEstimateMaximum'NonNullableUnit'EnumHour
            | val GHC.Classes.== "month" -> ShippingRateDeliveryEstimateMaximum'NonNullableUnit'EnumMonth
            | val GHC.Classes.== "week" -> ShippingRateDeliveryEstimateMaximum'NonNullableUnit'EnumWeek
            | GHC.Base.otherwise -> ShippingRateDeliveryEstimateMaximum'NonNullableUnit'Other val
      )

-- | Defines the object schema located at @components.schemas.shipping_rate_delivery_estimate.properties.minimum.anyOf@ in the specification.
--
-- The lower bound of the estimated range. If empty, represents no lower bound.
data ShippingRateDeliveryEstimateMinimum'NonNullable = ShippingRateDeliveryEstimateMinimum'NonNullable
  { -- | unit: A unit of time.
    shippingRateDeliveryEstimateMinimum'NonNullableUnit :: (GHC.Maybe.Maybe ShippingRateDeliveryEstimateMinimum'NonNullableUnit'),
    -- | value: Must be greater than 0.
    shippingRateDeliveryEstimateMinimum'NonNullableValue :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON ShippingRateDeliveryEstimateMinimum'NonNullable where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("unit" Data.Aeson.Types.ToJSON..=)) (shippingRateDeliveryEstimateMinimum'NonNullableUnit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("value" Data.Aeson.Types.ToJSON..=)) (shippingRateDeliveryEstimateMinimum'NonNullableValue obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("unit" Data.Aeson.Types.ToJSON..=)) (shippingRateDeliveryEstimateMinimum'NonNullableUnit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("value" Data.Aeson.Types.ToJSON..=)) (shippingRateDeliveryEstimateMinimum'NonNullableValue obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON ShippingRateDeliveryEstimateMinimum'NonNullable where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "ShippingRateDeliveryEstimateMinimum'NonNullable" (\obj -> (GHC.Base.pure ShippingRateDeliveryEstimateMinimum'NonNullable GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "unit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "value"))

-- | Create a new 'ShippingRateDeliveryEstimateMinimum'NonNullable' with all required fields.
mkShippingRateDeliveryEstimateMinimum'NonNullable :: ShippingRateDeliveryEstimateMinimum'NonNullable
mkShippingRateDeliveryEstimateMinimum'NonNullable =
  ShippingRateDeliveryEstimateMinimum'NonNullable
    { shippingRateDeliveryEstimateMinimum'NonNullableUnit = GHC.Maybe.Nothing,
      shippingRateDeliveryEstimateMinimum'NonNullableValue = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.shipping_rate_delivery_estimate.properties.minimum.anyOf.properties.unit@ in the specification.
--
-- A unit of time.
data ShippingRateDeliveryEstimateMinimum'NonNullableUnit'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    ShippingRateDeliveryEstimateMinimum'NonNullableUnit'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    ShippingRateDeliveryEstimateMinimum'NonNullableUnit'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"business_day"@
    ShippingRateDeliveryEstimateMinimum'NonNullableUnit'EnumBusinessDay
  | -- | Represents the JSON value @"day"@
    ShippingRateDeliveryEstimateMinimum'NonNullableUnit'EnumDay
  | -- | Represents the JSON value @"hour"@
    ShippingRateDeliveryEstimateMinimum'NonNullableUnit'EnumHour
  | -- | Represents the JSON value @"month"@
    ShippingRateDeliveryEstimateMinimum'NonNullableUnit'EnumMonth
  | -- | Represents the JSON value @"week"@
    ShippingRateDeliveryEstimateMinimum'NonNullableUnit'EnumWeek
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON ShippingRateDeliveryEstimateMinimum'NonNullableUnit' where
  toJSON (ShippingRateDeliveryEstimateMinimum'NonNullableUnit'Other val) = val
  toJSON (ShippingRateDeliveryEstimateMinimum'NonNullableUnit'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (ShippingRateDeliveryEstimateMinimum'NonNullableUnit'EnumBusinessDay) = "business_day"
  toJSON (ShippingRateDeliveryEstimateMinimum'NonNullableUnit'EnumDay) = "day"
  toJSON (ShippingRateDeliveryEstimateMinimum'NonNullableUnit'EnumHour) = "hour"
  toJSON (ShippingRateDeliveryEstimateMinimum'NonNullableUnit'EnumMonth) = "month"
  toJSON (ShippingRateDeliveryEstimateMinimum'NonNullableUnit'EnumWeek) = "week"

instance Data.Aeson.Types.FromJSON.FromJSON ShippingRateDeliveryEstimateMinimum'NonNullableUnit' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "business_day" -> ShippingRateDeliveryEstimateMinimum'NonNullableUnit'EnumBusinessDay
            | val GHC.Classes.== "day" -> ShippingRateDeliveryEstimateMinimum'NonNullableUnit'EnumDay
            | val GHC.Classes.== "hour" -> ShippingRateDeliveryEstimateMinimum'NonNullableUnit'EnumHour
            | val GHC.Classes.== "month" -> ShippingRateDeliveryEstimateMinimum'NonNullableUnit'EnumMonth
            | val GHC.Classes.== "week" -> ShippingRateDeliveryEstimateMinimum'NonNullableUnit'EnumWeek
            | GHC.Base.otherwise -> ShippingRateDeliveryEstimateMinimum'NonNullableUnit'Other val
      )
