{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema ShippingRateFixedAmount
module StripeAPI.Types.ShippingRateFixedAmount where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.shipping_rate_fixed_amount@ in the specification.
data ShippingRateFixedAmount = ShippingRateFixedAmount
  { -- | amount: A non-negative integer in cents representing how much to charge.
    shippingRateFixedAmountAmount :: GHC.Types.Int,
    -- | currency: Three-letter [ISO currency code](https:\/\/www.iso.org\/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https:\/\/stripe.com\/docs\/currencies).
    shippingRateFixedAmountCurrency :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON ShippingRateFixedAmount where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= shippingRateFixedAmountAmount obj] : ["currency" Data.Aeson.Types.ToJSON..= shippingRateFixedAmountCurrency obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= shippingRateFixedAmountAmount obj] : ["currency" Data.Aeson.Types.ToJSON..= shippingRateFixedAmountCurrency obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON ShippingRateFixedAmount where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "ShippingRateFixedAmount" (\obj -> (GHC.Base.pure ShippingRateFixedAmount GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "currency"))

-- | Create a new 'ShippingRateFixedAmount' with all required fields.
mkShippingRateFixedAmount ::
  -- | 'shippingRateFixedAmountAmount'
  GHC.Types.Int ->
  -- | 'shippingRateFixedAmountCurrency'
  Data.Text.Internal.Text ->
  ShippingRateFixedAmount
mkShippingRateFixedAmount shippingRateFixedAmountAmount shippingRateFixedAmountCurrency =
  ShippingRateFixedAmount
    { shippingRateFixedAmountAmount = shippingRateFixedAmountAmount,
      shippingRateFixedAmountCurrency = shippingRateFixedAmountCurrency
    }
