{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema UsBankAccountNetworks
module StripeAPI.Types.UsBankAccountNetworks where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.us_bank_account_networks@ in the specification.
data UsBankAccountNetworks = UsBankAccountNetworks
  { -- | preferred: The preferred network.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    usBankAccountNetworksPreferred :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text)),
    -- | supported: All supported networks.
    usBankAccountNetworksSupported :: ([UsBankAccountNetworksSupported'])
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON UsBankAccountNetworks where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("preferred" Data.Aeson.Types.ToJSON..=)) (usBankAccountNetworksPreferred obj) : ["supported" Data.Aeson.Types.ToJSON..= usBankAccountNetworksSupported obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("preferred" Data.Aeson.Types.ToJSON..=)) (usBankAccountNetworksPreferred obj) : ["supported" Data.Aeson.Types.ToJSON..= usBankAccountNetworksSupported obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON UsBankAccountNetworks where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "UsBankAccountNetworks" (\obj -> (GHC.Base.pure UsBankAccountNetworks GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "preferred")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "supported"))

-- | Create a new 'UsBankAccountNetworks' with all required fields.
mkUsBankAccountNetworks ::
  -- | 'usBankAccountNetworksSupported'
  [UsBankAccountNetworksSupported'] ->
  UsBankAccountNetworks
mkUsBankAccountNetworks usBankAccountNetworksSupported =
  UsBankAccountNetworks
    { usBankAccountNetworksPreferred = GHC.Maybe.Nothing,
      usBankAccountNetworksSupported = usBankAccountNetworksSupported
    }

-- | Defines the enum schema located at @components.schemas.us_bank_account_networks.properties.supported.items@ in the specification.
data UsBankAccountNetworksSupported'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    UsBankAccountNetworksSupported'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    UsBankAccountNetworksSupported'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ach"@
    UsBankAccountNetworksSupported'EnumAch
  | -- | Represents the JSON value @"us_domestic_wire"@
    UsBankAccountNetworksSupported'EnumUsDomesticWire
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON UsBankAccountNetworksSupported' where
  toJSON (UsBankAccountNetworksSupported'Other val) = val
  toJSON (UsBankAccountNetworksSupported'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (UsBankAccountNetworksSupported'EnumAch) = "ach"
  toJSON (UsBankAccountNetworksSupported'EnumUsDomesticWire) = "us_domestic_wire"

instance Data.Aeson.Types.FromJSON.FromJSON UsBankAccountNetworksSupported' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ach" -> UsBankAccountNetworksSupported'EnumAch
            | val GHC.Classes.== "us_domestic_wire" -> UsBankAccountNetworksSupported'EnumUsDomesticWire
            | GHC.Base.otherwise -> UsBankAccountNetworksSupported'Other val
      )
