{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postIssuingCards
module StripeAPI.Operations.PostIssuingCards where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/issuing/cards
--
-- \<p>Creates an Issuing \<code>Card\<\/code> object.\<\/p>
postIssuingCards ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | The request body to send
  PostIssuingCardsRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response PostIssuingCardsResponse)
postIssuingCards body =
  GHC.Base.fmap
    ( \response_0 ->
        GHC.Base.fmap
          ( Data.Either.either PostIssuingCardsResponseError GHC.Base.id
              GHC.Base.. ( \response body ->
                             if
                                 | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                   PostIssuingCardsResponse200
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Issuing'card
                                                      )
                                 | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                   PostIssuingCardsResponseDefault
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Error
                                                      )
                                 | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                         )
                response_0
          )
          response_0
    )
    (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack "/v1/issuing/cards") GHC.Base.mempty (GHC.Maybe.Just body) StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/issuing\/cards.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostIssuingCardsRequestBody = PostIssuingCardsRequestBody
  { -- | cardholder: The [Cardholder](https:\/\/stripe.com\/docs\/api\#issuing_cardholder_object) object with which the card will be associated.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardsRequestBodyCardholder :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | currency: The currency for the card.
    postIssuingCardsRequestBodyCurrency :: Data.Text.Internal.Text,
    -- | expand: Specifies which fields in the response should be expanded.
    postIssuingCardsRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | financial_account
    postIssuingCardsRequestBodyFinancialAccount :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | metadata: Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`.
    postIssuingCardsRequestBodyMetadata :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | replacement_for: The card this is meant to be a replacement for (if any).
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardsRequestBodyReplacementFor :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | replacement_reason: If \`replacement_for\` is specified, this should indicate why that card is being replaced.
    postIssuingCardsRequestBodyReplacementReason :: (GHC.Maybe.Maybe PostIssuingCardsRequestBodyReplacementReason'),
    -- | shipping: The address where the card will be shipped.
    postIssuingCardsRequestBodyShipping :: (GHC.Maybe.Maybe PostIssuingCardsRequestBodyShipping'),
    -- | spending_controls: Rules that control spending for this card. Refer to our [documentation](https:\/\/stripe.com\/docs\/issuing\/controls\/spending-controls) for more details.
    postIssuingCardsRequestBodySpendingControls :: (GHC.Maybe.Maybe PostIssuingCardsRequestBodySpendingControls'),
    -- | status: Whether authorizations can be approved on this card. Defaults to \`inactive\`.
    postIssuingCardsRequestBodyStatus :: (GHC.Maybe.Maybe PostIssuingCardsRequestBodyStatus'),
    -- | type: The type of card to issue. Possible values are \`physical\` or \`virtual\`.
    postIssuingCardsRequestBodyType :: PostIssuingCardsRequestBodyType'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("cardholder" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyCardholder obj) : ["currency" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodyCurrency obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("financial_account" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyFinancialAccount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyMetadata obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("replacement_for" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyReplacementFor obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("replacement_reason" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyReplacementReason obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyShipping obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("spending_controls" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodySpendingControls obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("status" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyStatus obj) : ["type" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodyType obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("cardholder" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyCardholder obj) : ["currency" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodyCurrency obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("financial_account" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyFinancialAccount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyMetadata obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("replacement_for" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyReplacementFor obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("replacement_reason" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyReplacementReason obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyShipping obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("spending_controls" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodySpendingControls obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("status" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyStatus obj) : ["type" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodyType obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardsRequestBody" (\obj -> ((((((((((GHC.Base.pure PostIssuingCardsRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "cardholder")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "currency")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "financial_account")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "replacement_for")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "replacement_reason")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "shipping")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "spending_controls")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "status")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "type"))

-- | Create a new 'PostIssuingCardsRequestBody' with all required fields.
mkPostIssuingCardsRequestBody ::
  -- | 'postIssuingCardsRequestBodyCurrency'
  Data.Text.Internal.Text ->
  -- | 'postIssuingCardsRequestBodyType'
  PostIssuingCardsRequestBodyType' ->
  PostIssuingCardsRequestBody
mkPostIssuingCardsRequestBody postIssuingCardsRequestBodyCurrency postIssuingCardsRequestBodyType =
  PostIssuingCardsRequestBody
    { postIssuingCardsRequestBodyCardholder = GHC.Maybe.Nothing,
      postIssuingCardsRequestBodyCurrency = postIssuingCardsRequestBodyCurrency,
      postIssuingCardsRequestBodyExpand = GHC.Maybe.Nothing,
      postIssuingCardsRequestBodyFinancialAccount = GHC.Maybe.Nothing,
      postIssuingCardsRequestBodyMetadata = GHC.Maybe.Nothing,
      postIssuingCardsRequestBodyReplacementFor = GHC.Maybe.Nothing,
      postIssuingCardsRequestBodyReplacementReason = GHC.Maybe.Nothing,
      postIssuingCardsRequestBodyShipping = GHC.Maybe.Nothing,
      postIssuingCardsRequestBodySpendingControls = GHC.Maybe.Nothing,
      postIssuingCardsRequestBodyStatus = GHC.Maybe.Nothing,
      postIssuingCardsRequestBodyType = postIssuingCardsRequestBodyType
    }

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cards.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.replacement_reason@ in the specification.
--
-- If \`replacement_for\` is specified, this should indicate why that card is being replaced.
data PostIssuingCardsRequestBodyReplacementReason'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardsRequestBodyReplacementReason'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardsRequestBodyReplacementReason'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"damaged"@
    PostIssuingCardsRequestBodyReplacementReason'EnumDamaged
  | -- | Represents the JSON value @"expired"@
    PostIssuingCardsRequestBodyReplacementReason'EnumExpired
  | -- | Represents the JSON value @"lost"@
    PostIssuingCardsRequestBodyReplacementReason'EnumLost
  | -- | Represents the JSON value @"stolen"@
    PostIssuingCardsRequestBodyReplacementReason'EnumStolen
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsRequestBodyReplacementReason' where
  toJSON (PostIssuingCardsRequestBodyReplacementReason'Other val) = val
  toJSON (PostIssuingCardsRequestBodyReplacementReason'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardsRequestBodyReplacementReason'EnumDamaged) = "damaged"
  toJSON (PostIssuingCardsRequestBodyReplacementReason'EnumExpired) = "expired"
  toJSON (PostIssuingCardsRequestBodyReplacementReason'EnumLost) = "lost"
  toJSON (PostIssuingCardsRequestBodyReplacementReason'EnumStolen) = "stolen"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsRequestBodyReplacementReason' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "damaged" -> PostIssuingCardsRequestBodyReplacementReason'EnumDamaged
            | val GHC.Classes.== "expired" -> PostIssuingCardsRequestBodyReplacementReason'EnumExpired
            | val GHC.Classes.== "lost" -> PostIssuingCardsRequestBodyReplacementReason'EnumLost
            | val GHC.Classes.== "stolen" -> PostIssuingCardsRequestBodyReplacementReason'EnumStolen
            | GHC.Base.otherwise -> PostIssuingCardsRequestBodyReplacementReason'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/issuing\/cards.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping@ in the specification.
--
-- The address where the card will be shipped.
data PostIssuingCardsRequestBodyShipping' = PostIssuingCardsRequestBodyShipping'
  { -- | address
    postIssuingCardsRequestBodyShipping'Address :: PostIssuingCardsRequestBodyShipping'Address',
    -- | name
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardsRequestBodyShipping'Name :: Data.Text.Internal.Text,
    -- | service
    postIssuingCardsRequestBodyShipping'Service :: (GHC.Maybe.Maybe PostIssuingCardsRequestBodyShipping'Service'),
    -- | type
    postIssuingCardsRequestBodyShipping'Type :: (GHC.Maybe.Maybe PostIssuingCardsRequestBodyShipping'Type')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsRequestBodyShipping' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["address" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodyShipping'Address obj] : ["name" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodyShipping'Name obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("service" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyShipping'Service obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("type" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyShipping'Type obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["address" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodyShipping'Address obj] : ["name" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodyShipping'Name obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("service" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyShipping'Service obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("type" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyShipping'Type obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsRequestBodyShipping' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardsRequestBodyShipping'" (\obj -> (((GHC.Base.pure PostIssuingCardsRequestBodyShipping' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "address")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "service")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "type"))

-- | Create a new 'PostIssuingCardsRequestBodyShipping'' with all required fields.
mkPostIssuingCardsRequestBodyShipping' ::
  -- | 'postIssuingCardsRequestBodyShipping'Address'
  PostIssuingCardsRequestBodyShipping'Address' ->
  -- | 'postIssuingCardsRequestBodyShipping'Name'
  Data.Text.Internal.Text ->
  PostIssuingCardsRequestBodyShipping'
mkPostIssuingCardsRequestBodyShipping' postIssuingCardsRequestBodyShipping'Address postIssuingCardsRequestBodyShipping'Name =
  PostIssuingCardsRequestBodyShipping'
    { postIssuingCardsRequestBodyShipping'Address = postIssuingCardsRequestBodyShipping'Address,
      postIssuingCardsRequestBodyShipping'Name = postIssuingCardsRequestBodyShipping'Name,
      postIssuingCardsRequestBodyShipping'Service = GHC.Maybe.Nothing,
      postIssuingCardsRequestBodyShipping'Type = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/issuing\/cards.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping.properties.address@ in the specification.
data PostIssuingCardsRequestBodyShipping'Address' = PostIssuingCardsRequestBodyShipping'Address'
  { -- | city
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardsRequestBodyShipping'Address'City :: Data.Text.Internal.Text,
    -- | country
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardsRequestBodyShipping'Address'Country :: Data.Text.Internal.Text,
    -- | line1
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardsRequestBodyShipping'Address'Line1 :: Data.Text.Internal.Text,
    -- | line2
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardsRequestBodyShipping'Address'Line2 :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | postal_code
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardsRequestBodyShipping'Address'PostalCode :: Data.Text.Internal.Text,
    -- | state
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardsRequestBodyShipping'Address'State :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsRequestBodyShipping'Address' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["city" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodyShipping'Address'City obj] : ["country" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodyShipping'Address'Country obj] : ["line1" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodyShipping'Address'Line1 obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line2" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyShipping'Address'Line2 obj) : ["postal_code" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodyShipping'Address'PostalCode obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("state" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyShipping'Address'State obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["city" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodyShipping'Address'City obj] : ["country" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodyShipping'Address'Country obj] : ["line1" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodyShipping'Address'Line1 obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line2" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyShipping'Address'Line2 obj) : ["postal_code" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodyShipping'Address'PostalCode obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("state" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodyShipping'Address'State obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsRequestBodyShipping'Address' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardsRequestBodyShipping'Address'" (\obj -> (((((GHC.Base.pure PostIssuingCardsRequestBodyShipping'Address' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "city")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "country")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "line1")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "line2")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "postal_code")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "state"))

-- | Create a new 'PostIssuingCardsRequestBodyShipping'Address'' with all required fields.
mkPostIssuingCardsRequestBodyShipping'Address' ::
  -- | 'postIssuingCardsRequestBodyShipping'Address'City'
  Data.Text.Internal.Text ->
  -- | 'postIssuingCardsRequestBodyShipping'Address'Country'
  Data.Text.Internal.Text ->
  -- | 'postIssuingCardsRequestBodyShipping'Address'Line1'
  Data.Text.Internal.Text ->
  -- | 'postIssuingCardsRequestBodyShipping'Address'PostalCode'
  Data.Text.Internal.Text ->
  PostIssuingCardsRequestBodyShipping'Address'
mkPostIssuingCardsRequestBodyShipping'Address' postIssuingCardsRequestBodyShipping'Address'City postIssuingCardsRequestBodyShipping'Address'Country postIssuingCardsRequestBodyShipping'Address'Line1 postIssuingCardsRequestBodyShipping'Address'PostalCode =
  PostIssuingCardsRequestBodyShipping'Address'
    { postIssuingCardsRequestBodyShipping'Address'City = postIssuingCardsRequestBodyShipping'Address'City,
      postIssuingCardsRequestBodyShipping'Address'Country = postIssuingCardsRequestBodyShipping'Address'Country,
      postIssuingCardsRequestBodyShipping'Address'Line1 = postIssuingCardsRequestBodyShipping'Address'Line1,
      postIssuingCardsRequestBodyShipping'Address'Line2 = GHC.Maybe.Nothing,
      postIssuingCardsRequestBodyShipping'Address'PostalCode = postIssuingCardsRequestBodyShipping'Address'PostalCode,
      postIssuingCardsRequestBodyShipping'Address'State = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cards.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping.properties.service@ in the specification.
data PostIssuingCardsRequestBodyShipping'Service'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardsRequestBodyShipping'Service'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardsRequestBodyShipping'Service'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"express"@
    PostIssuingCardsRequestBodyShipping'Service'EnumExpress
  | -- | Represents the JSON value @"priority"@
    PostIssuingCardsRequestBodyShipping'Service'EnumPriority
  | -- | Represents the JSON value @"standard"@
    PostIssuingCardsRequestBodyShipping'Service'EnumStandard
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsRequestBodyShipping'Service' where
  toJSON (PostIssuingCardsRequestBodyShipping'Service'Other val) = val
  toJSON (PostIssuingCardsRequestBodyShipping'Service'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardsRequestBodyShipping'Service'EnumExpress) = "express"
  toJSON (PostIssuingCardsRequestBodyShipping'Service'EnumPriority) = "priority"
  toJSON (PostIssuingCardsRequestBodyShipping'Service'EnumStandard) = "standard"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsRequestBodyShipping'Service' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "express" -> PostIssuingCardsRequestBodyShipping'Service'EnumExpress
            | val GHC.Classes.== "priority" -> PostIssuingCardsRequestBodyShipping'Service'EnumPriority
            | val GHC.Classes.== "standard" -> PostIssuingCardsRequestBodyShipping'Service'EnumStandard
            | GHC.Base.otherwise -> PostIssuingCardsRequestBodyShipping'Service'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cards.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping.properties.type@ in the specification.
data PostIssuingCardsRequestBodyShipping'Type'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardsRequestBodyShipping'Type'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardsRequestBodyShipping'Type'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"bulk"@
    PostIssuingCardsRequestBodyShipping'Type'EnumBulk
  | -- | Represents the JSON value @"individual"@
    PostIssuingCardsRequestBodyShipping'Type'EnumIndividual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsRequestBodyShipping'Type' where
  toJSON (PostIssuingCardsRequestBodyShipping'Type'Other val) = val
  toJSON (PostIssuingCardsRequestBodyShipping'Type'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardsRequestBodyShipping'Type'EnumBulk) = "bulk"
  toJSON (PostIssuingCardsRequestBodyShipping'Type'EnumIndividual) = "individual"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsRequestBodyShipping'Type' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "bulk" -> PostIssuingCardsRequestBodyShipping'Type'EnumBulk
            | val GHC.Classes.== "individual" -> PostIssuingCardsRequestBodyShipping'Type'EnumIndividual
            | GHC.Base.otherwise -> PostIssuingCardsRequestBodyShipping'Type'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/issuing\/cards.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls@ in the specification.
--
-- Rules that control spending for this card. Refer to our [documentation](https:\/\/stripe.com\/docs\/issuing\/controls\/spending-controls) for more details.
data PostIssuingCardsRequestBodySpendingControls' = PostIssuingCardsRequestBodySpendingControls'
  { -- | allowed_categories
    postIssuingCardsRequestBodySpendingControls'AllowedCategories :: (GHC.Maybe.Maybe ([PostIssuingCardsRequestBodySpendingControls'AllowedCategories'])),
    -- | blocked_categories
    postIssuingCardsRequestBodySpendingControls'BlockedCategories :: (GHC.Maybe.Maybe ([PostIssuingCardsRequestBodySpendingControls'BlockedCategories'])),
    -- | spending_limits
    postIssuingCardsRequestBodySpendingControls'SpendingLimits :: (GHC.Maybe.Maybe ([PostIssuingCardsRequestBodySpendingControls'SpendingLimits']))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsRequestBodySpendingControls' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("allowed_categories" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodySpendingControls'AllowedCategories obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("blocked_categories" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodySpendingControls'BlockedCategories obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("spending_limits" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodySpendingControls'SpendingLimits obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("allowed_categories" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodySpendingControls'AllowedCategories obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("blocked_categories" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodySpendingControls'BlockedCategories obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("spending_limits" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodySpendingControls'SpendingLimits obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsRequestBodySpendingControls' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardsRequestBodySpendingControls'" (\obj -> ((GHC.Base.pure PostIssuingCardsRequestBodySpendingControls' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "allowed_categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "blocked_categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "spending_limits"))

-- | Create a new 'PostIssuingCardsRequestBodySpendingControls'' with all required fields.
mkPostIssuingCardsRequestBodySpendingControls' :: PostIssuingCardsRequestBodySpendingControls'
mkPostIssuingCardsRequestBodySpendingControls' =
  PostIssuingCardsRequestBodySpendingControls'
    { postIssuingCardsRequestBodySpendingControls'AllowedCategories = GHC.Maybe.Nothing,
      postIssuingCardsRequestBodySpendingControls'BlockedCategories = GHC.Maybe.Nothing,
      postIssuingCardsRequestBodySpendingControls'SpendingLimits = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cards.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.allowed_categories.items@ in the specification.
data PostIssuingCardsRequestBodySpendingControls'AllowedCategories'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsRequestBodySpendingControls'AllowedCategories' where
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'Other val) = val
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAdvertisingServices) = "advertising_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAmbulanceServices) = "ambulance_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAntiqueReproductions) = "antique_reproductions"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAntiqueShops) = "antique_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAquariums) = "aquariums"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutoPaintShops) = "auto_paint_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutoServiceShops) = "auto_service_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutomobileAssociations) = "automobile_associations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBakeries) = "bakeries"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBandsOrchestras) = "bands_orchestras"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBicycleShops) = "bicycle_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBoatDealers) = "boat_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBookStores) = "book_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBowlingAlleys) = "bowling_alleys"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBusLines) = "bus_lines"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarWashes) = "car_washes"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarpentryServices) = "carpentry_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCaterers) = "caterers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumChildCareServices) = "child_care_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumChiropractors) = "chiropractors"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumClothingRental) = "clothing_rental"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCollegesUniversities) = "colleges_universities"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCommercialEquipment) = "commercial_equipment"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCommercialFootwear) = "commercial_footwear"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumComputerNetworkServices) = "computer_network_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumComputerProgramming) = "computer_programming"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumComputerRepair) = "computer_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumConcreteWorkServices) = "concrete_work_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumConstructionMaterials) = "construction_materials"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCosmeticStores) = "cosmetic_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCounselingServices) = "counseling_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCountryClubs) = "country_clubs"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCourierServices) = "courier_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCourtCosts) = "court_costs"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCruiseLines) = "cruise_lines"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDairyProductsStores) = "dairy_products_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDatingEscortServices) = "dating_escort_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDepartmentStores) = "department_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDetectiveAgencies) = "detective_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDiscountStores) = "discount_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDoctors) = "doctors"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDrinkingPlaces) = "drinking_places"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDryCleaners) = "dry_cleaners"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDurableGoods) = "durable_goods"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDutyFreeStores) = "duty_free_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumEducationalServices) = "educational_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElectricRazorStores) = "electric_razor_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElectricalServices) = "electrical_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElectronicsStores) = "electronics_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumEquipmentRental) = "equipment_rental"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumExterminatingServices) = "exterminating_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFinancialInstitutions) = "financial_institutions"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFlorists) = "florists"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGeneralServices) = "general_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGovernmentServices) = "government_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHardwareStores) = "hardware_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHospitals) = "hospitals"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumIndustrialSupplies) = "industrial_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumInsuranceDefault) = "insurance_default"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLandscapingServices) = "landscaping_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLaundries) = "laundries"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMassageParlors) = "massage_parlors"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMedicalServices) = "medical_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMembershipOrganizations) = "membership_organizations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMetalServiceCenters) = "metal_service_centers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneous) = "miscellaneous"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNondurableGoods) = "nondurable_goods"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumOsteopaths) = "osteopaths"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPassengerRailways) = "passenger_railways"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPawnShops) = "pawn_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPhotoDeveloping) = "photo_developing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPhotographicStudios) = "photographic_studios"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPictureVideoProduction) = "picture_video_production"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPoliticalOrganizations) = "political_organizations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumProfessionalServices) = "professional_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumRailroads) = "railroads"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumRecordStores) = "record_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumReligiousOrganizations) = "religious_organizations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumServiceStations) = "service_stations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumShoeStores) = "shoe_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSpecialTradeServices) = "special_trade_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTailorsAlterations) = "tailors_alterations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationServices) = "telecommunication_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTelegraphServices) = "telegraph_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTestingLaboratories) = "testing_laboratories"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTimeshares) = "timeshares"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTowingServices) = "towing_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTransportationServices) = "transportation_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTypewriterStores) = "typewriter_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumUtilities) = "utilities"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVarietyStores) = "variety_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVeterinaryServices) = "veterinary_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVideoGameArcades) = "video_game_arcades"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWeldingRepair) = "welding_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWholesaleClubs) = "wholesale_clubs"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsRequestBodySpendingControls'AllowedCategories' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCountryClubs
            | val GHC.Classes.== "courier_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCourierServices
            | val GHC.Classes.== "court_costs" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDiscountStores
            | val GHC.Classes.== "doctors" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLandscapingServices
            | val GHC.Classes.== "laundries" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumUtilities
            | val GHC.Classes.== "variety_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'EnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> PostIssuingCardsRequestBodySpendingControls'AllowedCategories'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cards.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.blocked_categories.items@ in the specification.
data PostIssuingCardsRequestBodySpendingControls'BlockedCategories'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsRequestBodySpendingControls'BlockedCategories' where
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'Other val) = val
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAdvertisingServices) = "advertising_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAmbulanceServices) = "ambulance_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAntiqueReproductions) = "antique_reproductions"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAntiqueShops) = "antique_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAquariums) = "aquariums"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutoPaintShops) = "auto_paint_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutoServiceShops) = "auto_service_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutomobileAssociations) = "automobile_associations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBakeries) = "bakeries"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBandsOrchestras) = "bands_orchestras"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBicycleShops) = "bicycle_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBoatDealers) = "boat_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBookStores) = "book_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBowlingAlleys) = "bowling_alleys"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBusLines) = "bus_lines"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarWashes) = "car_washes"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarpentryServices) = "carpentry_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCaterers) = "caterers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumChildCareServices) = "child_care_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumChiropractors) = "chiropractors"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumClothingRental) = "clothing_rental"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCollegesUniversities) = "colleges_universities"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCommercialEquipment) = "commercial_equipment"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCommercialFootwear) = "commercial_footwear"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumComputerNetworkServices) = "computer_network_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumComputerProgramming) = "computer_programming"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumComputerRepair) = "computer_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumConcreteWorkServices) = "concrete_work_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumConstructionMaterials) = "construction_materials"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCosmeticStores) = "cosmetic_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCounselingServices) = "counseling_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCountryClubs) = "country_clubs"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCourierServices) = "courier_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCourtCosts) = "court_costs"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCruiseLines) = "cruise_lines"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDairyProductsStores) = "dairy_products_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDatingEscortServices) = "dating_escort_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDepartmentStores) = "department_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDetectiveAgencies) = "detective_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDiscountStores) = "discount_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDoctors) = "doctors"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDrinkingPlaces) = "drinking_places"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDryCleaners) = "dry_cleaners"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDurableGoods) = "durable_goods"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDutyFreeStores) = "duty_free_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumEducationalServices) = "educational_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElectricRazorStores) = "electric_razor_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElectricalServices) = "electrical_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElectronicsStores) = "electronics_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumEquipmentRental) = "equipment_rental"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumExterminatingServices) = "exterminating_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFinancialInstitutions) = "financial_institutions"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFlorists) = "florists"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGeneralServices) = "general_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGovernmentServices) = "government_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHardwareStores) = "hardware_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHospitals) = "hospitals"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumIndustrialSupplies) = "industrial_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumInsuranceDefault) = "insurance_default"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLandscapingServices) = "landscaping_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLaundries) = "laundries"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMassageParlors) = "massage_parlors"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMedicalServices) = "medical_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMembershipOrganizations) = "membership_organizations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMetalServiceCenters) = "metal_service_centers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneous) = "miscellaneous"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNondurableGoods) = "nondurable_goods"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumOsteopaths) = "osteopaths"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPassengerRailways) = "passenger_railways"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPawnShops) = "pawn_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPhotoDeveloping) = "photo_developing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPhotographicStudios) = "photographic_studios"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPictureVideoProduction) = "picture_video_production"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPoliticalOrganizations) = "political_organizations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumProfessionalServices) = "professional_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumRailroads) = "railroads"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumRecordStores) = "record_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumReligiousOrganizations) = "religious_organizations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumServiceStations) = "service_stations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumShoeStores) = "shoe_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSpecialTradeServices) = "special_trade_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTailorsAlterations) = "tailors_alterations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationServices) = "telecommunication_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTelegraphServices) = "telegraph_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTestingLaboratories) = "testing_laboratories"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTimeshares) = "timeshares"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTowingServices) = "towing_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTransportationServices) = "transportation_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTypewriterStores) = "typewriter_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumUtilities) = "utilities"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVarietyStores) = "variety_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVeterinaryServices) = "veterinary_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVideoGameArcades) = "video_game_arcades"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWeldingRepair) = "welding_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWholesaleClubs) = "wholesale_clubs"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsRequestBodySpendingControls'BlockedCategories' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCountryClubs
            | val GHC.Classes.== "courier_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCourierServices
            | val GHC.Classes.== "court_costs" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDiscountStores
            | val GHC.Classes.== "doctors" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLandscapingServices
            | val GHC.Classes.== "laundries" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumUtilities
            | val GHC.Classes.== "variety_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'EnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> PostIssuingCardsRequestBodySpendingControls'BlockedCategories'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/issuing\/cards.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.spending_limits.items@ in the specification.
data PostIssuingCardsRequestBodySpendingControls'SpendingLimits' = PostIssuingCardsRequestBodySpendingControls'SpendingLimits'
  { -- | amount
    postIssuingCardsRequestBodySpendingControls'SpendingLimits'Amount :: GHC.Types.Int,
    -- | categories
    postIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories :: (GHC.Maybe.Maybe ([PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'])),
    -- | interval
    postIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval :: PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsRequestBodySpendingControls'SpendingLimits' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodySpendingControls'SpendingLimits'Amount obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("categories" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories obj) : ["interval" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodySpendingControls'SpendingLimits'Amount obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("categories" Data.Aeson.Types.ToJSON..=)) (postIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories obj) : ["interval" Data.Aeson.Types.ToJSON..= postIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsRequestBodySpendingControls'SpendingLimits' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardsRequestBodySpendingControls'SpendingLimits'" (\obj -> ((GHC.Base.pure PostIssuingCardsRequestBodySpendingControls'SpendingLimits' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "interval"))

-- | Create a new 'PostIssuingCardsRequestBodySpendingControls'SpendingLimits'' with all required fields.
mkPostIssuingCardsRequestBodySpendingControls'SpendingLimits' ::
  -- | 'postIssuingCardsRequestBodySpendingControls'SpendingLimits'Amount'
  GHC.Types.Int ->
  -- | 'postIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'
  PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval' ->
  PostIssuingCardsRequestBodySpendingControls'SpendingLimits'
mkPostIssuingCardsRequestBodySpendingControls'SpendingLimits' postIssuingCardsRequestBodySpendingControls'SpendingLimits'Amount postIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval =
  PostIssuingCardsRequestBodySpendingControls'SpendingLimits'
    { postIssuingCardsRequestBodySpendingControls'SpendingLimits'Amount = postIssuingCardsRequestBodySpendingControls'SpendingLimits'Amount,
      postIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories = GHC.Maybe.Nothing,
      postIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval = postIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval
    }

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cards.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.spending_limits.items.properties.categories.items@ in the specification.
data PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories' where
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'Other val) = val
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAdvertisingServices) = "advertising_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAmbulanceServices) = "ambulance_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueReproductions) = "antique_reproductions"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueShops) = "antique_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAquariums) = "aquariums"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoPaintShops) = "auto_paint_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoServiceShops) = "auto_service_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomobileAssociations) = "automobile_associations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBakeries) = "bakeries"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBandsOrchestras) = "bands_orchestras"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBicycleShops) = "bicycle_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatDealers) = "boat_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBookStores) = "book_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBowlingAlleys) = "bowling_alleys"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBusLines) = "bus_lines"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarWashes) = "car_washes"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpentryServices) = "carpentry_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCaterers) = "caterers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumChildCareServices) = "child_care_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropractors) = "chiropractors"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumClothingRental) = "clothing_rental"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCollegesUniversities) = "colleges_universities"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialEquipment) = "commercial_equipment"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialFootwear) = "commercial_footwear"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerNetworkServices) = "computer_network_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerProgramming) = "computer_programming"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerRepair) = "computer_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumConcreteWorkServices) = "concrete_work_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumConstructionMaterials) = "construction_materials"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCosmeticStores) = "cosmetic_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCounselingServices) = "counseling_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCountryClubs) = "country_clubs"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCourierServices) = "courier_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCourtCosts) = "court_costs"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCruiseLines) = "cruise_lines"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDairyProductsStores) = "dairy_products_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDatingEscortServices) = "dating_escort_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDepartmentStores) = "department_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDetectiveAgencies) = "detective_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDiscountStores) = "discount_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDoctors) = "doctors"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDrinkingPlaces) = "drinking_places"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDryCleaners) = "dry_cleaners"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDurableGoods) = "durable_goods"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDutyFreeStores) = "duty_free_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumEducationalServices) = "educational_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricRazorStores) = "electric_razor_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalServices) = "electrical_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsStores) = "electronics_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumEquipmentRental) = "equipment_rental"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumExterminatingServices) = "exterminating_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFinancialInstitutions) = "financial_institutions"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFlorists) = "florists"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGeneralServices) = "general_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGovernmentServices) = "government_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareStores) = "hardware_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHospitals) = "hospitals"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumIndustrialSupplies) = "industrial_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceDefault) = "insurance_default"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLandscapingServices) = "landscaping_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundries) = "laundries"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMassageParlors) = "massage_parlors"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalServices) = "medical_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMembershipOrganizations) = "membership_organizations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMetalServiceCenters) = "metal_service_centers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneous) = "miscellaneous"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNondurableGoods) = "nondurable_goods"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumOsteopaths) = "osteopaths"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPassengerRailways) = "passenger_railways"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPawnShops) = "pawn_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotoDeveloping) = "photo_developing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicStudios) = "photographic_studios"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPictureVideoProduction) = "picture_video_production"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPoliticalOrganizations) = "political_organizations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumProfessionalServices) = "professional_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumRailroads) = "railroads"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumRecordStores) = "record_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousOrganizations) = "religious_organizations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumServiceStations) = "service_stations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeStores) = "shoe_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialTradeServices) = "special_trade_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTailorsAlterations) = "tailors_alterations"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationServices) = "telecommunication_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTelegraphServices) = "telegraph_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTestingLaboratories) = "testing_laboratories"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTimeshares) = "timeshares"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTowingServices) = "towing_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTransportationServices) = "transportation_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTypewriterStores) = "typewriter_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumUtilities) = "utilities"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVarietyStores) = "variety_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVeterinaryServices) = "veterinary_services"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoGameArcades) = "video_game_arcades"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWeldingRepair) = "welding_repair"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWholesaleClubs) = "wholesale_clubs"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCountryClubs
            | val GHC.Classes.== "courier_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCourierServices
            | val GHC.Classes.== "court_costs" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDiscountStores
            | val GHC.Classes.== "doctors" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLandscapingServices
            | val GHC.Classes.== "laundries" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumUtilities
            | val GHC.Classes.== "variety_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'EnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Categories'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cards.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.spending_limits.items.properties.interval@ in the specification.
data PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"all_time"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumAllTime
  | -- | Represents the JSON value @"daily"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumDaily
  | -- | Represents the JSON value @"monthly"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumMonthly
  | -- | Represents the JSON value @"per_authorization"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumPerAuthorization
  | -- | Represents the JSON value @"weekly"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumWeekly
  | -- | Represents the JSON value @"yearly"@
    PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumYearly
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval' where
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'Other val) = val
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumAllTime) = "all_time"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumDaily) = "daily"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumMonthly) = "monthly"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumPerAuthorization) = "per_authorization"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumWeekly) = "weekly"
  toJSON (PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumYearly) = "yearly"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "all_time" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumAllTime
            | val GHC.Classes.== "daily" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumDaily
            | val GHC.Classes.== "monthly" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumMonthly
            | val GHC.Classes.== "per_authorization" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumPerAuthorization
            | val GHC.Classes.== "weekly" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumWeekly
            | val GHC.Classes.== "yearly" -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'EnumYearly
            | GHC.Base.otherwise -> PostIssuingCardsRequestBodySpendingControls'SpendingLimits'Interval'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cards.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.status@ in the specification.
--
-- Whether authorizations can be approved on this card. Defaults to \`inactive\`.
data PostIssuingCardsRequestBodyStatus'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardsRequestBodyStatus'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardsRequestBodyStatus'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"active"@
    PostIssuingCardsRequestBodyStatus'EnumActive
  | -- | Represents the JSON value @"inactive"@
    PostIssuingCardsRequestBodyStatus'EnumInactive
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsRequestBodyStatus' where
  toJSON (PostIssuingCardsRequestBodyStatus'Other val) = val
  toJSON (PostIssuingCardsRequestBodyStatus'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardsRequestBodyStatus'EnumActive) = "active"
  toJSON (PostIssuingCardsRequestBodyStatus'EnumInactive) = "inactive"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsRequestBodyStatus' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "active" -> PostIssuingCardsRequestBodyStatus'EnumActive
            | val GHC.Classes.== "inactive" -> PostIssuingCardsRequestBodyStatus'EnumInactive
            | GHC.Base.otherwise -> PostIssuingCardsRequestBodyStatus'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cards.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.type@ in the specification.
--
-- The type of card to issue. Possible values are \`physical\` or \`virtual\`.
data PostIssuingCardsRequestBodyType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardsRequestBodyType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardsRequestBodyType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"physical"@
    PostIssuingCardsRequestBodyType'EnumPhysical
  | -- | Represents the JSON value @"virtual"@
    PostIssuingCardsRequestBodyType'EnumVirtual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsRequestBodyType' where
  toJSON (PostIssuingCardsRequestBodyType'Other val) = val
  toJSON (PostIssuingCardsRequestBodyType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardsRequestBodyType'EnumPhysical) = "physical"
  toJSON (PostIssuingCardsRequestBodyType'EnumVirtual) = "virtual"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsRequestBodyType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "physical" -> PostIssuingCardsRequestBodyType'EnumPhysical
            | val GHC.Classes.== "virtual" -> PostIssuingCardsRequestBodyType'EnumVirtual
            | GHC.Base.otherwise -> PostIssuingCardsRequestBodyType'Other val
      )

-- | Represents a response of the operation 'postIssuingCards'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostIssuingCardsResponseError' is used.
data PostIssuingCardsResponse
  = -- | Means either no matching case available or a parse error
    PostIssuingCardsResponseError GHC.Base.String
  | -- | Successful response.
    PostIssuingCardsResponse200 Issuing'card
  | -- | Error response.
    PostIssuingCardsResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
