{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postOrdersId
module StripeAPI.Operations.PostOrdersId where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/orders/{id}
--
-- \<p>Updates the specific order by setting the values of the parameters passed. Any parameters not provided will be left unchanged.\<\/p>
postOrdersId ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | id | Constraints: Maximum length of 5000
  Data.Text.Internal.Text ->
  -- | The request body to send
  GHC.Maybe.Maybe PostOrdersIdRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response PostOrdersIdResponse)
postOrdersId
  id
  body =
    GHC.Base.fmap
      ( \response_0 ->
          GHC.Base.fmap
            ( Data.Either.either PostOrdersIdResponseError GHC.Base.id
                GHC.Base.. ( \response body ->
                               if
                                   | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostOrdersIdResponse200
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Order
                                                        )
                                   | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostOrdersIdResponseDefault
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Error
                                                        )
                                   | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                           )
                  response_0
            )
            response_0
      )
      (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack ("/v1/orders/" GHC.Base.++ (Data.ByteString.Char8.unpack (Network.HTTP.Types.URI.urlEncode GHC.Types.True GHC.Base.$ (Data.ByteString.Char8.pack GHC.Base.$ StripeAPI.Common.stringifyModel id)) GHC.Base.++ ""))) GHC.Base.mempty body StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostOrdersIdRequestBody = PostOrdersIdRequestBody
  { -- | automatic_tax: Settings for automatic tax calculation for this order.
    postOrdersIdRequestBodyAutomaticTax :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyAutomaticTax'),
    -- | billing_details: Billing details for the customer. If a customer is provided, this will be automatically populated with values from that customer if override values are not provided.
    postOrdersIdRequestBodyBillingDetails :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyBillingDetails'Variants),
    -- | currency: Three-letter [ISO currency code](https:\/\/www.iso.org\/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https:\/\/stripe.com\/docs\/currencies).
    postOrdersIdRequestBodyCurrency :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | customer: The customer associated with this order.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyCustomer :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | description: An arbitrary string attached to the object. Often useful for displaying to users.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyDescription :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | discounts: The coupons, promotion codes, and\/or discounts to apply to the order. Pass the empty string \`\"\"\` to unset this field.
    postOrdersIdRequestBodyDiscounts :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyDiscounts'Variants),
    -- | expand: Specifies which fields in the response should be expanded.
    postOrdersIdRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | ip_address: The IP address of the purchaser for this order.
    postOrdersIdRequestBodyIpAddress :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | line_items: A list of line items the customer is ordering. Each line item includes information about the product, the quantity, and the resulting cost.
    postOrdersIdRequestBodyLineItems :: (GHC.Maybe.Maybe ([PostOrdersIdRequestBodyLineItems'])),
    -- | metadata: Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`.
    postOrdersIdRequestBodyMetadata :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyMetadata'Variants),
    -- | payment: Payment information associated with the order, including payment settings.
    postOrdersIdRequestBodyPayment :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'),
    -- | shipping_cost: Settings for the customer cost of shipping for this order.
    postOrdersIdRequestBodyShippingCost :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyShippingCost'Variants),
    -- | shipping_details: Shipping details for the order.
    postOrdersIdRequestBodyShippingDetails :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyShippingDetails'Variants),
    -- | tax_details: Additional tax details about the purchaser to be used for this order.
    postOrdersIdRequestBodyTaxDetails :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyTaxDetails')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("automatic_tax" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyAutomaticTax obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("billing_details" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("currency" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyCurrency obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("customer" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyCustomer obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("description" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyDescription obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("discounts" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyDiscounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("ip_address" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyIpAddress obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line_items" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyMetadata obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_cost" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_details" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingDetails obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_details" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyTaxDetails obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("automatic_tax" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyAutomaticTax obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("billing_details" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("currency" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyCurrency obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("customer" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyCustomer obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("description" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyDescription obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("discounts" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyDiscounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("ip_address" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyIpAddress obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line_items" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyMetadata obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_cost" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_details" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingDetails obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_details" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyTaxDetails obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBody" (\obj -> (((((((((((((GHC.Base.pure PostOrdersIdRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "automatic_tax")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "billing_details")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "currency")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "customer")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "description")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "discounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "ip_address")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "line_items")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payment")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "shipping_cost")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "shipping_details")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tax_details"))

-- | Create a new 'PostOrdersIdRequestBody' with all required fields.
mkPostOrdersIdRequestBody :: PostOrdersIdRequestBody
mkPostOrdersIdRequestBody =
  PostOrdersIdRequestBody
    { postOrdersIdRequestBodyAutomaticTax = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyBillingDetails = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyCurrency = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyCustomer = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyDescription = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyDiscounts = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyExpand = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyIpAddress = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyLineItems = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyMetadata = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyShippingCost = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyShippingDetails = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyTaxDetails = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.automatic_tax@ in the specification.
--
-- Settings for automatic tax calculation for this order.
data PostOrdersIdRequestBodyAutomaticTax' = PostOrdersIdRequestBodyAutomaticTax'
  { -- | enabled
    postOrdersIdRequestBodyAutomaticTax'Enabled :: GHC.Types.Bool
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyAutomaticTax' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyAutomaticTax'Enabled obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyAutomaticTax'Enabled obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyAutomaticTax' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyAutomaticTax'" (\obj -> GHC.Base.pure PostOrdersIdRequestBodyAutomaticTax' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled"))

-- | Create a new 'PostOrdersIdRequestBodyAutomaticTax'' with all required fields.
mkPostOrdersIdRequestBodyAutomaticTax' ::
  -- | 'postOrdersIdRequestBodyAutomaticTax'Enabled'
  GHC.Types.Bool ->
  PostOrdersIdRequestBodyAutomaticTax'
mkPostOrdersIdRequestBodyAutomaticTax' postOrdersIdRequestBodyAutomaticTax'Enabled = PostOrdersIdRequestBodyAutomaticTax' {postOrdersIdRequestBodyAutomaticTax'Enabled = postOrdersIdRequestBodyAutomaticTax'Enabled}

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.billing_details.anyOf@ in the specification.
data PostOrdersIdRequestBodyBillingDetails'OneOf1 = PostOrdersIdRequestBodyBillingDetails'OneOf1
  { -- | address
    postOrdersIdRequestBodyBillingDetails'OneOf1Address :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyBillingDetails'OneOf1Address'),
    -- | email
    postOrdersIdRequestBodyBillingDetails'OneOf1Email :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | name
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyBillingDetails'OneOf1Name :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | phone
    --
    -- Constraints:
    --
    -- * Maximum length of 20
    postOrdersIdRequestBodyBillingDetails'OneOf1Phone :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyBillingDetails'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("address" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Address obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("email" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Email obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("name" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Name obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("phone" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Phone obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("address" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Address obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("email" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Email obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("name" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Name obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("phone" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Phone obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyBillingDetails'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyBillingDetails'OneOf1" (\obj -> (((GHC.Base.pure PostOrdersIdRequestBodyBillingDetails'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "address")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "email")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "phone"))

-- | Create a new 'PostOrdersIdRequestBodyBillingDetails'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyBillingDetails'OneOf1 :: PostOrdersIdRequestBodyBillingDetails'OneOf1
mkPostOrdersIdRequestBodyBillingDetails'OneOf1 =
  PostOrdersIdRequestBodyBillingDetails'OneOf1
    { postOrdersIdRequestBodyBillingDetails'OneOf1Address = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyBillingDetails'OneOf1Email = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyBillingDetails'OneOf1Name = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyBillingDetails'OneOf1Phone = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.billing_details.anyOf.properties.address@ in the specification.
data PostOrdersIdRequestBodyBillingDetails'OneOf1Address' = PostOrdersIdRequestBodyBillingDetails'OneOf1Address'
  { -- | city
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyBillingDetails'OneOf1Address'City :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | country
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyBillingDetails'OneOf1Address'Country :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | line1
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyBillingDetails'OneOf1Address'Line1 :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | line2
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyBillingDetails'OneOf1Address'Line2 :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | postal_code
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyBillingDetails'OneOf1Address'PostalCode :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | state
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyBillingDetails'OneOf1Address'State :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyBillingDetails'OneOf1Address' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("city" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Address'City obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("country" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Address'Country obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line1" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Address'Line1 obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line2" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Address'Line2 obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("postal_code" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Address'PostalCode obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("state" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Address'State obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("city" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Address'City obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("country" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Address'Country obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line1" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Address'Line1 obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line2" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Address'Line2 obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("postal_code" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Address'PostalCode obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("state" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyBillingDetails'OneOf1Address'State obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyBillingDetails'OneOf1Address' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyBillingDetails'OneOf1Address'" (\obj -> (((((GHC.Base.pure PostOrdersIdRequestBodyBillingDetails'OneOf1Address' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "city")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "country")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "line1")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "line2")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "postal_code")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "state"))

-- | Create a new 'PostOrdersIdRequestBodyBillingDetails'OneOf1Address'' with all required fields.
mkPostOrdersIdRequestBodyBillingDetails'OneOf1Address' :: PostOrdersIdRequestBodyBillingDetails'OneOf1Address'
mkPostOrdersIdRequestBodyBillingDetails'OneOf1Address' =
  PostOrdersIdRequestBodyBillingDetails'OneOf1Address'
    { postOrdersIdRequestBodyBillingDetails'OneOf1Address'City = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyBillingDetails'OneOf1Address'Country = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyBillingDetails'OneOf1Address'Line1 = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyBillingDetails'OneOf1Address'Line2 = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyBillingDetails'OneOf1Address'PostalCode = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyBillingDetails'OneOf1Address'State = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.billing_details.anyOf@ in the specification.
--
-- Billing details for the customer. If a customer is provided, this will be automatically populated with values from that customer if override values are not provided.
data PostOrdersIdRequestBodyBillingDetails'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyBillingDetails'EmptyString
  | PostOrdersIdRequestBodyBillingDetails'PostOrdersIdRequestBodyBillingDetails'OneOf1 PostOrdersIdRequestBodyBillingDetails'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyBillingDetails'Variants where
  toJSON (PostOrdersIdRequestBodyBillingDetails'PostOrdersIdRequestBodyBillingDetails'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyBillingDetails'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyBillingDetails'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyBillingDetails'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyBillingDetails'PostOrdersIdRequestBodyBillingDetails'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.discounts.anyOf.items@ in the specification.
data PostOrdersIdRequestBodyDiscounts'OneOf1 = PostOrdersIdRequestBodyDiscounts'OneOf1
  { -- | coupon
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyDiscounts'OneOf1Coupon :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | discount
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyDiscounts'OneOf1Discount :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | promotion_code
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyDiscounts'OneOf1PromotionCode :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyDiscounts'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("coupon" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyDiscounts'OneOf1Coupon obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("discount" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyDiscounts'OneOf1Discount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("promotion_code" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyDiscounts'OneOf1PromotionCode obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("coupon" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyDiscounts'OneOf1Coupon obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("discount" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyDiscounts'OneOf1Discount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("promotion_code" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyDiscounts'OneOf1PromotionCode obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyDiscounts'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyDiscounts'OneOf1" (\obj -> ((GHC.Base.pure PostOrdersIdRequestBodyDiscounts'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "coupon")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "discount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "promotion_code"))

-- | Create a new 'PostOrdersIdRequestBodyDiscounts'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyDiscounts'OneOf1 :: PostOrdersIdRequestBodyDiscounts'OneOf1
mkPostOrdersIdRequestBodyDiscounts'OneOf1 =
  PostOrdersIdRequestBodyDiscounts'OneOf1
    { postOrdersIdRequestBodyDiscounts'OneOf1Coupon = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyDiscounts'OneOf1Discount = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyDiscounts'OneOf1PromotionCode = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.discounts.anyOf@ in the specification.
--
-- The coupons, promotion codes, and\/or discounts to apply to the order. Pass the empty string \`\"\"\` to unset this field.
data PostOrdersIdRequestBodyDiscounts'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyDiscounts'EmptyString
  | PostOrdersIdRequestBodyDiscounts'ListTPostOrdersIdRequestBodyDiscounts'OneOf1 ([PostOrdersIdRequestBodyDiscounts'OneOf1])
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyDiscounts'Variants where
  toJSON (PostOrdersIdRequestBodyDiscounts'ListTPostOrdersIdRequestBodyDiscounts'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyDiscounts'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyDiscounts'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyDiscounts'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyDiscounts'ListTPostOrdersIdRequestBodyDiscounts'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items@ in the specification.
data PostOrdersIdRequestBodyLineItems' = PostOrdersIdRequestBodyLineItems'
  { -- | description
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyLineItems'Description :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | discounts
    postOrdersIdRequestBodyLineItems'Discounts :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyLineItems'Discounts'Variants),
    -- | id
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyLineItems'Id :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | price
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyLineItems'Price :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | price_data
    postOrdersIdRequestBodyLineItems'PriceData :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyLineItems'PriceData'),
    -- | product
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyLineItems'Product :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | quantity
    postOrdersIdRequestBodyLineItems'Quantity :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | tax_rates
    postOrdersIdRequestBodyLineItems'TaxRates :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyLineItems'TaxRates'Variants)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyLineItems' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("description" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'Description obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("discounts" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'Discounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("id" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'Id obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("price" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'Price obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("price_data" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'PriceData obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("product" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'Product obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("quantity" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'Quantity obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_rates" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'TaxRates obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("description" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'Description obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("discounts" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'Discounts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("id" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'Id obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("price" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'Price obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("price_data" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'PriceData obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("product" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'Product obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("quantity" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'Quantity obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_rates" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'TaxRates obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyLineItems' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyLineItems'" (\obj -> (((((((GHC.Base.pure PostOrdersIdRequestBodyLineItems' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "description")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "discounts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "id")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "price")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "price_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "product")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "quantity")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tax_rates"))

-- | Create a new 'PostOrdersIdRequestBodyLineItems'' with all required fields.
mkPostOrdersIdRequestBodyLineItems' :: PostOrdersIdRequestBodyLineItems'
mkPostOrdersIdRequestBodyLineItems' =
  PostOrdersIdRequestBodyLineItems'
    { postOrdersIdRequestBodyLineItems'Description = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyLineItems'Discounts = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyLineItems'Id = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyLineItems'Price = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyLineItems'PriceData = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyLineItems'Product = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyLineItems'Quantity = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyLineItems'TaxRates = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items.properties.discounts.anyOf.items@ in the specification.
data PostOrdersIdRequestBodyLineItems'Discounts'OneOf1 = PostOrdersIdRequestBodyLineItems'Discounts'OneOf1
  { -- | coupon
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyLineItems'Discounts'OneOf1Coupon :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | discount
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyLineItems'Discounts'OneOf1Discount :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyLineItems'Discounts'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("coupon" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'Discounts'OneOf1Coupon obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("discount" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'Discounts'OneOf1Discount obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("coupon" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'Discounts'OneOf1Coupon obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("discount" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'Discounts'OneOf1Discount obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyLineItems'Discounts'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyLineItems'Discounts'OneOf1" (\obj -> (GHC.Base.pure PostOrdersIdRequestBodyLineItems'Discounts'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "coupon")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "discount"))

-- | Create a new 'PostOrdersIdRequestBodyLineItems'Discounts'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyLineItems'Discounts'OneOf1 :: PostOrdersIdRequestBodyLineItems'Discounts'OneOf1
mkPostOrdersIdRequestBodyLineItems'Discounts'OneOf1 =
  PostOrdersIdRequestBodyLineItems'Discounts'OneOf1
    { postOrdersIdRequestBodyLineItems'Discounts'OneOf1Coupon = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyLineItems'Discounts'OneOf1Discount = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items.properties.discounts.anyOf@ in the specification.
data PostOrdersIdRequestBodyLineItems'Discounts'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyLineItems'Discounts'EmptyString
  | PostOrdersIdRequestBodyLineItems'Discounts'ListTPostOrdersIdRequestBodyLineItems'Discounts'OneOf1 ([PostOrdersIdRequestBodyLineItems'Discounts'OneOf1])
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyLineItems'Discounts'Variants where
  toJSON (PostOrdersIdRequestBodyLineItems'Discounts'ListTPostOrdersIdRequestBodyLineItems'Discounts'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyLineItems'Discounts'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyLineItems'Discounts'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyLineItems'Discounts'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyLineItems'Discounts'ListTPostOrdersIdRequestBodyLineItems'Discounts'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items.properties.price_data@ in the specification.
data PostOrdersIdRequestBodyLineItems'PriceData' = PostOrdersIdRequestBodyLineItems'PriceData'
  { -- | currency
    postOrdersIdRequestBodyLineItems'PriceData'Currency :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | product
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyLineItems'PriceData'Product :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | tax_behavior
    postOrdersIdRequestBodyLineItems'PriceData'TaxBehavior :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior'),
    -- | unit_amount
    postOrdersIdRequestBodyLineItems'PriceData'UnitAmount :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | unit_amount_decimal
    postOrdersIdRequestBodyLineItems'PriceData'UnitAmountDecimal :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyLineItems'PriceData' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("currency" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'PriceData'Currency obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("product" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'PriceData'Product obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_behavior" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'PriceData'TaxBehavior obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("unit_amount" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'PriceData'UnitAmount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("unit_amount_decimal" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'PriceData'UnitAmountDecimal obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("currency" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'PriceData'Currency obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("product" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'PriceData'Product obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_behavior" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'PriceData'TaxBehavior obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("unit_amount" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'PriceData'UnitAmount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("unit_amount_decimal" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyLineItems'PriceData'UnitAmountDecimal obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyLineItems'PriceData' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyLineItems'PriceData'" (\obj -> ((((GHC.Base.pure PostOrdersIdRequestBodyLineItems'PriceData' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "currency")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "product")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tax_behavior")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "unit_amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "unit_amount_decimal"))

-- | Create a new 'PostOrdersIdRequestBodyLineItems'PriceData'' with all required fields.
mkPostOrdersIdRequestBodyLineItems'PriceData' :: PostOrdersIdRequestBodyLineItems'PriceData'
mkPostOrdersIdRequestBodyLineItems'PriceData' =
  PostOrdersIdRequestBodyLineItems'PriceData'
    { postOrdersIdRequestBodyLineItems'PriceData'Currency = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyLineItems'PriceData'Product = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyLineItems'PriceData'TaxBehavior = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyLineItems'PriceData'UnitAmount = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyLineItems'PriceData'UnitAmountDecimal = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items.properties.price_data.properties.tax_behavior@ in the specification.
data PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"exclusive"@
    PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior'EnumExclusive
  | -- | Represents the JSON value @"inclusive"@
    PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior'EnumInclusive
  | -- | Represents the JSON value @"unspecified"@
    PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior'EnumUnspecified
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior' where
  toJSON (PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior'Other val) = val
  toJSON (PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior'EnumExclusive) = "exclusive"
  toJSON (PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior'EnumInclusive) = "inclusive"
  toJSON (PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior'EnumUnspecified) = "unspecified"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "exclusive" -> PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior'EnumExclusive
            | val GHC.Classes.== "inclusive" -> PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior'EnumInclusive
            | val GHC.Classes.== "unspecified" -> PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior'EnumUnspecified
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyLineItems'PriceData'TaxBehavior'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items.properties.tax_rates.anyOf@ in the specification.
data PostOrdersIdRequestBodyLineItems'TaxRates'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyLineItems'TaxRates'EmptyString
  | PostOrdersIdRequestBodyLineItems'TaxRates'ListTText ([Data.Text.Internal.Text])
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyLineItems'TaxRates'Variants where
  toJSON (PostOrdersIdRequestBodyLineItems'TaxRates'ListTText a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyLineItems'TaxRates'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyLineItems'TaxRates'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyLineItems'TaxRates'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyLineItems'TaxRates'ListTText Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.metadata.anyOf@ in the specification.
--
-- Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`.
data PostOrdersIdRequestBodyMetadata'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyMetadata'EmptyString
  | PostOrdersIdRequestBodyMetadata'Object Data.Aeson.Types.Internal.Object
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyMetadata'Variants where
  toJSON (PostOrdersIdRequestBodyMetadata'Object a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyMetadata'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyMetadata'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyMetadata'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyMetadata'Object Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment@ in the specification.
--
-- Payment information associated with the order, including payment settings.
data PostOrdersIdRequestBodyPayment' = PostOrdersIdRequestBodyPayment'
  { -- | settings
    postOrdersIdRequestBodyPayment'Settings :: PostOrdersIdRequestBodyPayment'Settings'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["settings" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyPayment'Settings obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["settings" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyPayment'Settings obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'" (\obj -> GHC.Base.pure PostOrdersIdRequestBodyPayment' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "settings"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'' with all required fields.
mkPostOrdersIdRequestBodyPayment' ::
  -- | 'postOrdersIdRequestBodyPayment'Settings'
  PostOrdersIdRequestBodyPayment'Settings' ->
  PostOrdersIdRequestBodyPayment'
mkPostOrdersIdRequestBodyPayment' postOrdersIdRequestBodyPayment'Settings = PostOrdersIdRequestBodyPayment' {postOrdersIdRequestBodyPayment'Settings = postOrdersIdRequestBodyPayment'Settings}

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings' = PostOrdersIdRequestBodyPayment'Settings'
  { -- | application_fee_amount
    postOrdersIdRequestBodyPayment'Settings'ApplicationFeeAmount :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'ApplicationFeeAmount'Variants),
    -- | payment_method_options
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'),
    -- | payment_method_types
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes :: (GHC.Maybe.Maybe ([PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'])),
    -- | return_url
    postOrdersIdRequestBodyPayment'Settings'ReturnUrl :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'ReturnUrl'Variants),
    -- | statement_descriptor
    --
    -- Constraints:
    --
    -- * Maximum length of 22
    postOrdersIdRequestBodyPayment'Settings'StatementDescriptor :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | statement_descriptor_suffix
    --
    -- Constraints:
    --
    -- * Maximum length of 22
    postOrdersIdRequestBodyPayment'Settings'StatementDescriptorSuffix :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | transfer_data
    postOrdersIdRequestBodyPayment'Settings'TransferData :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'TransferData'Variants)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("application_fee_amount" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'ApplicationFeeAmount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_options" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_types" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("return_url" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'ReturnUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("statement_descriptor" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'StatementDescriptor obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("statement_descriptor_suffix" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'StatementDescriptorSuffix obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("transfer_data" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'TransferData obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("application_fee_amount" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'ApplicationFeeAmount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_options" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_types" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("return_url" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'ReturnUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("statement_descriptor" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'StatementDescriptor obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("statement_descriptor_suffix" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'StatementDescriptorSuffix obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("transfer_data" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'TransferData obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'" (\obj -> ((((((GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "application_fee_amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payment_method_options")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payment_method_types")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "return_url")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "statement_descriptor")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "statement_descriptor_suffix")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "transfer_data"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings' :: PostOrdersIdRequestBodyPayment'Settings'
mkPostOrdersIdRequestBodyPayment'Settings' =
  PostOrdersIdRequestBodyPayment'Settings'
    { postOrdersIdRequestBodyPayment'Settings'ApplicationFeeAmount = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'ReturnUrl = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'StatementDescriptor = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'StatementDescriptorSuffix = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'TransferData = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.application_fee_amount.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'ApplicationFeeAmount'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'ApplicationFeeAmount'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'ApplicationFeeAmount'Int GHC.Types.Int
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'ApplicationFeeAmount'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'ApplicationFeeAmount'Int a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'ApplicationFeeAmount'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'ApplicationFeeAmount'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'ApplicationFeeAmount'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'ApplicationFeeAmount'Int Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions' = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'
  { -- | acss_debit
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'Variants),
    -- | afterpay_clearpay
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'Variants),
    -- | alipay
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'Variants),
    -- | bancontact
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'Variants),
    -- | card
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'Variants),
    -- | customer_balance
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'Variants),
    -- | ideal
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'Variants),
    -- | klarna
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'Variants),
    -- | link
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'Variants),
    -- | oxxo
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'Variants),
    -- | p24
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24 :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'Variants),
    -- | sepa_debit
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'Variants),
    -- | sofort
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'Variants),
    -- | wechat_pay
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'Variants)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("acss_debit" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("afterpay_clearpay" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("alipay" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bancontact" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("card" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("customer_balance" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("ideal" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("klarna" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("link" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("oxxo" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("p24" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24 obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sepa_debit" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sofort" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("wechat_pay" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("acss_debit" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("afterpay_clearpay" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("alipay" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bancontact" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("card" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("customer_balance" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("ideal" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("klarna" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("link" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("oxxo" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("p24" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24 obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sepa_debit" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sofort" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("wechat_pay" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'" (\obj -> (((((((((((((GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "acss_debit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "afterpay_clearpay")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "alipay")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "bancontact")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "card")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "customer_balance")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "ideal")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "klarna")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "link")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "oxxo")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "p24")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "sepa_debit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "sofort")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "wechat_pay"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions' :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions' =
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'
    { postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24 = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.acss_debit.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1
  { -- | mandate_options
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'),
    -- | setup_future_usage
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'),
    -- | verification_method
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("mandate_options" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verification_method" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("mandate_options" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verification_method" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1" (\obj -> ((GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "mandate_options")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "verification_method"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1 :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1 =
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1
    { postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.acss_debit.anyOf.properties.mandate_options@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions' = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'
  { -- | custom_mandate_url
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'CustomMandateUrl :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'CustomMandateUrl'Variants),
    -- | interval_description
    --
    -- Constraints:
    --
    -- * Maximum length of 500
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'IntervalDescription :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | payment_schedule
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule'),
    -- | transaction_type
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("custom_mandate_url" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'CustomMandateUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("interval_description" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'IntervalDescription obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_schedule" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("transaction_type" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("custom_mandate_url" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'CustomMandateUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("interval_description" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'IntervalDescription obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_schedule" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("transaction_type" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'" (\obj -> (((GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "custom_mandate_url")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "interval_description")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payment_schedule")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "transaction_type"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions' :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions' =
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'
    { postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'CustomMandateUrl = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'IntervalDescription = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.acss_debit.anyOf.properties.mandate_options.properties.custom_mandate_url.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'CustomMandateUrl'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'CustomMandateUrl'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'CustomMandateUrl'Text Data.Text.Internal.Text
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'CustomMandateUrl'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'CustomMandateUrl'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'CustomMandateUrl'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'CustomMandateUrl'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'CustomMandateUrl'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'CustomMandateUrl'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.acss_debit.anyOf.properties.mandate_options.properties.payment_schedule@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"combined"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule'EnumCombined
  | -- | Represents the JSON value @"interval"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule'EnumInterval
  | -- | Represents the JSON value @"sporadic"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule'EnumSporadic
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule'EnumCombined) = "combined"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule'EnumInterval) = "interval"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule'EnumSporadic) = "sporadic"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "combined" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule'EnumCombined
            | val GHC.Classes.== "interval" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule'EnumInterval
            | val GHC.Classes.== "sporadic" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule'EnumSporadic
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'PaymentSchedule'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.acss_debit.anyOf.properties.mandate_options.properties.transaction_type@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"business"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType'EnumBusiness
  | -- | Represents the JSON value @"personal"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType'EnumPersonal
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType'EnumBusiness) = "business"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType'EnumPersonal) = "personal"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "business" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType'EnumBusiness
            | val GHC.Classes.== "personal" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType'EnumPersonal
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1MandateOptions'TransactionType'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.acss_debit.anyOf.properties.setup_future_usage@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'EnumEmptyString
  | -- | Represents the JSON value @"none"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'EnumNone
  | -- | Represents the JSON value @"off_session"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'EnumOffSession
  | -- | Represents the JSON value @"on_session"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'EnumOnSession
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'EnumEmptyString) = ""
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'EnumNone) = "none"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'EnumOffSession) = "off_session"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'EnumOnSession) = "on_session"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'EnumEmptyString
            | val GHC.Classes.== "none" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'EnumNone
            | val GHC.Classes.== "off_session" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'EnumOffSession
            | val GHC.Classes.== "on_session" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'EnumOnSession
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1SetupFutureUsage'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.acss_debit.anyOf.properties.verification_method@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"automatic"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod'EnumAutomatic
  | -- | Represents the JSON value @"instant"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod'EnumInstant
  | -- | Represents the JSON value @"microdeposits"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod'EnumMicrodeposits
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod'EnumAutomatic) = "automatic"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod'EnumInstant) = "instant"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod'EnumMicrodeposits) = "microdeposits"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "automatic" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod'EnumAutomatic
            | val GHC.Classes.== "instant" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod'EnumInstant
            | val GHC.Classes.== "microdeposits" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod'EnumMicrodeposits
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1VerificationMethod'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.acss_debit.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1 PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AcssDebit'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.afterpay_clearpay.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1
  { -- | capture_method
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod'),
    -- | reference
    --
    -- Constraints:
    --
    -- * Maximum length of 128
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1Reference :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | setup_future_usage
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1SetupFutureUsage :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1SetupFutureUsage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("reference" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1Reference obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1SetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("reference" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1Reference obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1SetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1" (\obj -> ((GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "capture_method")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "reference")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1 :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1 =
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1
    { postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1Reference = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1SetupFutureUsage = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.afterpay_clearpay.anyOf.properties.capture_method@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"automatic"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod'EnumAutomatic
  | -- | Represents the JSON value @"manual"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod'EnumManual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod'EnumAutomatic) = "automatic"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod'EnumManual) = "manual"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "automatic" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod'EnumAutomatic
            | val GHC.Classes.== "manual" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod'EnumManual
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1CaptureMethod'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.afterpay_clearpay.anyOf.properties.setup_future_usage@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1SetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1SetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1SetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"none"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1SetupFutureUsage'EnumNone
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1SetupFutureUsage' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1SetupFutureUsage'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1SetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1SetupFutureUsage'EnumNone) = "none"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1SetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "none" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1SetupFutureUsage'EnumNone
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1SetupFutureUsage'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.afterpay_clearpay.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1 PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'AfterpayClearpay'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.alipay.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1
  { -- | setup_future_usage
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1" (\obj -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1 :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1 {postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage = GHC.Maybe.Nothing}

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.alipay.anyOf.properties.setup_future_usage@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage'EnumEmptyString
  | -- | Represents the JSON value @"none"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage'EnumNone
  | -- | Represents the JSON value @"off_session"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage'EnumOffSession
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage'EnumEmptyString) = ""
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage'EnumNone) = "none"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage'EnumOffSession) = "off_session"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage'EnumEmptyString
            | val GHC.Classes.== "none" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage'EnumNone
            | val GHC.Classes.== "off_session" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage'EnumOffSession
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1SetupFutureUsage'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.alipay.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1 PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Alipay'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.bancontact.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1
  { -- | preferred_language
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'),
    -- | setup_future_usage
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("preferred_language" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("preferred_language" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1" (\obj -> (GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "preferred_language")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1 :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1 =
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1
    { postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.bancontact.anyOf.properties.preferred_language@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"de"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'EnumDe
  | -- | Represents the JSON value @"en"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'EnumEn
  | -- | Represents the JSON value @"fr"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'EnumFr
  | -- | Represents the JSON value @"nl"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'EnumNl
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'EnumDe) = "de"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'EnumEn) = "en"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'EnumFr) = "fr"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'EnumNl) = "nl"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "de" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'EnumDe
            | val GHC.Classes.== "en" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'EnumEn
            | val GHC.Classes.== "fr" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'EnumFr
            | val GHC.Classes.== "nl" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'EnumNl
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1PreferredLanguage'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.bancontact.anyOf.properties.setup_future_usage@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage'EnumEmptyString
  | -- | Represents the JSON value @"none"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage'EnumNone
  | -- | Represents the JSON value @"off_session"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage'EnumOffSession
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage'EnumEmptyString) = ""
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage'EnumNone) = "none"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage'EnumOffSession) = "off_session"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage'EnumEmptyString
            | val GHC.Classes.== "none" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage'EnumNone
            | val GHC.Classes.== "off_session" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage'EnumOffSession
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1SetupFutureUsage'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.bancontact.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1 PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Bancontact'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.card.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1
  { -- | capture_method
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod'),
    -- | setup_future_usage
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1" (\obj -> (GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "capture_method")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1 :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1 =
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1
    { postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.card.anyOf.properties.capture_method@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"automatic"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod'EnumAutomatic
  | -- | Represents the JSON value @"manual"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod'EnumManual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod'EnumAutomatic) = "automatic"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod'EnumManual) = "manual"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "automatic" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod'EnumAutomatic
            | val GHC.Classes.== "manual" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod'EnumManual
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1CaptureMethod'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.card.anyOf.properties.setup_future_usage@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"none"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage'EnumNone
  | -- | Represents the JSON value @"off_session"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage'EnumOffSession
  | -- | Represents the JSON value @"on_session"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage'EnumOnSession
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage'EnumNone) = "none"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage'EnumOffSession) = "off_session"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage'EnumOnSession) = "on_session"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "none" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage'EnumNone
            | val GHC.Classes.== "off_session" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage'EnumOffSession
            | val GHC.Classes.== "on_session" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage'EnumOnSession
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1SetupFutureUsage'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.card.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1 PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Card'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.customer_balance.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1
  { -- | bank_transfer
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'),
    -- | funding_type
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1FundingType :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1FundingType'),
    -- | setup_future_usage
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1SetupFutureUsage :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1SetupFutureUsage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bank_transfer" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("funding_type" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1FundingType obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1SetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bank_transfer" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("funding_type" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1FundingType obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1SetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1" (\obj -> ((GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "bank_transfer")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "funding_type")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1 :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1 =
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1
    { postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1FundingType = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1SetupFutureUsage = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.customer_balance.anyOf.properties.bank_transfer@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer' = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'
  { -- | eu_bank_transfer
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer'),
    -- | requested_address_types
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes :: (GHC.Maybe.Maybe ([PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'])),
    -- | type
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("eu_bank_transfer" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("requested_address_types" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes obj) : ["type" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("eu_bank_transfer" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("requested_address_types" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes obj) : ["type" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'" (\obj -> ((GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "eu_bank_transfer")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "requested_address_types")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "type"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer' ::
  -- | 'postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type' ->
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer' postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type =
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'
    { postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type = postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type
    }

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.customer_balance.anyOf.properties.bank_transfer.properties.eu_bank_transfer@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer' = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer'
  { -- | country
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer'Country :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["country" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer'Country obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["country" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer'Country obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer'" (\obj -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "country"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer'' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer' ::
  -- | 'postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer'Country'
  Data.Text.Internal.Text ->
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer'
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer' postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer'Country = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer' {postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer'Country = postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'EuBankTransfer'Country}

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.customer_balance.anyOf.properties.bank_transfer.properties.requested_address_types.items@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"iban"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'EnumIban
  | -- | Represents the JSON value @"sepa"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'EnumSepa
  | -- | Represents the JSON value @"sort_code"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'EnumSortCode
  | -- | Represents the JSON value @"spei"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'EnumSpei
  | -- | Represents the JSON value @"zengin"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'EnumZengin
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'EnumIban) = "iban"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'EnumSepa) = "sepa"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'EnumSortCode) = "sort_code"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'EnumSpei) = "spei"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'EnumZengin) = "zengin"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "iban" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'EnumIban
            | val GHC.Classes.== "sepa" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'EnumSepa
            | val GHC.Classes.== "sort_code" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'EnumSortCode
            | val GHC.Classes.== "spei" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'EnumSpei
            | val GHC.Classes.== "zengin" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'EnumZengin
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'RequestedAddressTypes'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.customer_balance.anyOf.properties.bank_transfer.properties.type@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"eu_bank_transfer"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'EnumEuBankTransfer
  | -- | Represents the JSON value @"gb_bank_transfer"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'EnumGbBankTransfer
  | -- | Represents the JSON value @"jp_bank_transfer"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'EnumJpBankTransfer
  | -- | Represents the JSON value @"mx_bank_transfer"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'EnumMxBankTransfer
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'EnumEuBankTransfer) = "eu_bank_transfer"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'EnumGbBankTransfer) = "gb_bank_transfer"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'EnumJpBankTransfer) = "jp_bank_transfer"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'EnumMxBankTransfer) = "mx_bank_transfer"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "eu_bank_transfer" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'EnumEuBankTransfer
            | val GHC.Classes.== "gb_bank_transfer" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'EnumGbBankTransfer
            | val GHC.Classes.== "jp_bank_transfer" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'EnumJpBankTransfer
            | val GHC.Classes.== "mx_bank_transfer" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'EnumMxBankTransfer
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1BankTransfer'Type'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.customer_balance.anyOf.properties.funding_type@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1FundingType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1FundingType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1FundingType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"bank_transfer"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1FundingType'EnumBankTransfer
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1FundingType' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1FundingType'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1FundingType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1FundingType'EnumBankTransfer) = "bank_transfer"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1FundingType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "bank_transfer" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1FundingType'EnumBankTransfer
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1FundingType'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.customer_balance.anyOf.properties.setup_future_usage@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1SetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1SetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1SetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"none"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1SetupFutureUsage'EnumNone
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1SetupFutureUsage' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1SetupFutureUsage'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1SetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1SetupFutureUsage'EnumNone) = "none"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1SetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "none" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1SetupFutureUsage'EnumNone
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1SetupFutureUsage'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.customer_balance.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1 PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'CustomerBalance'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.ideal.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1
  { -- | setup_future_usage
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1" (\obj -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1 :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1 {postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage = GHC.Maybe.Nothing}

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.ideal.anyOf.properties.setup_future_usage@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage'EnumEmptyString
  | -- | Represents the JSON value @"none"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage'EnumNone
  | -- | Represents the JSON value @"off_session"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage'EnumOffSession
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage'EnumEmptyString) = ""
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage'EnumNone) = "none"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage'EnumOffSession) = "off_session"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage'EnumEmptyString
            | val GHC.Classes.== "none" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage'EnumNone
            | val GHC.Classes.== "off_session" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage'EnumOffSession
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1SetupFutureUsage'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.ideal.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1 PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Ideal'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.klarna.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1
  { -- | capture_method
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod'),
    -- | preferred_locale
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'),
    -- | setup_future_usage
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1SetupFutureUsage :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1SetupFutureUsage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("preferred_locale" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1SetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("preferred_locale" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1SetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1" (\obj -> ((GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "capture_method")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "preferred_locale")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1 :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1 =
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1
    { postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1SetupFutureUsage = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.klarna.anyOf.properties.capture_method@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod'EnumEmptyString
  | -- | Represents the JSON value @"manual"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod'EnumManual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod'EnumEmptyString) = ""
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod'EnumManual) = "manual"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod'EnumEmptyString
            | val GHC.Classes.== "manual" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod'EnumManual
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1CaptureMethod'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.klarna.anyOf.properties.preferred_locale@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"da-DK"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumDaDK
  | -- | Represents the JSON value @"de-AT"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumDeAT
  | -- | Represents the JSON value @"de-DE"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumDeDE
  | -- | Represents the JSON value @"en-AT"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnAT
  | -- | Represents the JSON value @"en-AU"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnAU
  | -- | Represents the JSON value @"en-BE"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnBE
  | -- | Represents the JSON value @"en-DE"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnDE
  | -- | Represents the JSON value @"en-DK"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnDK
  | -- | Represents the JSON value @"en-ES"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnES
  | -- | Represents the JSON value @"en-FI"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnFI
  | -- | Represents the JSON value @"en-FR"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnFR
  | -- | Represents the JSON value @"en-GB"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnGB
  | -- | Represents the JSON value @"en-IE"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnIE
  | -- | Represents the JSON value @"en-IT"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnIT
  | -- | Represents the JSON value @"en-NL"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnNL
  | -- | Represents the JSON value @"en-NO"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnNO
  | -- | Represents the JSON value @"en-NZ"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnNZ
  | -- | Represents the JSON value @"en-SE"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnSE
  | -- | Represents the JSON value @"en-US"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnUS
  | -- | Represents the JSON value @"es-ES"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEsES
  | -- | Represents the JSON value @"es-US"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEsUS
  | -- | Represents the JSON value @"fi-FI"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumFiFI
  | -- | Represents the JSON value @"fr-BE"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumFrBE
  | -- | Represents the JSON value @"fr-FR"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumFrFR
  | -- | Represents the JSON value @"it-IT"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumItIT
  | -- | Represents the JSON value @"nb-NO"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumNbNO
  | -- | Represents the JSON value @"nl-BE"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumNlBE
  | -- | Represents the JSON value @"nl-NL"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumNlNL
  | -- | Represents the JSON value @"sv-FI"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumSvFI
  | -- | Represents the JSON value @"sv-SE"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumSvSE
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumDaDK) = "da-DK"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumDeAT) = "de-AT"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumDeDE) = "de-DE"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnAT) = "en-AT"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnAU) = "en-AU"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnBE) = "en-BE"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnDE) = "en-DE"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnDK) = "en-DK"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnES) = "en-ES"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnFI) = "en-FI"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnFR) = "en-FR"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnGB) = "en-GB"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnIE) = "en-IE"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnIT) = "en-IT"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnNL) = "en-NL"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnNO) = "en-NO"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnNZ) = "en-NZ"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnSE) = "en-SE"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnUS) = "en-US"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEsES) = "es-ES"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEsUS) = "es-US"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumFiFI) = "fi-FI"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumFrBE) = "fr-BE"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumFrFR) = "fr-FR"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumItIT) = "it-IT"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumNbNO) = "nb-NO"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumNlBE) = "nl-BE"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumNlNL) = "nl-NL"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumSvFI) = "sv-FI"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumSvSE) = "sv-SE"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "da-DK" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumDaDK
            | val GHC.Classes.== "de-AT" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumDeAT
            | val GHC.Classes.== "de-DE" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumDeDE
            | val GHC.Classes.== "en-AT" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnAT
            | val GHC.Classes.== "en-AU" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnAU
            | val GHC.Classes.== "en-BE" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnBE
            | val GHC.Classes.== "en-DE" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnDE
            | val GHC.Classes.== "en-DK" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnDK
            | val GHC.Classes.== "en-ES" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnES
            | val GHC.Classes.== "en-FI" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnFI
            | val GHC.Classes.== "en-FR" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnFR
            | val GHC.Classes.== "en-GB" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnGB
            | val GHC.Classes.== "en-IE" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnIE
            | val GHC.Classes.== "en-IT" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnIT
            | val GHC.Classes.== "en-NL" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnNL
            | val GHC.Classes.== "en-NO" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnNO
            | val GHC.Classes.== "en-NZ" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnNZ
            | val GHC.Classes.== "en-SE" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnSE
            | val GHC.Classes.== "en-US" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEnUS
            | val GHC.Classes.== "es-ES" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEsES
            | val GHC.Classes.== "es-US" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumEsUS
            | val GHC.Classes.== "fi-FI" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumFiFI
            | val GHC.Classes.== "fr-BE" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumFrBE
            | val GHC.Classes.== "fr-FR" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumFrFR
            | val GHC.Classes.== "it-IT" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumItIT
            | val GHC.Classes.== "nb-NO" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumNbNO
            | val GHC.Classes.== "nl-BE" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumNlBE
            | val GHC.Classes.== "nl-NL" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumNlNL
            | val GHC.Classes.== "sv-FI" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumSvFI
            | val GHC.Classes.== "sv-SE" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'EnumSvSE
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1PreferredLocale'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.klarna.anyOf.properties.setup_future_usage@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1SetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1SetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1SetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"none"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1SetupFutureUsage'EnumNone
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1SetupFutureUsage' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1SetupFutureUsage'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1SetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1SetupFutureUsage'EnumNone) = "none"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1SetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "none" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1SetupFutureUsage'EnumNone
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1SetupFutureUsage'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.klarna.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1 PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Klarna'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.link.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1
  { -- | capture_method
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod'),
    -- | persistent_token
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1PersistentToken :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | setup_future_usage
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("persistent_token" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1PersistentToken obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("persistent_token" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1PersistentToken obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1" (\obj -> ((GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "capture_method")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "persistent_token")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1 :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1 =
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1
    { postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1PersistentToken = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.link.anyOf.properties.capture_method@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod'EnumEmptyString
  | -- | Represents the JSON value @"manual"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod'EnumManual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod'EnumEmptyString) = ""
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod'EnumManual) = "manual"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod'EnumEmptyString
            | val GHC.Classes.== "manual" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod'EnumManual
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1CaptureMethod'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.link.anyOf.properties.setup_future_usage@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage'EnumEmptyString
  | -- | Represents the JSON value @"none"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage'EnumNone
  | -- | Represents the JSON value @"off_session"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage'EnumOffSession
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage'EnumEmptyString) = ""
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage'EnumNone) = "none"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage'EnumOffSession) = "off_session"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage'EnumEmptyString
            | val GHC.Classes.== "none" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage'EnumNone
            | val GHC.Classes.== "off_session" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage'EnumOffSession
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1SetupFutureUsage'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.link.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1 PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Link'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.oxxo.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1
  { -- | expires_after_days
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1ExpiresAfterDays :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | setup_future_usage
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1SetupFutureUsage :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1SetupFutureUsage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expires_after_days" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1ExpiresAfterDays obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1SetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expires_after_days" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1ExpiresAfterDays obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1SetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1" (\obj -> (GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "expires_after_days")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1 :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1 =
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1
    { postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1ExpiresAfterDays = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1SetupFutureUsage = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.oxxo.anyOf.properties.setup_future_usage@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1SetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1SetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1SetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"none"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1SetupFutureUsage'EnumNone
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1SetupFutureUsage' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1SetupFutureUsage'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1SetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1SetupFutureUsage'EnumNone) = "none"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1SetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "none" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1SetupFutureUsage'EnumNone
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1SetupFutureUsage'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.oxxo.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1 PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Oxxo'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.p24.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1
  { -- | setup_future_usage
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1SetupFutureUsage :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1SetupFutureUsage'),
    -- | tos_shown_and_accepted
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1TosShownAndAccepted :: (GHC.Maybe.Maybe GHC.Types.Bool)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1SetupFutureUsage obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tos_shown_and_accepted" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1TosShownAndAccepted obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1SetupFutureUsage obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tos_shown_and_accepted" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1TosShownAndAccepted obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1" (\obj -> (GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tos_shown_and_accepted"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1 :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1 =
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1
    { postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1SetupFutureUsage = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1TosShownAndAccepted = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.p24.anyOf.properties.setup_future_usage@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1SetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1SetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1SetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"none"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1SetupFutureUsage'EnumNone
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1SetupFutureUsage' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1SetupFutureUsage'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1SetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1SetupFutureUsage'EnumNone) = "none"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1SetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "none" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1SetupFutureUsage'EnumNone
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1SetupFutureUsage'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.p24.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1 PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'P24'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.sepa_debit.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1
  { -- | mandate_options
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1MandateOptions :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | setup_future_usage
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("mandate_options" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1MandateOptions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("mandate_options" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1MandateOptions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1" (\obj -> (GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "mandate_options")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1 :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1 =
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1
    { postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1MandateOptions = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.sepa_debit.anyOf.properties.setup_future_usage@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'EnumEmptyString
  | -- | Represents the JSON value @"none"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'EnumNone
  | -- | Represents the JSON value @"off_session"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'EnumOffSession
  | -- | Represents the JSON value @"on_session"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'EnumOnSession
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'EnumEmptyString) = ""
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'EnumNone) = "none"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'EnumOffSession) = "off_session"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'EnumOnSession) = "on_session"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'EnumEmptyString
            | val GHC.Classes.== "none" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'EnumNone
            | val GHC.Classes.== "off_session" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'EnumOffSession
            | val GHC.Classes.== "on_session" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'EnumOnSession
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1SetupFutureUsage'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.sepa_debit.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1 PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'SepaDebit'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.sofort.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1
  { -- | preferred_language
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'),
    -- | setup_future_usage
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("preferred_language" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("preferred_language" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1" (\obj -> (GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "preferred_language")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1 :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1 =
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1
    { postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.sofort.anyOf.properties.preferred_language@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumEmptyString
  | -- | Represents the JSON value @"de"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumDe
  | -- | Represents the JSON value @"en"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumEn
  | -- | Represents the JSON value @"es"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumEs
  | -- | Represents the JSON value @"fr"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumFr
  | -- | Represents the JSON value @"it"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumIt
  | -- | Represents the JSON value @"nl"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumNl
  | -- | Represents the JSON value @"pl"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumPl
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumEmptyString) = ""
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumDe) = "de"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumEn) = "en"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumEs) = "es"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumFr) = "fr"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumIt) = "it"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumNl) = "nl"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumPl) = "pl"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumEmptyString
            | val GHC.Classes.== "de" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumDe
            | val GHC.Classes.== "en" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumEn
            | val GHC.Classes.== "es" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumEs
            | val GHC.Classes.== "fr" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumFr
            | val GHC.Classes.== "it" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumIt
            | val GHC.Classes.== "nl" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumNl
            | val GHC.Classes.== "pl" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'EnumPl
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1PreferredLanguage'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.sofort.anyOf.properties.setup_future_usage@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage'EnumEmptyString
  | -- | Represents the JSON value @"none"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage'EnumNone
  | -- | Represents the JSON value @"off_session"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage'EnumOffSession
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage'EnumEmptyString) = ""
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage'EnumNone) = "none"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage'EnumOffSession) = "off_session"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage'EnumEmptyString
            | val GHC.Classes.== "none" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage'EnumNone
            | val GHC.Classes.== "off_session" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage'EnumOffSession
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1SetupFutureUsage'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.sofort.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1 PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'Sofort'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.wechat_pay.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1
  { -- | app_id
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1AppId :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | client
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client :: PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client',
    -- | setup_future_usage
    postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1SetupFutureUsage :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1SetupFutureUsage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("app_id" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1AppId obj) : ["client" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1SetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("app_id" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1AppId obj) : ["client" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1SetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1" (\obj -> ((GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "app_id")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "client")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1 ::
  -- | 'postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client'
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client' ->
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1
mkPostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1 postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client =
  PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1
    { postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1AppId = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client = postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client,
      postOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1SetupFutureUsage = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.wechat_pay.anyOf.properties.client@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"android"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client'EnumAndroid
  | -- | Represents the JSON value @"ios"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client'EnumIos
  | -- | Represents the JSON value @"web"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client'EnumWeb
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client'EnumAndroid) = "android"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client'EnumIos) = "ios"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client'EnumWeb) = "web"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "android" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client'EnumAndroid
            | val GHC.Classes.== "ios" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client'EnumIos
            | val GHC.Classes.== "web" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client'EnumWeb
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1Client'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.wechat_pay.anyOf.properties.setup_future_usage@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1SetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1SetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1SetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"none"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1SetupFutureUsage'EnumNone
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1SetupFutureUsage' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1SetupFutureUsage'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1SetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1SetupFutureUsage'EnumNone) = "none"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1SetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "none" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1SetupFutureUsage'EnumNone
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1SetupFutureUsage'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_options.properties.wechat_pay.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1 PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'PostOrdersIdRequestBodyPayment'Settings'PaymentMethodOptions'WechatPay'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.payment_method_types.items@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"acss_debit"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumAcssDebit
  | -- | Represents the JSON value @"afterpay_clearpay"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumAfterpayClearpay
  | -- | Represents the JSON value @"alipay"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumAlipay
  | -- | Represents the JSON value @"au_becs_debit"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumAuBecsDebit
  | -- | Represents the JSON value @"bacs_debit"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumBacsDebit
  | -- | Represents the JSON value @"bancontact"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumBancontact
  | -- | Represents the JSON value @"card"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumCard
  | -- | Represents the JSON value @"customer_balance"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumCustomerBalance
  | -- | Represents the JSON value @"eps"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumEps
  | -- | Represents the JSON value @"fpx"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumFpx
  | -- | Represents the JSON value @"giropay"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumGiropay
  | -- | Represents the JSON value @"grabpay"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumGrabpay
  | -- | Represents the JSON value @"ideal"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumIdeal
  | -- | Represents the JSON value @"klarna"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumKlarna
  | -- | Represents the JSON value @"link"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumLink
  | -- | Represents the JSON value @"oxxo"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumOxxo
  | -- | Represents the JSON value @"p24"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumP24
  | -- | Represents the JSON value @"paypal"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumPaypal
  | -- | Represents the JSON value @"sepa_debit"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumSepaDebit
  | -- | Represents the JSON value @"sofort"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumSofort
  | -- | Represents the JSON value @"wechat_pay"@
    PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumWechatPay
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes' where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'Other val) = val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumAcssDebit) = "acss_debit"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumAfterpayClearpay) = "afterpay_clearpay"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumAlipay) = "alipay"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumAuBecsDebit) = "au_becs_debit"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumBacsDebit) = "bacs_debit"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumBancontact) = "bancontact"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumCard) = "card"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumCustomerBalance) = "customer_balance"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumEps) = "eps"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumFpx) = "fpx"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumGiropay) = "giropay"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumGrabpay) = "grabpay"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumIdeal) = "ideal"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumKlarna) = "klarna"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumLink) = "link"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumOxxo) = "oxxo"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumP24) = "p24"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumPaypal) = "paypal"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumSepaDebit) = "sepa_debit"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumSofort) = "sofort"
  toJSON (PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumWechatPay) = "wechat_pay"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "acss_debit" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumAcssDebit
            | val GHC.Classes.== "afterpay_clearpay" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumAfterpayClearpay
            | val GHC.Classes.== "alipay" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumAlipay
            | val GHC.Classes.== "au_becs_debit" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumAuBecsDebit
            | val GHC.Classes.== "bacs_debit" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumBacsDebit
            | val GHC.Classes.== "bancontact" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumBancontact
            | val GHC.Classes.== "card" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumCard
            | val GHC.Classes.== "customer_balance" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumCustomerBalance
            | val GHC.Classes.== "eps" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumEps
            | val GHC.Classes.== "fpx" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumFpx
            | val GHC.Classes.== "giropay" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumGiropay
            | val GHC.Classes.== "grabpay" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumGrabpay
            | val GHC.Classes.== "ideal" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumIdeal
            | val GHC.Classes.== "klarna" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumKlarna
            | val GHC.Classes.== "link" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumLink
            | val GHC.Classes.== "oxxo" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumOxxo
            | val GHC.Classes.== "p24" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumP24
            | val GHC.Classes.== "paypal" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumPaypal
            | val GHC.Classes.== "sepa_debit" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumSepaDebit
            | val GHC.Classes.== "sofort" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumSofort
            | val GHC.Classes.== "wechat_pay" -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'EnumWechatPay
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyPayment'Settings'PaymentMethodTypes'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.return_url.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'ReturnUrl'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'ReturnUrl'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'ReturnUrl'Text Data.Text.Internal.Text
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'ReturnUrl'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'ReturnUrl'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'ReturnUrl'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'ReturnUrl'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'ReturnUrl'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'ReturnUrl'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.transfer_data.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1 = PostOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1
  { -- | amount
    postOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1Amount :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | destination
    postOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1Destination :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("amount" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1Amount obj) : ["destination" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1Destination obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("amount" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1Amount obj) : ["destination" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1Destination obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1" (\obj -> (GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "destination"))

-- | Create a new 'PostOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1 ::
  -- | 'postOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1Destination'
  Data.Text.Internal.Text ->
  PostOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1
mkPostOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1 postOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1Destination =
  PostOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1
    { postOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1Amount = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1Destination = postOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1Destination
    }

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment.properties.settings.properties.transfer_data.anyOf@ in the specification.
data PostOrdersIdRequestBodyPayment'Settings'TransferData'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyPayment'Settings'TransferData'EmptyString
  | PostOrdersIdRequestBodyPayment'Settings'TransferData'PostOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1 PostOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyPayment'Settings'TransferData'Variants where
  toJSON (PostOrdersIdRequestBodyPayment'Settings'TransferData'PostOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyPayment'Settings'TransferData'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyPayment'Settings'TransferData'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyPayment'Settings'TransferData'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyPayment'Settings'TransferData'PostOrdersIdRequestBodyPayment'Settings'TransferData'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_cost.anyOf@ in the specification.
data PostOrdersIdRequestBodyShippingCost'OneOf1 = PostOrdersIdRequestBodyShippingCost'OneOf1
  { -- | shipping_rate
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRate :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | shipping_rate_data
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyShippingCost'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_rate" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRate obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_rate_data" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_rate" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRate obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_rate_data" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyShippingCost'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyShippingCost'OneOf1" (\obj -> (GHC.Base.pure PostOrdersIdRequestBodyShippingCost'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "shipping_rate")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "shipping_rate_data"))

-- | Create a new 'PostOrdersIdRequestBodyShippingCost'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyShippingCost'OneOf1 :: PostOrdersIdRequestBodyShippingCost'OneOf1
mkPostOrdersIdRequestBodyShippingCost'OneOf1 =
  PostOrdersIdRequestBodyShippingCost'OneOf1
    { postOrdersIdRequestBodyShippingCost'OneOf1ShippingRate = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_cost.anyOf.properties.shipping_rate_data@ in the specification.
data PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData' = PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'
  { -- | delivery_estimate
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'),
    -- | display_name
    --
    -- Constraints:
    --
    -- * Maximum length of 100
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DisplayName :: Data.Text.Internal.Text,
    -- | fixed_amount
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'),
    -- | metadata
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Metadata :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | tax_behavior
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior'),
    -- | tax_code
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxCode :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | type
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Type :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Type')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("delivery_estimate" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate obj) : ["display_name" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DisplayName obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amount" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Metadata obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_behavior" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_code" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxCode obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("type" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Type obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("delivery_estimate" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate obj) : ["display_name" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DisplayName obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("fixed_amount" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Metadata obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_behavior" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_code" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxCode obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("type" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Type obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'" (\obj -> ((((((GHC.Base.pure PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "delivery_estimate")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "display_name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "fixed_amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tax_behavior")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tax_code")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "type"))

-- | Create a new 'PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'' with all required fields.
mkPostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData' ::
  -- | 'postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DisplayName'
  Data.Text.Internal.Text ->
  PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'
mkPostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData' postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DisplayName =
  PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'
    { postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DisplayName = postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DisplayName,
      postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Metadata = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxCode = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Type = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_cost.anyOf.properties.shipping_rate_data.properties.delivery_estimate@ in the specification.
data PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate' = PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'
  { -- | maximum
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'),
    -- | minimum
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("maximum" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("minimum" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("maximum" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("minimum" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'" (\obj -> (GHC.Base.pure PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "maximum")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "minimum"))

-- | Create a new 'PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'' with all required fields.
mkPostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate' :: PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'
mkPostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate' =
  PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'
    { postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_cost.anyOf.properties.shipping_rate_data.properties.delivery_estimate.properties.maximum@ in the specification.
data PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum' = PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'
  { -- | unit
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit :: PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit',
    -- | value
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Value :: GHC.Types.Int
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["unit" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit obj] : ["value" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Value obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["unit" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit obj] : ["value" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Value obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'" (\obj -> (GHC.Base.pure PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "unit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "value"))

-- | Create a new 'PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'' with all required fields.
mkPostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum' ::
  -- | 'postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'
  PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit' ->
  -- | 'postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Value'
  GHC.Types.Int ->
  PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'
mkPostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum' postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Value =
  PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'
    { postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit = postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit,
      postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Value = postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Value
    }

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_cost.anyOf.properties.shipping_rate_data.properties.delivery_estimate.properties.maximum.properties.unit@ in the specification.
data PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"business_day"@
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'EnumBusinessDay
  | -- | Represents the JSON value @"day"@
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'EnumDay
  | -- | Represents the JSON value @"hour"@
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'EnumHour
  | -- | Represents the JSON value @"month"@
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'EnumMonth
  | -- | Represents the JSON value @"week"@
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'EnumWeek
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit' where
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'Other val) = val
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'EnumBusinessDay) = "business_day"
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'EnumDay) = "day"
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'EnumHour) = "hour"
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'EnumMonth) = "month"
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'EnumWeek) = "week"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "business_day" -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'EnumBusinessDay
            | val GHC.Classes.== "day" -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'EnumDay
            | val GHC.Classes.== "hour" -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'EnumHour
            | val GHC.Classes.== "month" -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'EnumMonth
            | val GHC.Classes.== "week" -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'EnumWeek
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Maximum'Unit'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_cost.anyOf.properties.shipping_rate_data.properties.delivery_estimate.properties.minimum@ in the specification.
data PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum' = PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'
  { -- | unit
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit :: PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit',
    -- | value
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Value :: GHC.Types.Int
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["unit" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit obj] : ["value" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Value obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["unit" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit obj] : ["value" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Value obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'" (\obj -> (GHC.Base.pure PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "unit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "value"))

-- | Create a new 'PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'' with all required fields.
mkPostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum' ::
  -- | 'postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'
  PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit' ->
  -- | 'postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Value'
  GHC.Types.Int ->
  PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'
mkPostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum' postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Value =
  PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'
    { postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit = postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit,
      postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Value = postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Value
    }

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_cost.anyOf.properties.shipping_rate_data.properties.delivery_estimate.properties.minimum.properties.unit@ in the specification.
data PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"business_day"@
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'EnumBusinessDay
  | -- | Represents the JSON value @"day"@
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'EnumDay
  | -- | Represents the JSON value @"hour"@
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'EnumHour
  | -- | Represents the JSON value @"month"@
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'EnumMonth
  | -- | Represents the JSON value @"week"@
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'EnumWeek
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit' where
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'Other val) = val
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'EnumBusinessDay) = "business_day"
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'EnumDay) = "day"
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'EnumHour) = "hour"
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'EnumMonth) = "month"
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'EnumWeek) = "week"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "business_day" -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'EnumBusinessDay
            | val GHC.Classes.== "day" -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'EnumDay
            | val GHC.Classes.== "hour" -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'EnumHour
            | val GHC.Classes.== "month" -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'EnumMonth
            | val GHC.Classes.== "week" -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'EnumWeek
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'DeliveryEstimate'Minimum'Unit'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_cost.anyOf.properties.shipping_rate_data.properties.fixed_amount@ in the specification.
data PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount' = PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'
  { -- | amount
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'Amount :: GHC.Types.Int,
    -- | currency
    postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'Currency :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'Amount obj] : ["currency" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'Currency obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'Amount obj] : ["currency" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'Currency obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'" (\obj -> (GHC.Base.pure PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "currency"))

-- | Create a new 'PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'' with all required fields.
mkPostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount' ::
  -- | 'postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'Amount'
  GHC.Types.Int ->
  -- | 'postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'Currency'
  Data.Text.Internal.Text ->
  PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'
mkPostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount' postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'Amount postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'Currency =
  PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'
    { postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'Amount = postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'Amount,
      postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'Currency = postOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'FixedAmount'Currency
    }

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_cost.anyOf.properties.shipping_rate_data.properties.tax_behavior@ in the specification.
data PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"exclusive"@
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior'EnumExclusive
  | -- | Represents the JSON value @"inclusive"@
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior'EnumInclusive
  | -- | Represents the JSON value @"unspecified"@
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior'EnumUnspecified
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior' where
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior'Other val) = val
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior'EnumExclusive) = "exclusive"
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior'EnumInclusive) = "inclusive"
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior'EnumUnspecified) = "unspecified"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "exclusive" -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior'EnumExclusive
            | val GHC.Classes.== "inclusive" -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior'EnumInclusive
            | val GHC.Classes.== "unspecified" -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior'EnumUnspecified
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'TaxBehavior'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_cost.anyOf.properties.shipping_rate_data.properties.type@ in the specification.
data PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Type'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Type'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Type'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"fixed_amount"@
    PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Type'EnumFixedAmount
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Type' where
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Type'Other val) = val
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Type'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Type'EnumFixedAmount) = "fixed_amount"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Type' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "fixed_amount" -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Type'EnumFixedAmount
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyShippingCost'OneOf1ShippingRateData'Type'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_cost.anyOf@ in the specification.
--
-- Settings for the customer cost of shipping for this order.
data PostOrdersIdRequestBodyShippingCost'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyShippingCost'EmptyString
  | PostOrdersIdRequestBodyShippingCost'PostOrdersIdRequestBodyShippingCost'OneOf1 PostOrdersIdRequestBodyShippingCost'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyShippingCost'Variants where
  toJSON (PostOrdersIdRequestBodyShippingCost'PostOrdersIdRequestBodyShippingCost'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyShippingCost'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyShippingCost'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyShippingCost'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyShippingCost'PostOrdersIdRequestBodyShippingCost'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_details.anyOf@ in the specification.
data PostOrdersIdRequestBodyShippingDetails'OneOf1 = PostOrdersIdRequestBodyShippingDetails'OneOf1
  { -- | address
    postOrdersIdRequestBodyShippingDetails'OneOf1Address :: PostOrdersIdRequestBodyShippingDetails'OneOf1Address',
    -- | name
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyShippingDetails'OneOf1Name :: Data.Text.Internal.Text,
    -- | phone
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyShippingDetails'OneOf1Phone :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyShippingDetails'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["address" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingDetails'OneOf1Address obj] : ["name" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingDetails'OneOf1Name obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("phone" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingDetails'OneOf1Phone obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["address" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingDetails'OneOf1Address obj] : ["name" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyShippingDetails'OneOf1Name obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("phone" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingDetails'OneOf1Phone obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyShippingDetails'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyShippingDetails'OneOf1" (\obj -> ((GHC.Base.pure PostOrdersIdRequestBodyShippingDetails'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "address")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "phone"))

-- | Create a new 'PostOrdersIdRequestBodyShippingDetails'OneOf1' with all required fields.
mkPostOrdersIdRequestBodyShippingDetails'OneOf1 ::
  -- | 'postOrdersIdRequestBodyShippingDetails'OneOf1Address'
  PostOrdersIdRequestBodyShippingDetails'OneOf1Address' ->
  -- | 'postOrdersIdRequestBodyShippingDetails'OneOf1Name'
  Data.Text.Internal.Text ->
  PostOrdersIdRequestBodyShippingDetails'OneOf1
mkPostOrdersIdRequestBodyShippingDetails'OneOf1 postOrdersIdRequestBodyShippingDetails'OneOf1Address postOrdersIdRequestBodyShippingDetails'OneOf1Name =
  PostOrdersIdRequestBodyShippingDetails'OneOf1
    { postOrdersIdRequestBodyShippingDetails'OneOf1Address = postOrdersIdRequestBodyShippingDetails'OneOf1Address,
      postOrdersIdRequestBodyShippingDetails'OneOf1Name = postOrdersIdRequestBodyShippingDetails'OneOf1Name,
      postOrdersIdRequestBodyShippingDetails'OneOf1Phone = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_details.anyOf.properties.address@ in the specification.
data PostOrdersIdRequestBodyShippingDetails'OneOf1Address' = PostOrdersIdRequestBodyShippingDetails'OneOf1Address'
  { -- | city
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyShippingDetails'OneOf1Address'City :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | country
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyShippingDetails'OneOf1Address'Country :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | line1
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyShippingDetails'OneOf1Address'Line1 :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | line2
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyShippingDetails'OneOf1Address'Line2 :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | postal_code
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyShippingDetails'OneOf1Address'PostalCode :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | state
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyShippingDetails'OneOf1Address'State :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyShippingDetails'OneOf1Address' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("city" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingDetails'OneOf1Address'City obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("country" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingDetails'OneOf1Address'Country obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line1" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingDetails'OneOf1Address'Line1 obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line2" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingDetails'OneOf1Address'Line2 obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("postal_code" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingDetails'OneOf1Address'PostalCode obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("state" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingDetails'OneOf1Address'State obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("city" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingDetails'OneOf1Address'City obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("country" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingDetails'OneOf1Address'Country obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line1" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingDetails'OneOf1Address'Line1 obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line2" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingDetails'OneOf1Address'Line2 obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("postal_code" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingDetails'OneOf1Address'PostalCode obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("state" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyShippingDetails'OneOf1Address'State obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyShippingDetails'OneOf1Address' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyShippingDetails'OneOf1Address'" (\obj -> (((((GHC.Base.pure PostOrdersIdRequestBodyShippingDetails'OneOf1Address' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "city")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "country")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "line1")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "line2")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "postal_code")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "state"))

-- | Create a new 'PostOrdersIdRequestBodyShippingDetails'OneOf1Address'' with all required fields.
mkPostOrdersIdRequestBodyShippingDetails'OneOf1Address' :: PostOrdersIdRequestBodyShippingDetails'OneOf1Address'
mkPostOrdersIdRequestBodyShippingDetails'OneOf1Address' =
  PostOrdersIdRequestBodyShippingDetails'OneOf1Address'
    { postOrdersIdRequestBodyShippingDetails'OneOf1Address'City = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyShippingDetails'OneOf1Address'Country = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyShippingDetails'OneOf1Address'Line1 = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyShippingDetails'OneOf1Address'Line2 = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyShippingDetails'OneOf1Address'PostalCode = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyShippingDetails'OneOf1Address'State = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_details.anyOf@ in the specification.
--
-- Shipping details for the order.
data PostOrdersIdRequestBodyShippingDetails'Variants
  = -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyShippingDetails'EmptyString
  | PostOrdersIdRequestBodyShippingDetails'PostOrdersIdRequestBodyShippingDetails'OneOf1 PostOrdersIdRequestBodyShippingDetails'OneOf1
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyShippingDetails'Variants where
  toJSON (PostOrdersIdRequestBodyShippingDetails'PostOrdersIdRequestBodyShippingDetails'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostOrdersIdRequestBodyShippingDetails'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyShippingDetails'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostOrdersIdRequestBodyShippingDetails'EmptyString
        | GHC.Base.otherwise -> case (PostOrdersIdRequestBodyShippingDetails'PostOrdersIdRequestBodyShippingDetails'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tax_details@ in the specification.
--
-- Additional tax details about the purchaser to be used for this order.
data PostOrdersIdRequestBodyTaxDetails' = PostOrdersIdRequestBodyTaxDetails'
  { -- | tax_exempt
    postOrdersIdRequestBodyTaxDetails'TaxExempt :: (GHC.Maybe.Maybe PostOrdersIdRequestBodyTaxDetails'TaxExempt'),
    -- | tax_ids
    postOrdersIdRequestBodyTaxDetails'TaxIds :: (GHC.Maybe.Maybe ([PostOrdersIdRequestBodyTaxDetails'TaxIds']))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyTaxDetails' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_exempt" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyTaxDetails'TaxExempt obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_ids" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyTaxDetails'TaxIds obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_exempt" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyTaxDetails'TaxExempt obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_ids" Data.Aeson.Types.ToJSON..=)) (postOrdersIdRequestBodyTaxDetails'TaxIds obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyTaxDetails' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyTaxDetails'" (\obj -> (GHC.Base.pure PostOrdersIdRequestBodyTaxDetails' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tax_exempt")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tax_ids"))

-- | Create a new 'PostOrdersIdRequestBodyTaxDetails'' with all required fields.
mkPostOrdersIdRequestBodyTaxDetails' :: PostOrdersIdRequestBodyTaxDetails'
mkPostOrdersIdRequestBodyTaxDetails' =
  PostOrdersIdRequestBodyTaxDetails'
    { postOrdersIdRequestBodyTaxDetails'TaxExempt = GHC.Maybe.Nothing,
      postOrdersIdRequestBodyTaxDetails'TaxIds = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tax_details.properties.tax_exempt@ in the specification.
data PostOrdersIdRequestBodyTaxDetails'TaxExempt'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyTaxDetails'TaxExempt'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyTaxDetails'TaxExempt'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @""@
    PostOrdersIdRequestBodyTaxDetails'TaxExempt'EnumEmptyString
  | -- | Represents the JSON value @"exempt"@
    PostOrdersIdRequestBodyTaxDetails'TaxExempt'EnumExempt
  | -- | Represents the JSON value @"none"@
    PostOrdersIdRequestBodyTaxDetails'TaxExempt'EnumNone
  | -- | Represents the JSON value @"reverse"@
    PostOrdersIdRequestBodyTaxDetails'TaxExempt'EnumReverse
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyTaxDetails'TaxExempt' where
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxExempt'Other val) = val
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxExempt'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxExempt'EnumEmptyString) = ""
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxExempt'EnumExempt) = "exempt"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxExempt'EnumNone) = "none"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxExempt'EnumReverse) = "reverse"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyTaxDetails'TaxExempt' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "" -> PostOrdersIdRequestBodyTaxDetails'TaxExempt'EnumEmptyString
            | val GHC.Classes.== "exempt" -> PostOrdersIdRequestBodyTaxDetails'TaxExempt'EnumExempt
            | val GHC.Classes.== "none" -> PostOrdersIdRequestBodyTaxDetails'TaxExempt'EnumNone
            | val GHC.Classes.== "reverse" -> PostOrdersIdRequestBodyTaxDetails'TaxExempt'EnumReverse
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyTaxDetails'TaxExempt'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tax_details.properties.tax_ids.items@ in the specification.
data PostOrdersIdRequestBodyTaxDetails'TaxIds' = PostOrdersIdRequestBodyTaxDetails'TaxIds'
  { -- | type
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postOrdersIdRequestBodyTaxDetails'TaxIds'Type :: PostOrdersIdRequestBodyTaxDetails'TaxIds'Type',
    -- | value
    postOrdersIdRequestBodyTaxDetails'TaxIds'Value :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyTaxDetails'TaxIds' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["type" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyTaxDetails'TaxIds'Type obj] : ["value" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyTaxDetails'TaxIds'Value obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["type" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyTaxDetails'TaxIds'Type obj] : ["value" Data.Aeson.Types.ToJSON..= postOrdersIdRequestBodyTaxDetails'TaxIds'Value obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyTaxDetails'TaxIds' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostOrdersIdRequestBodyTaxDetails'TaxIds'" (\obj -> (GHC.Base.pure PostOrdersIdRequestBodyTaxDetails'TaxIds' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "type")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "value"))

-- | Create a new 'PostOrdersIdRequestBodyTaxDetails'TaxIds'' with all required fields.
mkPostOrdersIdRequestBodyTaxDetails'TaxIds' ::
  -- | 'postOrdersIdRequestBodyTaxDetails'TaxIds'Type'
  PostOrdersIdRequestBodyTaxDetails'TaxIds'Type' ->
  -- | 'postOrdersIdRequestBodyTaxDetails'TaxIds'Value'
  Data.Text.Internal.Text ->
  PostOrdersIdRequestBodyTaxDetails'TaxIds'
mkPostOrdersIdRequestBodyTaxDetails'TaxIds' postOrdersIdRequestBodyTaxDetails'TaxIds'Type postOrdersIdRequestBodyTaxDetails'TaxIds'Value =
  PostOrdersIdRequestBodyTaxDetails'TaxIds'
    { postOrdersIdRequestBodyTaxDetails'TaxIds'Type = postOrdersIdRequestBodyTaxDetails'TaxIds'Type,
      postOrdersIdRequestBodyTaxDetails'TaxIds'Value = postOrdersIdRequestBodyTaxDetails'TaxIds'Value
    }

-- | Defines the enum schema located at @paths.\/v1\/orders\/{id}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tax_details.properties.tax_ids.items.properties.type@ in the specification.
data PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ae_trn"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumAeTrn
  | -- | Represents the JSON value @"au_abn"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumAuAbn
  | -- | Represents the JSON value @"au_arn"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumAuArn
  | -- | Represents the JSON value @"bg_uic"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumBgUic
  | -- | Represents the JSON value @"br_cnpj"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumBrCnpj
  | -- | Represents the JSON value @"br_cpf"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumBrCpf
  | -- | Represents the JSON value @"ca_bn"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaBn
  | -- | Represents the JSON value @"ca_gst_hst"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaGstHst
  | -- | Represents the JSON value @"ca_pst_bc"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaPstBc
  | -- | Represents the JSON value @"ca_pst_mb"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaPstMb
  | -- | Represents the JSON value @"ca_pst_sk"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaPstSk
  | -- | Represents the JSON value @"ca_qst"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaQst
  | -- | Represents the JSON value @"ch_vat"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumChVat
  | -- | Represents the JSON value @"cl_tin"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumClTin
  | -- | Represents the JSON value @"es_cif"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumEsCif
  | -- | Represents the JSON value @"eu_oss_vat"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumEuOssVat
  | -- | Represents the JSON value @"eu_vat"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumEuVat
  | -- | Represents the JSON value @"gb_vat"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumGbVat
  | -- | Represents the JSON value @"ge_vat"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumGeVat
  | -- | Represents the JSON value @"hk_br"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumHkBr
  | -- | Represents the JSON value @"hu_tin"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumHuTin
  | -- | Represents the JSON value @"id_npwp"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumIdNpwp
  | -- | Represents the JSON value @"il_vat"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumIlVat
  | -- | Represents the JSON value @"in_gst"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumInGst
  | -- | Represents the JSON value @"is_vat"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumIsVat
  | -- | Represents the JSON value @"jp_cn"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumJpCn
  | -- | Represents the JSON value @"jp_rn"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumJpRn
  | -- | Represents the JSON value @"kr_brn"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumKrBrn
  | -- | Represents the JSON value @"li_uid"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumLiUid
  | -- | Represents the JSON value @"mx_rfc"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumMxRfc
  | -- | Represents the JSON value @"my_frp"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumMyFrp
  | -- | Represents the JSON value @"my_itn"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumMyItn
  | -- | Represents the JSON value @"my_sst"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumMySst
  | -- | Represents the JSON value @"no_vat"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumNoVat
  | -- | Represents the JSON value @"nz_gst"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumNzGst
  | -- | Represents the JSON value @"ru_inn"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumRuInn
  | -- | Represents the JSON value @"ru_kpp"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumRuKpp
  | -- | Represents the JSON value @"sa_vat"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumSaVat
  | -- | Represents the JSON value @"sg_gst"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumSgGst
  | -- | Represents the JSON value @"sg_uen"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumSgUen
  | -- | Represents the JSON value @"si_tin"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumSiTin
  | -- | Represents the JSON value @"th_vat"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumThVat
  | -- | Represents the JSON value @"tw_vat"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumTwVat
  | -- | Represents the JSON value @"ua_vat"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumUaVat
  | -- | Represents the JSON value @"us_ein"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumUsEin
  | -- | Represents the JSON value @"za_vat"@
    PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumZaVat
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostOrdersIdRequestBodyTaxDetails'TaxIds'Type' where
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'Other val) = val
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumAeTrn) = "ae_trn"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumAuAbn) = "au_abn"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumAuArn) = "au_arn"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumBgUic) = "bg_uic"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumBrCnpj) = "br_cnpj"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumBrCpf) = "br_cpf"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaBn) = "ca_bn"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaGstHst) = "ca_gst_hst"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaPstBc) = "ca_pst_bc"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaPstMb) = "ca_pst_mb"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaPstSk) = "ca_pst_sk"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaQst) = "ca_qst"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumChVat) = "ch_vat"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumClTin) = "cl_tin"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumEsCif) = "es_cif"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumEuOssVat) = "eu_oss_vat"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumEuVat) = "eu_vat"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumGbVat) = "gb_vat"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumGeVat) = "ge_vat"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumHkBr) = "hk_br"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumHuTin) = "hu_tin"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumIdNpwp) = "id_npwp"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumIlVat) = "il_vat"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumInGst) = "in_gst"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumIsVat) = "is_vat"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumJpCn) = "jp_cn"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumJpRn) = "jp_rn"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumKrBrn) = "kr_brn"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumLiUid) = "li_uid"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumMxRfc) = "mx_rfc"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumMyFrp) = "my_frp"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumMyItn) = "my_itn"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumMySst) = "my_sst"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumNoVat) = "no_vat"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumNzGst) = "nz_gst"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumRuInn) = "ru_inn"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumRuKpp) = "ru_kpp"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumSaVat) = "sa_vat"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumSgGst) = "sg_gst"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumSgUen) = "sg_uen"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumSiTin) = "si_tin"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumThVat) = "th_vat"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumTwVat) = "tw_vat"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumUaVat) = "ua_vat"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumUsEin) = "us_ein"
  toJSON (PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumZaVat) = "za_vat"

instance Data.Aeson.Types.FromJSON.FromJSON PostOrdersIdRequestBodyTaxDetails'TaxIds'Type' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ae_trn" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumAeTrn
            | val GHC.Classes.== "au_abn" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumAuAbn
            | val GHC.Classes.== "au_arn" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumAuArn
            | val GHC.Classes.== "bg_uic" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumBgUic
            | val GHC.Classes.== "br_cnpj" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumBrCnpj
            | val GHC.Classes.== "br_cpf" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumBrCpf
            | val GHC.Classes.== "ca_bn" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaBn
            | val GHC.Classes.== "ca_gst_hst" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaGstHst
            | val GHC.Classes.== "ca_pst_bc" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaPstBc
            | val GHC.Classes.== "ca_pst_mb" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaPstMb
            | val GHC.Classes.== "ca_pst_sk" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaPstSk
            | val GHC.Classes.== "ca_qst" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumCaQst
            | val GHC.Classes.== "ch_vat" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumChVat
            | val GHC.Classes.== "cl_tin" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumClTin
            | val GHC.Classes.== "es_cif" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumEsCif
            | val GHC.Classes.== "eu_oss_vat" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumEuOssVat
            | val GHC.Classes.== "eu_vat" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumEuVat
            | val GHC.Classes.== "gb_vat" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumGbVat
            | val GHC.Classes.== "ge_vat" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumGeVat
            | val GHC.Classes.== "hk_br" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumHkBr
            | val GHC.Classes.== "hu_tin" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumHuTin
            | val GHC.Classes.== "id_npwp" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumIdNpwp
            | val GHC.Classes.== "il_vat" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumIlVat
            | val GHC.Classes.== "in_gst" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumInGst
            | val GHC.Classes.== "is_vat" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumIsVat
            | val GHC.Classes.== "jp_cn" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumJpCn
            | val GHC.Classes.== "jp_rn" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumJpRn
            | val GHC.Classes.== "kr_brn" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumKrBrn
            | val GHC.Classes.== "li_uid" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumLiUid
            | val GHC.Classes.== "mx_rfc" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumMxRfc
            | val GHC.Classes.== "my_frp" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumMyFrp
            | val GHC.Classes.== "my_itn" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumMyItn
            | val GHC.Classes.== "my_sst" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumMySst
            | val GHC.Classes.== "no_vat" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumNoVat
            | val GHC.Classes.== "nz_gst" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumNzGst
            | val GHC.Classes.== "ru_inn" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumRuInn
            | val GHC.Classes.== "ru_kpp" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumRuKpp
            | val GHC.Classes.== "sa_vat" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumSaVat
            | val GHC.Classes.== "sg_gst" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumSgGst
            | val GHC.Classes.== "sg_uen" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumSgUen
            | val GHC.Classes.== "si_tin" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumSiTin
            | val GHC.Classes.== "th_vat" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumThVat
            | val GHC.Classes.== "tw_vat" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumTwVat
            | val GHC.Classes.== "ua_vat" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumUaVat
            | val GHC.Classes.== "us_ein" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumUsEin
            | val GHC.Classes.== "za_vat" -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'EnumZaVat
            | GHC.Base.otherwise -> PostOrdersIdRequestBodyTaxDetails'TaxIds'Type'Other val
      )

-- | Represents a response of the operation 'postOrdersId'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostOrdersIdResponseError' is used.
data PostOrdersIdResponse
  = -- | Means either no matching case available or a parse error
    PostOrdersIdResponseError GHC.Base.String
  | -- | Successful response.
    PostOrdersIdResponse200 Order
  | -- | Error response.
    PostOrdersIdResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
